<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

member::check_admin_page_access('banned') or die('Warning access!');

function banned_index()
{
	global $tpl, $options, $page;
	$page['title'] .= ' &bull; مسدود سازی آی پی';
	$itpl = new template('engine/admin/template/banned.tpl');
	$itpl->assign(array(
		'[not-show-list]' => null,
		'[/not-show-list]' => null,
	));
	$itpl->block('#\\[show-list\\](.*?)\\[/show-list\\]#s', '');
	$tpl->assign('{content}', $itpl->get_var());
	unset($itpl);
}

function banned_list()
{
	global $d;
	$itpl = new template('engine/admin/template/banned.tpl');

	$d->query("SELECT * FROM #__banned ORDER BY ban_id DESC");
	while($data = $d->fetch()) 
	{
		$ip = explode('.', $data['ban_ip']);
		$itpl->add_for('list', array(
			'{odd-even}' => odd_even(),
			'{id}' => $data['ban_id'],
			'{ip}' => $data['ban_ip'],
			'{ip-1}' => $ip[0],
			'{ip-2}' => $ip[1],
			'{ip-3}' => $ip[2],
			'{ip-4}' => $ip[3],
			'{reason}' => strip_tags($data['ban_reason']),
			'{date}' => jdate("l j F Y ساعت h:i A", $data['ban_date']),
		));
	}

	if(isset($itpl->foreach['list']))
	{
		$itpl->assign(array(
			'[list]' => null,
			'[/list]' => null,
		));
		$itpl->block('#\\[not-list\\](.*?)\\[/not-list\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[not-list]' => null,
			'[/not-list]' => null,
		));
		$itpl->block('#\\[list\\](.*?)\\[/list\\]#s', '');
	}

	$itpl->assign(array(
		'[show-list]' => null,
		'[/show-list]' => null,
	));
	$itpl->block('#\\[not-show-list\\](.*?)\\[/not-show-list\\]#s', '');
	$itpl->display();
	define('no_template', true);
}

function banned_new()
{
	global $d;

	$banned = get_param($_POST, 'banned', null, 1);
	if(isset($banned) && is_array($banned) && count($banned))
	{
		$banned['reason'] = filter($banned['reason'], 'preview');
		$banned['ip'][1] = intval($banned['ip'][1]);
		$banned['ip'][2] = intval($banned['ip'][2]);
		$banned['ip'][3] = trim($banned['ip'][3])=='*'? '*' : intval($banned['ip'][3]);
		$banned['ip'][4] = trim($banned['ip'][4])=='*'? '*' : intval($banned['ip'][4]);
	
		if(substr($banned['ip'][2], 0, 2) == 00) $banned['ip'][2] = str_replace('00', null, $banned['ip'][2]);
		if(substr($banned['ip'][3], 0, 2) == 00) $banned['ip'][3] = str_replace('00', null, $banned['ip'][3]);
		if(substr($banned['ip'][4], 0, 2) == 00) $banned['ip'][4] = str_replace('00', null, $banned['ip'][4]);
	
		$ip = $banned['ip'][1].'.'.$banned['ip'][2].'.'.$banned['ip'][3].'.'.$banned['ip'][4];
		$msg = null;

		if(empty($banned['ip'][1]) OR empty($banned['ip'][2]) OR empty($banned['ip'][3]) OR empty($banned['ip'][4]))
		{
			$msg .= 'آدرس IP ازحدود طبيعي خارج است!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(empty($msg) && !is_numeric($banned['ip'][1]) && !empty($banned['ip'][1]) OR !is_numeric($banned['ip'][2]) && !empty($banned['ip'][2]) OR !is_numeric($banned['ip'][3]) && !empty($banned['ip'][3]) && $banned['ip'][3] != '*' OR !is_numeric($banned['ip'][4]) && !empty($banned['ip'][4]) && $banned['ip'][4] != '*')
		{
			$msg .= 'آدرس IP بايد عددي باشد!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(empty($msg) && $banned['ip'][1] > 255 OR $banned['ip'][2] > 255 OR $banned['ip'][3] > 255 && $banned['ip'][3] != '*' OR $banned['ip'][4] > 255 && $banned['ip'][4] != '*')
		{
			$msg .= 'آدرس IP ازحدود طبيعي خارج است!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(empty($msg) && substr($banned['ip'][1], 0, 1) == 0)
		{
			$msg .= 'آدرس IP نميتواند با 0 شروع شود!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(empty($msg) && $ip == '127.0.0.1')
		{
			$msg .= 'شما نميتوانيد Localhost را مسدود كنيد!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(empty($msg) && $ip == get_ip())
		{
			$msg .= 'شما نميتونيد IP خودتان را مسدود كنيد!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(!isset($banned['reason']) || empty($banned['reason']))
		{
			$msg .= 'دلیل مسدود سازی را ننوشته اید!<br>';
		}
		
		if(!empty($msg))
		{
			echo message($msg, 'error');
		}
		else
		{
			$d->insert('banned', array(
				'ban_ip' => $ip,
				'ban_reason' => $banned['reason'],
				'ban_date' => time(),
			));	
			
			if($d->affectedRows())
			{
				$d->update('options', array('option_value'=>time()), "option_name='last-banned'", 1);
				remove_cache('options');
				echo message('آی پی <u dir="ltr">'.$ip.'</u> با موفقیت مسدود شد!', 'success');
				echo '<script>parsnuke.hideID("form-new-banned")</script>';
			}
			else
			{
				echo message('در ذخیره خطایی رخ داده مجدد تلاش کنید!', 'error');
			}
		}
	}
	define('no_template', true);
}

function banned_edit()
{
	global $d;
	$id = get_param($_GET, 'id', 0);

	$d->query("SELECT * FROM #__banned WHERE `ban_id`='$id' LIMIT 1");
	$data = $d->fetch();
	
	if(!is_array($data) || !count($data))
	{
		echo message('این آی پی وجود ندارد!', 'error');
		die;
	}

	$banned = get_param($_POST, 'banned', null, 1);
	if(isset($banned) && is_array($banned) && count($banned))
	{
		$banned['reason'] = filter($banned['reason'], 'preview');
		$banned['ip'][1] = intval($banned['ip'][1]);
		$banned['ip'][2] = intval($banned['ip'][2]);
		$banned['ip'][3] = trim($banned['ip'][3])=='*'? '*' : intval($banned['ip'][3]);
		$banned['ip'][4] = trim($banned['ip'][4])=='*'? '*' : intval($banned['ip'][4]);
	
		if(substr($banned['ip'][2], 0, 2) == 00) $banned['ip'][2] = str_replace('00', null, $banned['ip'][2]);
		if(substr($banned['ip'][3], 0, 2) == 00) $banned['ip'][3] = str_replace('00', null, $banned['ip'][3]);
		if(substr($banned['ip'][4], 0, 2) == 00) $banned['ip'][4] = str_replace('00', null, $banned['ip'][4]);
	
		$ip = $banned['ip'][1].'.'.$banned['ip'][2].'.'.$banned['ip'][3].'.'.$banned['ip'][4];
		$msg = null;

		if(empty($banned['ip'][1]) OR empty($banned['ip'][2]) OR empty($banned['ip'][3]) OR empty($banned['ip'][4]))
		{
			$msg .= 'آدرس IP ازحدود طبيعي خارج است!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(empty($msg) && !is_numeric($banned['ip'][1]) && !empty($banned['ip'][1]) OR !is_numeric($banned['ip'][2]) && !empty($banned['ip'][2]) OR !is_numeric($banned['ip'][3]) && !empty($banned['ip'][3]) && $banned['ip'][3] != '*' OR !is_numeric($banned['ip'][4]) && !empty($banned['ip'][4]) && $banned['ip'][4] != '*')
		{
			$msg .= 'آدرس IP بايد عددي باشد!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(empty($msg) && $banned['ip'][1] > 255 OR $banned['ip'][2] > 255 OR $banned['ip'][3] > 255 && $banned['ip'][3] != '*' OR $banned['ip'][4] > 255 && $banned['ip'][4] != '*')
		{
			$msg .= 'آدرس IP ازحدود طبيعي خارج است!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(empty($msg) && substr($banned['ip'][1], 0, 1) == 0)
		{
			$msg .= 'آدرس IP نميتواند با 0 شروع شود!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(empty($msg) && $ip == '127.0.0.1')
		{
			$msg .= 'شما نميتوانيد Localhost را مسدود كنيد!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(empty($msg) && $ip == get_ip())
		{
			$msg .= 'شما نميتونيد IP خودتان را مسدود كنيد!<br>';
			$msg .= 'آدرس IP وارد شده: <u dir="ltr">'.$ip.'</u><br>';
		}
		if(!isset($banned['reason']) || empty($banned['reason']))
		{
			$msg .= 'دلیل مسدود سازی را ننوشته اید!<br>';
		}

		if(!empty($msg))
		{
			echo message($msg, 'error');
		}
		else
		{
			$d->update('banned', array(
				'ban_ip' => $ip,
				'ban_reason' => $banned['reason'],
				'ban_date' => time(),
			), "`ban_id`='{$id}'", 1);	
			
			if($d->affectedRows())
			{
				$d->update('options', array('option_value'=>time()), "option_name='last-banned'", 1);
				remove_cache('options');
				echo message('آی پی <u dir="ltr">'.$ip.'</u> با موفقیت ویرایش شد!', 'success');
			}
			else
			{
				echo message('در ذخیره خطایی رخ داده مجدد تلاش کنید!', 'error');
			}
		}
	}

	define('no_template', true);
}

function banned_delete()
{
	global $d;
	$id = get_param($_GET, 'id', 0);
	
	$d->delete('banned', "`ban_id`='{$id}'", 1);

	if($d->affectedRows())
	{
		$d->update('options', array('option_value'=>time()), "option_name='last-banned'", 1);
		remove_cache('options');
		echo message('آی پی با موفقیت حذف شد.', 'success');
	}
	else
	{
		echo message('در حذف آی پی خطایی رخ داده مجدد تلاش کنید!', 'error');
	}
	banned_list();
}

$_GET['do'] = get_param($_GET, 'do');
switch($_GET['do'])
{
	case 'list':
	banned_list();
	break;

	case 'new':
	banned_new();
	break;

	case 'edit':
	banned_edit();
	break;

	case 'delete':
	banned_delete();
	break;

	default:
	banned_index();
	break;
}

?>