<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

member::check_admin_page_access('blocks') or die('Warning access!');

function blocks_index()
{
	global $tpl, $options, $page;
	$page['title'] .= ' &bull; بلوک ها';

	$template_info = template_info($options['theme']);
	$template_info = explode(',', $template_info['positions']);

	$positions = array();
	if(count($template_info))
		foreach($template_info as $k => $pos)
			$positions[$pos] = $pos;

	if(isset($positions) && count($positions))
	$position = html::select('block[position]', $positions, null, 'id="block-position" dir=ltr');
	else
	$position = 'تم فعلی سایت شما بلوک ها را پشتیبانی نمی کند!';
	
	if(isset($positions) && count($positions))
	$edit_position = html::select('block[position]', $positions, null, 'id="block-edit-position" dir=ltr');
	else
	$edit_position = 'تم فعلی سایت شما بلوک ها را پشتیبانی نمی کند!';

	$itpl = new template('engine/admin/template/blocks.tpl');
	$itpl->assign('{position}', $position);
	$itpl->assign('{edit-position}', $edit_position);
	$itpl->assign('{textarea}', wysiwyg_textarea('block[content]', null));
	$itpl->assign('{edit-textarea}', wysiwyg_textarea('block[content2]', null));
	$itpl->assign(array(
		'[not-show-list]' => null,
		'[/not-show-list]' => null,
	));
	$itpl->block('#\\[show-list\\](.*?)\\[/show-list\\]#s', '');
	$tpl->assign('{content}', $itpl->get_var());
	unset($itpl);
}

function blocks_list()
{
	global $d;
	$d->query("SELECT * FROM #__blocks ORDER BY block_position,block_ordering,block_id ASC");
	while ($data = $d->fetch()) 
	{
		$blocks[$data['block_position']][] = $data;
	}
	
	$itpl = new template('engine/admin/template/blocks.tpl');

	foreach($blocks as $position=>$data)
	{
		$x = 1;
		if(is_array($data) && count($data))
		foreach($data as $b)
		{
			if(count($data) <= 1)
				$reposit = false;
			else
			{
				$reposit  = $x-1>0? '<a href="javascript:return false" onclick="block_reposit(\'top\', '.$b['block_ordering'].')"><img src="engine/images/icons/navigation-090-button.png" width=16 hight=16 title="بالا"></a>' : null;				
				$reposit .= $x+1<=count($data)? '&nbsp;<a href="javascript:return false" onclick="block_reposit(\'bottom\', '.$b['block_ordering'].')"><img src="engine/images/icons/navigation-270-button.png" width=16 hight=16 title="پایین"></a>' : null;
			}

			// coloration
			if(!empty($b['block_function']) && strpos($b['block_content'], '[- options -]') !== FALSE)
			{
				$con = filter($b['block_content'], 'safe');
				if(substr($con, 0, 13) == '[- options -]')
				{
					$con = trim(substr($con, 13));
					if(strpos($con, '=') !== FALSE)
					{
						$content = null;
						$con = explode("\n", $con);
						foreach($con as $c)
						{
							$c = explode('=', $c);
							if(!isset($c[0]) || !isset($c[1]) || trim($c[0])=='' || trim($c[1])=='') continue;
							$c[0] = trim($c[0]);
							$c[1] = trim($c[1]);
							$content .= '<span style="color:#009933">'.$c[0].'</span> <span style="color:#3366CC">=</span> <span style="color:#9900CC">'.$c[1].'</span>'."\n";
						}
						$con = empty($content)? null : '<span style="color:#CC0000">[- options -]</span>'."\n".trim($content);
					}

					$b['block_content'] = '<div style="text-align:left;direction:ltr;font-weight:bold">'.nl2br($con).'</div>';
				}
				unset($con);
			}

			$itpl->add_for('list', array(
				'{odd-even}' => odd_even(),
				'{id}' => $b['block_id'],
				'{title}' => $b['block_title'],
				'{position}' => $b['block_position'],
				'{active}' => $b['block_active'],
				'{view}' => $b['block_view'],
				'{function}' => filter($b['block_function'], 'en-num'),
				'{content}' => trim($b['block_content']),
				'{reposit}' => $reposit,
				'replace' => array(
					'#\\[reposit\\](.*?)\\[/reposit\\]#s' => $reposit? '\\1' : '',
					'#\\[not-reposit\\](.*?)\\[/not-reposit\\]#s' => !$reposit? '\\1' : '',
					'#\\[status\\](.*?)\\[/status\\]#s' => $b['block_active']==1? '\\1' : '',
					'#\\[not-status\\](.*?)\\[/not-status\\]#s' => $b['block_active']!=1? '\\1' : '',
				)
			));
			$x++;
		}
	}

	if(isset($itpl->foreach['list']))
	{
		$itpl->assign(array(
			'[list]' => null,
			'[/list]' => null,
		));
		$itpl->block('#\\[not-list\\](.*?)\\[/not-list\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[not-list]' => null,
			'[/not-list]' => null,
		));
		$itpl->block('#\\[list\\](.*?)\\[/list\\]#s', '');
	}

	$itpl->assign(array(
		'[show-list]' => null,
		'[/show-list]' => null,
	));
	$itpl->block('#\\[not-show-list\\](.*?)\\[/not-show-list\\]#s', '');

	if(is_ajax())
	{
		define('no_template', true);
		$itpl->display();
	}
	else
	{
		return $itpl->get_var();
	}
}

function blocks_status()
{
	global $d;
	$id = get_param($_GET, 'id', 0);
	$d->query("SELECT `block_active` FROM `#__blocks` WHERE `block_id`='".$id."' LIMIT 1");
	$active = $d->fetch();
	$active = $active['block_active']==0? 1 : 0;
	
	$d->update('blocks', array(
		'block_active' => $active,
	), "`block_id`='{$id}'", 1);

	if($d->affectedRows())
	{
		remove_cache('blocks');
		die($active==1? 'active' : 'inactive');
	}
	else
	{
		die('خطا');
	}
}

function blocks_reposit()
{
	$type = get_param($_GET, 'type');
	$ordering = get_param($_GET, 'ordering', 0);

	$array = array();
	$x = 1;
	global $d;
	$d->query("SELECT `block_id` FROM `#__blocks` WHERE `block_ordering`='".intval($ordering)."' LIMIT 1");
	$id = $d->fetch();
	$id = $id['block_id'];

	if($type=='bottom')
	{
		$d->query("SELECT `block_ordering`,`block_id` FROM `#__blocks` WHERE `block_ordering`>'{$ordering}' ORDER BY `block_ordering` ASC LIMIT 1");
		$data = $d->fetch();

		if(is_array($data) && count($data)):
			$d->update('blocks', array(
				'block_ordering' => intval($ordering),
			), "`block_id`='".intval($data['block_id'])."'", 1);

			$d->update('blocks', array(
				'block_ordering' => intval($data['block_ordering']),
			), "`block_id`='".intval($id)."'", 1);
		endif;
	}
	else
	{
		$d->query("SELECT `block_ordering`,`block_id` FROM `#__blocks` WHERE `block_ordering`<'{$ordering}' ORDER BY `block_ordering` DESC LIMIT 1");
		$data = $d->fetch();

		if(is_array($data) && count($data)):
			$d->update('blocks', array(
				'block_ordering' => intval($ordering),
			), "`block_id`='".intval($data['block_id'])."'", 1);

			$d->update('blocks', array(
				'block_ordering' => intval($data['block_ordering']),
			), "`block_id`='".intval($id)."'", 1);
		endif;
	}	

	if(is_array($data) && count($data))
	{
		$data = null;
		$x = 1;
		$query = $d->query("SELECT `block_id` FROM #__blocks ORDER BY block_position,block_ordering,block_id ASC");
		while($data = $d->fetch($query)) 
		{
			$d->update('blocks', array(
				'block_ordering' => intval($x),
			), "`block_id`='".intval($data['block_id'])."'", 1);	
			$x++;
		}
	}

	remove_cache('blocks');
	blocks_list();		
}

function blocks_new()
{
	global $d;

	$block = get_param($_POST, 'block', null, 2);
	if(isset($block) && is_array($block) && count($block))
	{
		$block['title'] = filter($block['title'], 'nohtml');
		$block['position'] = filter($block['position'], 'en-num');
		$block['active'] = intval($block['active']);
		$block['view'] = intval($block['view']);
		$block['content'] = trim($block['content']);
	
		$msg = null;

		$block['function'] = filter($block['function'], 'en-num');
		if(!empty($block['function']) && !function_exists('block_'.$block['function']))
			$msg .= 'تابع <u>'.$block['function'].'</u> که برای این بلوک انتخاب شده است معتبر نمی باشد!<br>';

		if(!isset($block['title']) || empty($block['title']))
		$msg .= 'عنوان بلوک را ننوشته اید!';
		
		if(!empty($msg))
		{
			echo message($msg, 'error');
		}
		else
		{
			if(!empty($block['function']) && strpos($block['content'], '[- options -]') !== FALSE)
			{
				$block['content'] = trim(filter($block['content'], 'safe'));
				if(substr($block['content'], 0, 13) == '[- options -]')
				{
					$block['content'] = trim(substr($block['content'], 13));
					if(strpos($block['content'], '=') !== FALSE)
					{
						$content = null;
						$block['content'] = explode("\n", $block['content']);
						foreach($block['content'] as $c)
						{
							$c = explode('=', $c);
							if(!isset($c[0]) || !isset($c[1]) || trim($c[0])=='' || trim($c[1])=='') continue;
							$c[0] = trim($c[0]);
							$c[1] = trim($c[1]);
							$content .= $c[0].' = '.$c[1]."\n";
						}
						$block['content'] = empty($content)? null : "[- options -]\n".trim($content);
					}
					else
					{
						$block['content'] = null;
					}
				}
			}

			$d->query("SELECT MAX(block_ordering) as max FROM `#__blocks` WHERE `block_position`='".$block['position']."' LIMIT 1");
			$ordering = $d->fetch();
			$ordering = isset($ordering['max'])? ($ordering['max'] + 1) : 1;

			$d->insert('blocks', array(
				'block_title' => $block['title'],
				'block_content' => $block['content'],
				'block_function' => $block['function'],
				'block_position' => $block['position'],
				'block_active' => $block['active'],
				'block_view' => $block['view'],
				'block_ordering' => $ordering,
			));	
			
			if($d->affectedRows())
			{
				remove_cache('blocks');
				echo message('بلوک با موفقیت ذخیره شد!', 'success');
				echo '<script>parsnuke.hideID("form-new-block")</script>';
			}
			else
			{
				echo message('در ذخیره خطایی رخ داده مجدد تلاش کنید!', 'error');
			}
		}
	}

	define('no_template', true);
}

function blocks_edit()
{
	global $d;
	$id = get_param($_GET, 'id', 0);

	$d->query("SELECT *FROM #__blocks WHERE `block_id`='$id' LIMIT 1");
	$data = $d->fetch();
	
	if(!is_array($data) || !count($data))
	{
		echo message('این بلوک وجود ندارد!', 'error');
		die;
	}

	$block = get_param($_POST, 'block', null, 2);
	if(isset($block) && is_array($block) && count($block))
	{
		$block['title'] = filter($block['title'], 'nohtml');
		$block['position'] = filter($block['position'], 'en-num');
		$block['active'] = intval($block['active']);
		$block['view'] = intval($block['view']);
		$block['content'] = trim($block['content2']);
	
		$msg = null;

		$block['function'] = filter($block['function'], 'en-num');
		if(!empty($block['function']) && !function_exists('block_'.$block['function']))
			$msg .= 'تابع <u>'.$block['function'].'</u> که برای این بلوک انتخاب شده است معتبر نمی باشد!<br>';

		if(!isset($block['title']) || empty($block['title']))
		$msg .= 'عنوان بلوک را ننوشته اید!';
		
		if(!empty($msg))
		{
			echo message($msg, 'error');
		}
		else
		{
			if(!empty($block['function']) && strpos($block['content'], '[- options -]') !== FALSE)
			{
				$block['content'] = trim(filter($block['content'], 'safe'));
				if(substr($block['content'], 0, 13) == '[- options -]')
				{
					$block['content'] = trim(substr($block['content'], 13));
					if(strpos($block['content'], '=') !== FALSE)
					{
						$content = null;
						$block['content'] = explode("\n", $block['content']);
						foreach($block['content'] as $c)
						{
							$c = explode('=', $c);
							if(!isset($c[0]) || !isset($c[1]) || trim($c[0])=='' || trim($c[1])=='') continue;
							$c[0] = trim($c[0]);
							$c[1] = trim($c[1]);
							$content .= $c[0].' = '.$c[1]."\n";
						}
						$block['content'] = empty($content)? null : "[- options -]\n".trim($content);
					}
					else
					{
						$block['content'] = null;
					}
				}
				call_user_func('block_'.$block['function'], 'remove-cache', $id, $block['position']);
			}
		
			$d->update('blocks', array(
				'block_title' => $block['title'],
				'block_content' => $block['content'],
				'block_function' => $block['function'],
				'block_position' => $block['position'],
				'block_active' => $block['active'],
				'block_view' => $block['view'],
			), "`block_id`='{$id}'", 1);	
			
			if($d->affectedRows())
			{
				remove_cache('blocks');
				echo message('بلوک با موفقیت ذخیره شد!', 'success');
			}
			else
			{
				echo message('در ذخیره خطایی رخ داده مجدد تلاش کنید!', 'error');
			}
		}
	}

	define('no_template', true);
}

function blocks_delete()
{
	global $d;
	$id = get_param($_GET, 'id', 0);
	
	$d->delete('blocks', "`block_id`='{$id}'", 1);

	if($d->affectedRows())
	{
		remove_cache('blocks');
		echo message('بلوک با موفقیت حذف شد.', 'success');
	}
	else
	{
		echo message('در حذف بلوک خطایی رخ داده مجدد تلاش کنید!', 'error');
	}
	blocks_list();
}

$_GET['do'] = get_param($_GET, 'do');
switch($_GET['do'])
{
	case 'list':
	blocks_list();
	break;
	
	case 'status':
	blocks_status();
	break;

	case 'reposit':
	blocks_reposit();
	break;

	case 'new':
	blocks_new();
	break;

	case 'edit':
	blocks_edit();
	break;

	case 'delete':
	blocks_delete();
	break;

	default:
	blocks_index();
	break;
}

?>