<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

member::check_admin_page_access('cache') or die('Warning access!');

function cache_index()
{
	global $tpl, $options, $page;
	$page['title'] .= ' &bull; مدیریت کش';
	$itpl = new template('engine/admin/template/cache.tpl');
	
	$handle = opendir(engine_dir.'cache');
	while($file = readdir($handle))
	{
		if(get_extension($file) == 'cache')
		{
			$cachedFile = engine_dir.'cache/'.$file;
			$itpl->add_for('cache', array(
				'{odd-even}' => odd_even(),
				'{name}' => substr($file, 0, -6),
				'{time}' => getPastTime(filemtime($cachedFile)),
				'replace' => array(
					'#\\[expiry\\](.*?)\\[/expiry\\]#s' => filemtime($cachedFile)+caching_life < time()? '\\1' : '',
					'#\\[not-expiry\\](.*?)\\[/not-expiry\\]#s' => filemtime($cachedFile)+caching_life > time()? '\\1' : ''
				)
			));
			$is_cache = true;
		}
	}
	closedir($handle);
	unset($handle, $file);
	
	if(isset($is_cache))
	{
		$itpl->assign(array(
			'[cache]' => null,
			'[/cache]' => null,
		));
		$itpl->block('#\\[not-cache\\](.*?)\\[/not-cache\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[not-cache]' => null,
			'[/not-cache]' => null,
		));
		$itpl->block('#\\[cache\\](.*?)\\[/cache\\]#s', '');
	}
	
	if(caching)
	{
		$itpl->block('#\\[caching\\](.*?)\\[/caching\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[caching]' => null,
			'[/caching]' => null,
		));
	}

	if(is_ajax())
	{
		$itpl->display();
		define('no_template', true);
	}
	else
	{
		set_content(false, $itpl->get_var());
	}
	unset($itpl);
}

function cache_delete()
{
	$name = get_param($_GET, 'name');
	$name = filter($name, 'en-num');
	if(!empty($name))
	{
		remove_cache($name);
		echo message('کش '.$name.' حذف شد!', 'success');
	}
	else
	{
		$handle = opendir(engine_dir.'cache');
		while($file = readdir($handle))
		{
			if(get_extension($file) == 'cache')
			{
				$cachedFile = engine_dir.'cache/'.$file;
				@unlink($cachedFile);
			}
		}
		closedir($handle);
		unset($handle, $file);
		echo message('فایل های کش حذف شدند!', 'success');
	}
	cache_index();
}

$_GET['do'] = get_param($_GET, 'do');
switch($_GET['do'])
{
	case 'delete':
	cache_delete();
	break;

	default:
	cache_index();
	break;
}

?>