<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

member::check_admin_page_access('options') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');

function options_index()
{
	global $options, $page, $d, $modules, $tpl;

	if(!$options['licence'] = get_cache('options-licence', 2592000)) /* 2592000 == 1 Month */
	{
		$options['licence'] = $d->get_row("SELECT * FROM `#__options` WHERE `option_name`='licence'");
		$options['licence'] = $options['licence'][0]['option_value'];
		set_cache('options-licence', $options['licence'], false);
	}

	if(!$options['offline-message'] = get_cache('options-offline-message', 2592000)) /* 2592000 == 1 Month */
	{
		$options['offline-message'] = $d->get_row("SELECT * FROM `#__options` WHERE `option_name`='offline-message'");
		$options['offline-message'] = $options['offline-message'][0]['option_value'];
		set_cache('options-offline-message', $options['offline-message'], false);
	}
	
	if(!$options['comments'] = get_cache('comments-options', 2592000)) /* 2592000 == 1 Month */
	{
		$options['comments'] = $d->get_row("SELECT * FROM `#__options` WHERE `option_name`='comments'");
		$options['comments'] = maybe_unserialize($options['comments'][0]['option_value']);
		set_cache('comments-options', $options['comments']);
	}

	$page['title'] .= ' &bull; تنظیمات سیستم';

	foreach($modules as $mod)
		if(is_module($mod['module_name'])) $m[$mod['module_name']] = $mod['module_name'];

	$t = array();
	$handle = opendir(root_dir.'templates');
	while($file = readdir($handle))
	{
		if(template_exists($file))
		{
			$t[$file] = $file;
		}
	}
	closedir($handle);
	unset($handle, $file);

	$itpl = new template('options.tpl', root_dir.'engine/admin/template/');

	$itpl->assign(array(
		'{default-module}' => html::select('options[default-module]', $m, $options['default-module'], 'dir="ltr"'),
		'{theme}' => html::select('options[theme]', $t, $options['theme'], 'dir="ltr"'),
		'{offline-message}' => wysiwyg_textarea('options[offline-message]', $options['offline-message']),
		'{mail}' => $options['mail'],
		'{feed-limit}' => $options['feed-limit'],
		'{separator-rewrite}' => $options['separator-rewrite'],
		'{file-rewrite}' => $options['file-rewrite'],
		'{keywords}' => str_replace(',', ', ', $options['meta-keys']),
		'{licence}' => wysiwyg_textarea('options[licence]', $options['licence']),
		'{comment-limit}' => $options['comments']['limit'],
	));

	if($options['http-referer']==1)
	{
		$itpl->assign(array(
			'[referer]' => null,
			'[/referer]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[referer\\](.*?)\\[/referer\\]#s', '');
	}
	
	if($options['replace-link']==1)
	{
		$itpl->assign(array(
			'[replace]' => null,
			'[/replace]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[replace\\](.*?)\\[/replace\\]#s', '');
	}
	
	if($options['rewrite']==1)
	{
		$itpl->assign(array(
			'[rewrite-on]' => null,
			'[/rewrite-on]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[rewrite-on\\](.*?)\\[/rewrite-on\\]#s', '');
	}
	
	if($options['comments']['post-guest']==1)
	{
		$itpl->assign(array(
			'[comment-guest]' => null,
			'[/comment-guest]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[comment-guest\\](.*?)\\[/comment-guest\\]#s', '');
	}
	
	if($options['comments']['editor']==1)
	{
		$itpl->assign(array(
			'[comment-editor]' => null,
			'[/comment-editor]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[comment-editor\\](.*?)\\[/comment-editor\\]#s', '');
	}
	
	if($options['comments']['email']==1)
	{
		$itpl->assign(array(
			'[comment-email]' => null,
			'[/comment-email]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[comment-email\\](.*?)\\[/comment-email\\]#s', '');
	}
	
	if($options['comments']['approve']==1)
	{
		$itpl->assign(array(
			'[comment-approve]' => null,
			'[/comment-approve]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[comment-approve\\](.*?)\\[/comment-approve\\]#s', '');
	}
	
	if($options['offline']==1)
	{
		$itpl->assign(array(
			'[offline-on]' => null,
			'[/offline-on]' => null,
		));
		$itpl->block('#\\[offline-off\\](.*?)\\[/offline-off\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[offline-off]' => null,
			'[/offline-off]' => null,
		));
		$itpl->block('#\\[offline-on\\](.*?)\\[/offline-on\\]#s', '');
	}
	
	$tpl->assign('{content}', $itpl->get_var());
}

function options_save()
{
	global $d, $options;
	$msg = null;
	$save = 0;
	$op = get_param($_POST, 'options', null, 1);
	
	if(is_array($op) && count($op))
	{
		$op['admin'] = trim(filter($op['admin'], 'safe'));
		$op['admin'] = str_replace(array('!','#','$','%','^','*','÷','(',')','{','}','=','|','¦','/','\\','~','≈','`','´','\'','"','&','?','؟','>','<','»','«','⇔','⇒','→','×',',','،','¸','…','‌','“','”','„','‛','¤','♦','•','►','—','–','¯','¨','º','·','€','©','®','¢','£','¶','™'),'',$op['admin']);
		$op['default-module'] = filter($op['default-module'], 'en-num');
		$op['theme'] = filter($op['theme'], 'en-num');
		$op['title'] = filter($op['title'], 'preview');
		$op['slogan'] = filter($op['slogan'], 'preview');
		$op['mail'] = strtolower(filter($op['mail'], 'safe'));
		$op['feed-limit'] = intval($op['feed-limit'])<=0? 1 : intval($op['feed-limit']);
		$op['http-referer'] = !isset($op['http-referer']) || intval($op['http-referer'])<=0? 0 : 1;
		$op['replace-link'] = !isset($op['replace-link']) || intval($op['replace-link'])<=0? 0 : 1;
		$op['rewrite'] = !isset($op['rewrite']) || intval($op['rewrite'])<=0? 0 : 1;
		$op['separator-rewrite'] = filter($op['separator-rewrite'], 'safe');
		$op['file-rewrite'] = filter($op['file-rewrite'], 'safe');
		$op['meta-desc'] = filter($op['meta-desc'], 'safe');
		$op['meta-keys'] = filter($op['meta-keys'], 'safe');
		$op['meta-keys'] = str_replace(array('،', '  ', ' , ', ', ', ' ,'), array(',', ' ', ',', ',', ','), $op['meta-keys']);

		$op['comments']['limit'] = intval($op['comments']['limit'])<=100? 100 : intval($op['comments']['limit']);
		$op['comments']['post-guest'] = !isset($op['comments']['post-guest']) || intval($op['comments']['post-guest'])<=0? 0 : 1;
		$op['comments']['editor'] = !isset($op['comments']['editor']) || intval($op['comments']['editor'])<=0? 0 : 1;
		$op['comments']['email'] = !isset($op['comments']['email']) || intval($op['comments']['email'])<=0? 0 : 1;
		$op['comments']['approve'] = !isset($op['comments']['approve']) || intval($op['comments']['approve'])<=0? 0 : 1;
		$op['comments'] = serialize($op['comments']);

		$op['offline-message'] = $op['offline-message'];
		$op['offline'] = !isset($op['offline']) || intval($op['offline'])<=0? 0 : 1;
		$op['licence'] = $op['licence'];

		if(is_dir(root_dir.'modules/'.$op['admin']))
			$msg .= 'نام انتخابی شما برای کلید بخش مدیریت معتبر نیست!';

		if(!is_module($op['default-module']))
			$msg .= 'ماژول انتخاب شده برای پبشفرض معتبر نیست!';

		if(!template_exists($op['theme']))
			$msg .= 'تم انتخاب شده برای پبشفرض معتبر نیست!';
		
		if(!validate_email_format($op['mail']))
			$msg .= 'ایمل وارد شده برای سایت معتبر نیست!';
		
		if(empty($op['separator-rewrite']))
			$msg .= 'جداکننده لینکهای سئو نباید خالی باشد!';
		
		if(!empty($msg))
		{
			echo message($msg, 'error');
		}
		else
		{
			foreach($op as $name => $value)
			{
				$d->update('options', array('option_value'=>trim($value)), "option_name='".$d->escapeString($name)."'", 1);
				if($d->affectedRows())
				{
					$save++;
					switch($name)
					{
						case 'offline-message':
						remove_cache('options-offline-message');
						break;
						
						case 'licence':
						remove_cache('options-licence');
						break;

						case 'comments':
						remove_cache('comments-options');
						break;
						
						case 'rewrite':
						case 'separator-rewrite':
						case 'file-rewrite':
						remove_cache('sitemap');
						break;
					}
				}
			}
			
			if($save)
			{
				if($op['admin'] != $options['admin'])
				{
					refresh('?a='.$op['admin'].'&b=options', 5);
					echo message('کلید بخش مدیریت تغییر کرده، لطفا صبر کنید تا چند لحظه دیگر صفحه مجدد بارگذاری خواهد شد.<br>کلید جدید: <u dir=ltr>'.$op['admin'].'</u>', 'info');
				}
				echo message('تنظیمات با موفقیت ذخیره شد!', 'success');
				remove_cache('options');
			}
			else
			{
				echo message('در ذخیره تنظیمات خطایی رخ داده مجدد تلاش کنید!', 'error');
			}
		}
	}

	//dump($op);
	die;
}

$_GET['do'] = get_param($_GET, 'do');
if($_GET['do']=='save')
	options_save();
else
	options_index();

?>