<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

member::check_admin_page_access('robots') or die('Warning access!');

function robots_index()
{
	global $tpl, $options, $page, $d;
	require_once(engine_dir.'pagination.class.php');
	$page['title'] .= ' &bull; مديريت ربات ها';

	if(!file_exists(root_dir.'robots.txt'))
	{
		@file_put_contents(root_dir.'robots.txt', robots_default());
	}
	
	$itpl = new template('engine/admin/template/robots.tpl');

	$itpl->assign(array(
		'{robots}' => @file_get_contents(root_dir.'robots.txt'),
		'{time}' => jdate('l j F Y ساعت h:i A', filemtime(root_dir.'robots.txt')),
	));
	
	if(is_writable(root_dir.'robots.txt'))
	{
		$itpl->block('#\\[not-writable\\](.*?)\\[/not-writable\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[not-writable]' => null,
			'[/not-writable]' => null,
		));
	}
	
	set_content(FALSE, $itpl->get_var());
	unset($itpl);
}

function robots_edit()
{
	$robots = get_param($_POST, 'robots');
	if(isset($_GET['reset']))
	{
		$robots = robots_default();
	}
	if(!empty($robots))
	{
		if(is_writable(root_dir.'robots.txt'))
		{
			if(file_put_contents(root_dir.'robots.txt', stripslashes($robots)))
			{
				echo message('فایل با موفقیت ویرایش شد!', 'success');
				echo message('آخرین ویرایش در '.jdate('l j F Y ساعت h:i A', filemtime(root_dir.'robots.txt')).' بوده است.', 'info');
				if(isset($_GET['reset']))
				{
					$robots = trim($robots);
					$robots = str_replace(array("\n", "\r\n"), '\n', $robots);
					echo '<script>parsnuke.value("robots-textarea", "'.addcslashes($robots, '"').'")</script>';
				}
			}
			else
			{
				echo message('در ویرایش فایل خطایی رخ داده!', 'error');
			}
		}
		else
		{
			echo message('فایل robots.txt در روت سایت قابل نوشتن نیست.', 'error');
		}
	}
	else
	{
		echo message('محتوای فایل را وارد نکرده اید!', 'error');
	}
	define('no_template', true);
}

function robots_default()
{
	$robots_content  = 'User-agent: Mediapartners-Google*'."\r\n";
	$robots_content .= 'Disallow:'."\r\n";
	$robots_content .= 'User-agent: *'."\r\n";
	$robots_content .= 'Disallow: /engine/'."\r\n";
	$robots_content .= 'Disallow: /modules/'."\r\n";
	$robots_content .= 'Disallow: /templates/'."\r\n";
	$robots_content .= 'Disallow: /uploads/'."\r\n";
	$robots_content .= 'Sitemap: '.url.'sitemap.xml';
	return $robots_content;
}

$_GET['do'] = get_param($_GET, 'do');
switch($_GET['do'])
{
	case 'edit':
	robots_edit();
	break;

	default:
	robots_index();
	break;
}

?>