<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
**/

defined('security') or die('Direct Access to this location is not allowed.');

class comments 
{
    public $type;
    public $link;
    public $action;
    public $options;
    public $comments;
    public $comments_count;
    public $message;

    public function __construct($type, $link, $action)
	{
		$this->type = filter($type, 'en-num');
		$this->link = intval($link);
		$this->action = $action;
	}

	public function options()
	{
		if(!$this->options = get_cache('comments-options', 2592000))
		{
			global $d;
			$d->query("SELECT `option_value` FROM `#__options` WHERE `option_name`='comments' LIMIT 1");
			$result = $d->fetch();
			$d->freeResult();
			$this->options = maybe_unserialize($result['option_value']);
			set_cache('comments-options', $this->options);
		}
		return $this->options;
	}

    public function query()
	{
		global $d;
		$query = "
			SELECT c.*,m.member_avatar,m.member_group,m.member_name
			FROM #__comments AS c
			LEFT JOIN #__members AS m ON (m.member_id = c.comment_member_id)
			WHERE c.comment_type='".$this->type."' AND c.comment_link='".$this->link."'".($this->options['approve']==1? " AND (c.comment_approve='1'".(member==1? " OR c.comment_member_id='".member_id."'" : " OR c.comment_author_ip='".get_ip()."'").")" : null)."
			GROUP BY c.comment_id
			ORDER BY c.comment_id ASC
		";

		$this->comments = $d->get_row($query);
		$this->comments_count = count($this->comments);
		unset($query);
	}

    public function build($function = null)
	{
		global $member, $options, $tpl;
		$this->options();
	
		if(member == 1)
			$member = member::is('info');
		
		// save a new comment
		$com = get_param($_POST, 'comment');
		if(is_array($com) && count($com))
		{
			$this->post($com, $function);
		}
		unset($com);

		$this->query();
		
		require_once(engine_dir.'bbcode.class.php');
		$bbcode = new bbcode();
		$comments = array();
		$form = array();

		$itpl = new template('comments.tpl', root_dir.'templates/'.$options['theme'].'/');

		if(is_array($this->comments) && count($this->comments))
		foreach($this->comments as $com)
		{
			$array = array(
				'{odd-even}' => odd_even(),
				'{member-id}' => $com['comment_member_id'],
				'{member-avatar}' => member::avatar($com['member_avatar']),
				'{member-group}' => $com['member_group'],
				'{member-name}' => $com['member_name'],
				'{id}' => $com['comment_id'],
				'{author}' => $com['comment_author'],
				'{author-email}' => $com['comment_author_email'],
				'{author-url}' => $com['comment_author_url'],
				'{author-ip}' => $com['comment_author_ip'],
				'{date}' => jdate('l j F Y ساعت h:i A', $com['comment_date']),
				'{past-time}' => getPastTime($com['comment_date']),
				'{text}' => '<a name="comment-'.$com['comment_id'].'"></a>'.nl2br($bbcode->parse($com['comment_text'])),
				'{answer-author}' => $com['comment_answer_author'],
				'{answer}' => empty($com['comment_answer'])? null : nl2br($bbcode->parse($com['comment_answer'])),
				'{language}' => $com['comment_language'],
			);

			if(!empty($com['comment_answer']))
			{
				$array['[answer]'] = null;
				$array['[/answer]'] = null;
			}
			else
			{
				$array['replace']['#\\[answer\\](.*?)\\[/answer\\]#s'] = '';
			}
			
			if($this->options['approve']==0 || $com['comment_approve']==1)
			{
				$array['[approve]'] = null;
				$array['[/approve]'] = null;
				$array['replace']['#\\[not-approve\\](.*?)\\[/not-approve\\]#s'] = '';
			}
			else
			{
				$array['[not-approve]'] = null;
				$array['[/not-approve]'] = null;
				$array['replace']['#\\[approve\\](.*?)\\[/approve\\]#s'] = '';
			}
			
			$array['replace']['|{date format=[\'"](.+?)[\'"]}|es'] = 'jdate("\\1", "'.$com['comment_date'].'")';
			$itpl->add_for('comments', $array);
		}

		$itpl->assign(array(
			'{message}' => empty($this->message)? null : message($this->message, 'error'),
			'{action}' => $this->action,
			'{name}' => member? (!empty($member['member_alias'])? $member['member_alias'] : member_name) : null,
			'{email}' => isset($member['member_email']) && !empty($member['member_email'])? $member['member_email'] : null,
			'{url}' => isset($member['member_web']) && !empty($member['member_web'])? $member['member_web'] : 'http://',
			'{comments-count}' => $this->comments_count,
			'{link}' => $this->link,
			'{wysiwyg-textarea}' => $this->options['editor']==1? wysiwyg_textarea('comment[text]', null, 'BBcode') : '<textarea name="comment[text]" id="comment-text" cols="45" rows="5"></textarea>',
			'{captcha}' => create_captcha('comment')
		));
		
		if(!empty($this->message))
		{
			$itpl->assign(array(
				'[message]' => null,
				'[/message]' => null,
			));
		}
		else
		{
			$itpl->block('#\\[message\\](.*?)\\[/message\\]#s', '');
		}

		if($this->options['post-guest']==1 || member==1)
		{
			$itpl->assign(array(
				'[post]' => null,
				'[/post]' => null,
			));
			$itpl->block('#\\[not-post\\](.*?)\\[/not-post\\]#s', '');
		}
		else
		{
			$itpl->assign(array(
				'{message}' => message('فقط کاربران عضو می توانند نظر ارسال کنند!', 'error'),
				'[not-post]' => null,
				'[/not-post]' => null,
			));
			$itpl->block('#\\[post\\](.*?)\\[/post\\]#s', '');
		}
		
		if($this->options['editor']==1)
		{
			$itpl->assign(array(
				'[editor]' => null,
				'[/editor]' => null,
			));
			$itpl->block('#\\[not-editor\\](.*?)\\[/not-editor\\]#s', '');
		}
		else
		{
			$itpl->assign(array(
				'[not-editor]' => null,
				'[/not-editor]' => null,
			));
			$itpl->block('#\\[editor\\](.*?)\\[/editor\\]#s', '');
		}

		$tpl->assign('{content}', $itpl->get_var(), 'add');
		unset($bbcode, $comments, $form, $com, $post_name, $itpl);
	}

    public function post($post, $function)
	{
		$message = null;
		$post['name'] = filter($post['name'], 'preview');
		$post['text'] = filter($post['text'], 'preview');
		$post['email'] = filter($post['email'], 'safe');
		$post['url'] = filter($post['url'], 'safe');
		
		if(empty($this->type) || !is_numeric($this->link) || $this->link<=0)
			$message .= "اطلاعات شناسایی نظر معتبر نمی باشد!<br>";

		if($this->options['post-guest']==0 && member==0)
			$message .= "كاربران غير عضو اجازه ارسال نظر را ندارند<br>";

		if(!validate_captcha('comment', @$post['captcha']))
			$message .= 'کد امنیتی را صحیح وارد نکرده اید!<br />';

		if(empty($post['name']))
			$message .= "نام خود را وارد نكرده ايد!<br>";

		if($this->options['email']==1)
			if(empty($post['email']) || !validate_email_format($post['email']))
				$message .= "ايميل وارد شده صحيح نيست!<br>";

		if(empty($post['text']))
			$message .= "متن نظر خود را ننوشته ايد!<br>";
		else
		{
			$text = filter($post['text'], 'safe');
			if(strlen($text) < 5)
				$message .= "نظر شما خيلي كوتاه است حداقل بايد 5 حرف باشد!<br>";
			elseif(strlen($text) > $this->options['limit'])
				$message .= "نظر شما ".strlen($text)." حرف است، حداكثر تعداد حروف مجاز ".$this->options['limit']." حرف می باشد!<br>";
		}

		if(function_exists($function))
			$message .= $function('check', $post);

		if(!empty($message))
		{
			$this->message = $message;
		}
		else
		{
			global $d;
			
			if(!validate_email_format($post['email']))
				$post['email'] = null;

			if(!validate_url($post['url']))
				$post['url'] = null;

			$arr = array(
				'comment_type' => $this->type,
				'comment_link' => intval($this->link),
				'comment_author' => $post['name'],
				'comment_author_email' => $post['email'],
				'comment_author_url' => $post['url'],
				'comment_author_ip' => get_ip(),
				'comment_date' => time(),
				'comment_text' => $post['text'],
				'comment_member_id' => member_id,
				'comment_approve' => !group_admin? 0 : 1,
			);

			$d->insert('comments', $arr);
			if ($d->affectedRows())
			{
				if(function_exists($function))
					$function('success', $arr);

				un_set_cookie('security_code_comment');
				remove_cache('module-posts-comments-block-', true);
			}
			else
			{
				$this->message = 'در ذخیره نظر خطایی رخ داده مجدد تلاش کنید!';
			}
		}
		unset($text, $message, $post, $arr);
	}
}

?>