<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function get_param(&$arr, $name, $def = null, $mask = 0)
{
	if (isset( $arr[$name] )) 
	{
		if (is_array($arr[$name])) 
			foreach($arr[$name] as $key=>$element) 
				get_param($arr[$name], $key, $def, $mask);
		else 
		{
			$arr[$name] = trim( $arr[$name] );
			if (!is_numeric( $arr[$name] )) 
			{
				if (!$mask)
				{
				    $arr[$name] = strip_tags( $arr[$name] );

					if (is_numeric($def)) 
					    $arr[$name] = intval($arr[$name]);
				}
				global $d;
				$arr[$name] = isset($d) && is_object($d)? $d->escapeString($arr[$name]) : pn_addslashes($arr[$name]);
			}
		}
		return $arr[$name];
	} 
	else 
	{
		return $def;
	}
}

function pn_addslashes($string)
{
	if(is_array($string))
	{
		$string = array_map('pn_addslashes', $string);
	}
	else
	{
		$string = str_replace(array('*#pn-nline#*', '*#pn-rnline#*', "\r\n", "\n"), array('', '', '*#pn-rnline#*', '*#pn-nline#*'), $string);
		if(get_magic_quotes_gpc())
		{
			$string = stripslashes($string);
		}
		$string = addslashes($string);
		$string = str_replace(array('*#pn-nline#*', '*#pn-rnline#*'), array("\n", "\r\n"), $string);
	}
	return $string;		
}

function mod_rewrite()
{
	global $options;
	$alphabet = array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z');
	$mod_rewrite = get_param($_GET, 'mod_rewrite');
	$mod_rewrite = filter($mod_rewrite, 'safe');
	if(!empty($mod_rewrite) && $options['rewrite']==1)
	{
		$options['file-rewrite'] = $options['file-rewrite']=='/'? null : $options['file-rewrite'];
		$strlen = strlen($options['file-rewrite']);
		$mod_rewrite = trim($mod_rewrite, '/');
		if(!empty($options['file-rewrite']) && substr($mod_rewrite, -$strlen) != $options['file-rewrite'])
		{
			define('mod_rewrite', 'error');
		}
		else
		{
			$strlen = strlen($mod_rewrite)-intval($strlen);
			$mod_rewrite = substr($mod_rewrite, 0, $strlen);
			$mod_rewrite = trim($mod_rewrite, $options['separator-rewrite']);
			$mod_rewrite = explode($options['separator-rewrite'], $mod_rewrite);
			if(count($mod_rewrite))
			{
				for($i=0; $i<=count($mod_rewrite)-1; $i++)
				{
					if(empty($mod_rewrite[$i]) || $i>25) continue;
					$_GET[$alphabet[$i]] = urldecode($mod_rewrite[$i]);
				}
			}
			define('mod_rewrite', 1);
		}
	}
	else
	{
		define('mod_rewrite', 0);
	}
}

function url($url, $rewrite = false)
{
	global $options;
	if($rewrite)
	{
		return($options['rewrite']==1? $url : null);
	}
	$alphabet = array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z');
	$url = filter($url, 'safe');
	$return = null;
	if(!empty($url))
	{
		$url = trim($url, '/');
		$url = explode('/', $url);
		if(count($url))
		{
			for($i=0; $i<=count($url)-1; $i++)
			{
				if(empty($url[$i]) || $i>25) continue;
				$return .= $options['rewrite']==1? $options['separator-rewrite'].$url[$i] : '&amp;'.$alphabet[$i].'='.$url[$i];
			}
		}
		$return = substr($return, $options['rewrite']==1? strlen($options['separator-rewrite']) : 5);
		return($options['rewrite']==1? $return.($options['file-rewrite']==''? '/' : $options['file-rewrite']) : '?'.$return);
	}
	return false;
}

function replace_links($text)
{
    global $options;
	
	if(isset($options) && $options['replace-link']==1 && member==0)
		return preg_replace('#<a(.*?)href=["\'](.*?)["\'](.*?)>(.*?)</a>#i', '<a\\1href="javascript:alert(\'فقط کاربران عضو به این لینک دسترسی دارند!\')"\\3 rel="nofollow">\\4</a><!-- ParsNuke.com -->', $text);
	else
		return $text;
}

function memoryGetUsage()
{
	if(function_exists('memory_get_usage'))
    {
	    $memory_size = memory_get_usage(); // 36640
		$unit = array('بایت', 'کیلوبایت', 'مگابایت', 'گیگابایت');
		return @round($memory_size/pow(1024,($i=floor(log($memory_size,1024)))),2).' '.$unit[$i];
	}
	return false;
}

function is_cache()
{
    $path = engine_dir.'cache/';

	if(!is_dir($path))
	{
		@mkdir($path, 0777);
		pn_chmod($path, 0777);
	}

	if(caching===true && is_dir($path) && is_readable($path) && is_writable($path)) 
		return true;
	else
		return false;
}

function set_cache($name, $content, $serialize = true)
{
	if(!is_cache()) 
		return false;

	$name = filter($name, 'en-num');
	$cachedFile = engine_dir.'cache/'.$name.'.cache';

	if(file_put_contents($cachedFile, $serialize? serialize($content) : $content))
	{
		@pn_chmod($cachedFile, 0666);
		return true;
	}
	else
        return false;
}

function get_cache($name, $cacheLife = false)
{
	if(!is_cache()) 
		return false;

	$name = filter($name, 'en-num');
	$cachedFile = engine_dir.'cache/'.$name.'.cache';

	if(file_exists($cachedFile) && is_readable($cachedFile))
	{
		$cacheLife = !$cacheLife? intval(caching_life) : intval($cacheLife);
		$cacheLife = $cacheLife<=0? 7200 : $cacheLife;
		$cacheFileLife = filemtime($cachedFile);
		if($cacheFileLife+$cacheLife > time())
		{
			return maybe_unserialize(file_get_contents($cachedFile));
		};
		remove_cache($name);
	};
	return false;
}

function remove_cache($name, $strpos = false)
{
	if(!is_cache()) 
		return false;

	$name = filter($name, 'en-num');
	if($strpos)
	{
		$cachedFile = engine_dir.'cache/';
		$dir = opendir($cachedFile);
		if($dir && !empty($name))
		{
			while($file = @readdir($dir))
			{
				if(strpos($file, $name) !== FALSE && file_exists($cachedFile.$file) && is_writable($cachedFile.$file) && get_extension($file)=='cache')
				{
					unlink($cachedFile.$file);
					$unlink = true;
				}
			}
			@closedir($dir);
		}
		if(isset($unlink)) return true;
	}
	else
	{
		$cachedFile = engine_dir.'cache/'.$name.'.cache';
		if(file_exists($cachedFile) && is_writable($cachedFile))
		{
			return unlink($cachedFile);
		};
	}
	return false;
}

function current_url()
{
    if(!isset($_SERVER['REQUEST_URI']))
        $serverrequri = $_SERVER['PHP_SELF'];
    else
        $serverrequri = $_SERVER['REQUEST_URI'];
	
    $s = empty($_SERVER['HTTPS']) ? '' : ($_SERVER['HTTPS'] == 'on') ? 's' : '';
    $protocol = substr(strtolower($_SERVER['SERVER_PROTOCOL']), 0, strpos(strtolower($_SERVER['SERVER_PROTOCOL']), '/')).$s;
    $port = ($_SERVER['SERVER_PORT'] == '80') ? '' : (':'.$_SERVER['SERVER_PORT']);
	
    return $protocol.'://'.$_SERVER['SERVER_NAME'].$port.$serverrequri;   
}

function my_path()
{
    $url = url;   
    $url = str_ireplace(array('http://', 'https://'), null, $url); 
	if(substr($url, 0, 4) == 'www.')
	{
		$url = substr($url, 0, 4);
	}
    $url = trim($url, '/');
    $url = substr($url, strlen(domain));
	return $url.'/';
}

function set_cookie($name, $value, $expires='-')
{
	if ($expires=='-')
    {
		$expires = time() + 60*60*30;
	}
	elseif ($expires)
    {
		$expires = (int) $expires;
	}
    else
    {
		$expires = FALSE; // At n of session
	}
	$cookieDomain = domain=='localhost'? false : domain;
	if (PHP_VERSION < 5.2)
    {
		setcookie($name, $value, $expires, my_path(), $cookieDomain . "; HttpOnly");
	}
    else
    {
		setcookie($name, $value, $expires, my_path(), $cookieDomain, NULL, TRUE);
	}
}

function un_set_cookie($cookieName)
{
    set_cookie($cookieName, NULL, -1);
}

function copyright()
{
    return 'Powered by <a href="http://parsnuke.com" target="_blank" rel="copyright">Pars Nuke</a> copyright © '.date('Y').' by Iman Moodi.';
}

function filter($text, $type = 'preview', $space = FALSE)
{
	if(is_array($text))
	{
		foreach($text as $k => $v)
			$text[$k] = filter($v, $type, $space);
	}
	else
	{
		$text = @trim($text);

		if(empty($text))
			return $text;

		switch($type)
		{
			case'en':
			$pattern = 'A-Za-z-_';
			break;

			case'en-num':
			$pattern = 'A-Za-z-0-9-_';
			break;

			case'safe':
			case'nohtml':
			if($type=='safe')
			$text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
			$text = strip_tags($text);
			return @trim($text);
			break;

			case'htmldecode':
			return html_entity_decode($text, ENT_QUOTES, 'UTF-8');
			break;

			default:
			case'preview':
			$text = htmlentities($text, ENT_QUOTES, 'UTF-8');
			$text = str_replace(array('<','>','\'','"','&amp;'), array('&lt;','&gt;','&apos;','&quot;','&'), $text);
			return $text;
			break;
		}
		if($space) $pattern = $pattern.' ';
		$text = preg_replace('([^'.$pattern.']*)', null, $text);
	}
	return $text;
}

function preg_check($expression, $value)
{
	if(is_string($value))
	{
		return preg_match($expression, $value);
	}
	else
	{
		return false;
	}
}

function redirect($url, $siteurl = true)
{
    if(substr($url, 0, 7) != 'http://' && substr($url, 0, 8) != 'https://' && $siteurl) 
	{
        $url = url . $url;
    }
	$url = str_replace('&amp;', '&', $url);
	// First check if the current HTTP-Request is an Ajax-Request
	if(is_ajax())
	{
	   	die('<script type="text/javascript">document.location.href="'.$url.'";</script>');
	}
	Header("Location: ".$url."");
    die("Link Redirect:<br /><br />Please click <a href=\"{$url}\">here.</a>");
}

function refresh($url, $time = 3, $siteurl = true)
{
    if(substr($url, 0, 7) != 'http://' && substr($url, 0, 8) != 'https://' && $siteurl) 
	{
        $url = url . $url;
    }
	$url = str_replace('&amp;', '&', $url);
	// First check if the current HTTP-Request is an Ajax-Request
	if(is_ajax())
	{
	   	echo('<script type="text/javascript">setTimeout(\'document.location.href="'.$url.'"\', '.intval($time).'000)</script>');
	}
	Header("Refresh: ".intval($time)."; url=".$url."");
}

function smiles_replace($text)
{
	$replace = array(
		':)' => ':s-2:',
		'(:' => ':s-2:',
		':(' => ':s-3:',
		'):' => ':s-3:',
		';)' => ':s-4:',
	);
	$text = str_replace(array_keys($replace), array_values($replace), $text);
	
	for($o=1; $o<=75; $o++)
		$text = str_replace(':s-'.$o.':', '<img src="'.url.'engine/images/smiles/'.$o.'.gif" class="parsnuke-smiles" />', $text);
	unset($o, $replace);
	return $text;
}

function maybe_unserialize( $original )
{
	if ( is_serialized( $original ) ) // don't attempt to unserialize data that wasn't serialized going in
		return @unserialize( $original );
	return $original;
}

function is_serialized( $data )
{
	// if it isn't a string, it isn't serialized
	if ( !is_string( $data ) )
		return false;
	$data = trim( $data );
	if ( 'N;' == $data )
		return true;
	if ( !preg_match( '/^([adObis]):/', $data, $badions ) )
		return false;
	switch ( $badions[1] ) {
		case 'a' :
		case 'O' :
		case 's' :
			if ( preg_match( "/^{$badions[1]}:[0-9]+:.*[;}]\$/s", $data ) )
				return true;
			break;
		case 'b' :
		case 'i' :
		case 'd' :
			if ( preg_match( "/^{$badions[1]}:[0-9.E-]+;\$/", $data ) )
				return true;
			break;
	}
	return false;
}

function get_extension($file)
{
	return strtolower(substr(strrchr($file, '.'), 1));
}

function validate_email_format($email)
{
    if (phpversion() >= '5.2.0')
    {
        return filter_var($email, FILTER_VALIDATE_EMAIL);
    }
    else
    {
		if(strpos($email, ' ') !== false)
		{
			return false;
		}
		// Valid local characters for email addresses: http://www.remote.org/jochen/mail/info/chars.html
		return preg_match("/^[a-zA-Z0-9&*+\-_.{}~^\?=\/]+@[a-zA-Z0-9-]+\.([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]{2,}$/si", $email);
    }
}

function validate_url($url)
{
    if (phpversion() >= '5.2.0')
    {
        return filter_var($url, FILTER_VALIDATE_URL);
    }
    else
    {
        return preg_match('/^(http(s?)://|ftp://{1})((w+.){1,})w{2,}$/i', $url);
    }
}

function generate_password($count = 8, $add = '!@#%^&*()_+=-:;?~{}|÷.,')
{
	mt_srand(microtime()*1000000);
	$words = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'.$add;
	$return = '';
	for ($i=0; $i<$count; $i++) $return .= $words[mt_rand(0, strlen($words)-1)];
	return $return;
}

function is_ajax()
{
	return (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest');
}

function is_rtl()
{
	return (defined('rtl') && rtl===true);
}

function pn_chmod($file, $mode)
{
	// Passing $mode as an octal number causes strlen and substr to return incorrect values. Instead pass as a string
	if(substr($mode, 0, 1) != '0' || strlen($mode) !== 4)
	{
		return false;
	}
	$old_umask = umask(0);

	// We convert the octal string to a decimal number because passing a octal string doesn't work with chmod
	// and type casting subsequently removes the prepned 0 which is needed for octal numbers
	$result = chmod($file, octdec($mode));
	umask($old_umask);
	return $result;
}

function odd_even($even='parsnuke-even', $odd='parsnuke-odd')
{
    static $save;
    $save = (!$save || $save==$odd? $even : $odd);
    return $save;
}

function check_xss()
{
	$url = html_entity_decode( urldecode($_SERVER['QUERY_STRING']) );
	$url = str_replace('\\', '/', $url);

	if($url)
	{
		if( (strpos( $url, '<' ) !== false) || (strpos( $url, '>' ) !== false) || (strpos( $url, '"' ) !== false) || (strpos( $url, './' ) !== false) || (strpos( $url, '../' ) !== false) || (strpos( $url, '\'' ) !== false) || (strpos( $url, '.php' ) !== false) )
		{
			die('Hacking attempt!');
		}
	}
	$url = html_entity_decode( urldecode($_SERVER['REQUEST_URI']) );
	$url = str_replace('\\', '/', $url);

	if($url)
	{
		if( (strpos( $url, '<' ) !== false) || (strpos( $url, '>' ) !== false) || (strpos( $url, '"' ) !== false) || (strpos( $url, '\'' ) !== false) )
		{
			die('Hacking attempt!');
		}
	}
}

function get_ip()
{
	if (!empty($_SERVER['HTTP_CLIENT_IP'])) //check ip from share internet
	{
		$ip = $_SERVER['HTTP_CLIENT_IP'];
	}
	elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) //to check ip is pass from proxy
	{
		$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else
	{
		$ip = $_SERVER['REMOTE_ADDR'];
	}
	return filter($ip, 'safe');
}

function clean_text($text, $urlencode = false)
{
	$text = filter($text, 'safe');
	$text = str_replace(array('!','@','#','$','%','^','*','÷','(',')','{','}','_','--','=','+','++','|','¦','/','\\','~','≈','`','´','\'','"','&','?','؟','>','<','»','«','⇔','⇒','→','×','.',',','،','¸','…','‌',' ','“','”','„','‛','¤','♦','•','►','—','–','¯','¨','º','·','€','©','®','¢','£','¶','™'),'-',$text);
	$text = preg_replace('#-{2,}#', '-', $text);
	$text = trim($text, '-');
	return ($urlencode? urlencode($text) : $text);
}

function clean_url($url) 
{
    if($url == '') return;
    $url = str_replace('http://', null, strtolower($url));
    $url = str_replace('https://', null, $url );
    if(substr($url, 0, 4) == 'www.')  $url = substr($url, 4);
    $url = explode('/', $url);
    $url = reset($url);
    $url = explode(':', $url);
    $url = reset($url);
    return $url;
}

function un_register_globals()
{
	if ( !ini_get('register_globals') )
		return;

	if ( isset($_REQUEST['GLOBALS']) )
		die('GLOBALS overwrite attempt detected');

	// Variables that shouldn't be unset
	$noUnset = array('GLOBALS', '_GET', '_POST', '_COOKIE', '_REQUEST', '_SERVER', '_ENV', '_FILES', 'parsnuke');

	$input = array_merge($_GET, $_POST, $_COOKIE, $_SERVER, $_ENV, $_FILES, isset($_SESSION) && is_array($_SESSION) ? $_SESSION : array());
	foreach ( $input as $k => $v )
		if ( !in_array($k, $noUnset) && isset($GLOBALS[$k]) )
        {
			$GLOBALS[$k] = NULL;
			unset($GLOBALS[$k]);
		}
}

function create_captcha($key = 'parsnuke')
{
	return '<img src="'.url.'engine/captcha.php?key='.$key.'" id="parsnuke-captcha-'.$key.'" class="parsnuke-captcha" width="60" height="25" border="0"> <img src="'.url.'engine/images/reload.png" class="parsnuke-captcha-reload" width="16" height="16" border="0" title="براي تغيير كد كليك كنيد" style="cursor:pointer" onClick="parsnuke.changeSrc(\'parsnuke-captcha-'.$key.'\', \''.url.'engine/captcha.php?key='.$key.'&amp;_=\'+parsnuke.random())">';
}

function validate_captcha($key, $code)
{
    $key = filter($key, 'en-num');
    if(isset($_COOKIE['security_code_'.$key]) && !empty($_COOKIE['security_code_'.$key]))
    {
        if(md5(sha1(sitekey).$code.$key) == $_COOKIE['security_code_'.$key])
        {
	        return true;
        }
    }
	return false;
}

function message($message, $type = 'info', $go_back = false)
{
    switch($type) 
	{
        case'0':
        case'error':
        $class = 'error';
        break;

        case'1':
        case'success':
        $class = 'success';
        break;

        case'2':
        case'info':
        default:
        $class = 'info';
        break;
    }
	
    $html  = '<div class="parsnuke-message-'.$class.'"><span>'.$message;

    if($go_back)
        $html .= '&nbsp;&nbsp;[<a href="javascript:history.go(-1);" target="_self" title="Go Back!" class="parsnuke-goBack">بازگشت به صفحه قبل</a>] ';
		
    $html .= '</span></div>';
    return $html;
}

function is_module($name, $active = true)
{
	$name = filter($name, 'en-num');
	if(is_dir(root_dir.'modules/'.$name) && file_exists(root_dir.'modules/'.$name.'/config.php'))
	{
		global $modules;
		if(!isset($modules[$name]) || ($active && $modules[$name]['module_status'] <= 0))
			return false; 

		return true; 
	}

	return false; 
}

function check_banned()
{
	global $options;
	$IP = get_ip();
	$options['last-banned'] = intval($options['last-banned'])<=0? md5(md5(sitekey)) : intval($options['last-banned']);
	if(isset($_COOKIE['check-ip']))
	{
		$checkIP = md5(sitekey . md5($_SERVER['HTTP_USER_AGENT']) . md5($IP) . $options['last-banned']);
		if($_COOKIE['check-ip'] == $checkIP)
		{
			$checkIP = 'OK';
		}
		else
		{
			$checkIP = $_COOKIE['check-ip'] = FALSE;
			unset($_COOKIE['check-ip']);
			un_set_cookie('check-ip');
		}
	}
	if(!isset($checkIP) || $checkIP != 'OK')
	{
		global $d;
		$ip_class = explode('.', $IP);
		$ip_class[0] = intval(@$ip_class[0]);
		$ip_class[1] = intval(@$ip_class[1]);
		$ip_class[2] = intval(@$ip_class[2]);
		$ip_class[3] = intval(@$ip_class[3]);

		$IP_1 = $ip_class[0].'.'.$ip_class[1].'.'.$ip_class[2].'.*';
		$IP_2 = $ip_class[0].'.'.$ip_class[1].'.*.'.$ip_class[3];
		$IP_3 = $ip_class[0].'.'.$ip_class[1].'.*.*';

		$d->query("SELECT * FROM `#__banned` WHERE `ban_ip`='$IP' OR `ban_ip`='$IP_1' OR `ban_ip`='$IP_2' OR `ban_ip`='$IP_3'");
		if($d->numRows()>=1)
		{
			$result = $d->fetch();
			if(is_array($result) && count($result) && !empty($result['ban_ip']))
			{
				if($result['ban_ip']==$IP || $result['ban_ip']==$IP_1 || $result['ban_ip']==$IP_2 || $result['ban_ip']==$IP_3)
				{
					@Header('Content-type: text/html; charset='.charset);

					$tpl = get_tpl(engine_dir.'templates/||banned.tpl', template_dir.'||banned.tpl');
					$tpl = new template($tpl[1], $tpl[0]);

					$tpl->assign(array(
						'{reason}' => nl2br($result['ban_reason']),
						'{date}' => jdate("l j F Y ساعت h:i A", $result['ban_date']),
						'{site-title}' => $options['title'],
						'{site-slogan}' => $options['slogan'],
						'{site-url}' => url,
						'{year}' => date('Y'),
					));
					$tpl->display();
					die();
				}			
			}
		}

		set_cookie('check-ip', md5(sitekey . md5($_SERVER['HTTP_USER_AGENT']) . md5($IP) . $options['last-banned']), time()+(60*60*5));
		unset($IP, $ip_class, $IP_1, $IP_2, $IP_3, $q, $result);
	}
}

function http_referer()
{
	global $options, $d;
	if($options['http-referer'] == 1)
	{
		if(isset($_SERVER['HTTP_REFERER']))
		{
			$referer = filter($_SERVER['HTTP_REFERER'], 'safe');
			$referer = !validate_url($referer)? null : $referer;
			$parse = parse_url($referer);
		}

		if(isset($parse['host']) && !empty($referer) && $parse['host']!=domain && $parse['host']!=$_SERVER['HTTP_HOST'])
		{
			$d->insert('referer', array(
				'ref_url' => $referer,
				'ref_domain' => $parse['host'],
				'ref_time' => time(),
				'ref_ip' => get_ip()
			));
		}
		unset($referer, $parse);
	}
}

function send_mail($To, $Subject, $Body, $From = null)
{
	global $options;
	$MailHeader  = 'MIME-Version: 1.0' . "\r\n";
	$MailHeader .= 'Content-type: text/html; charset=UTF-8' . "\r\n";
    $MailHeader .= 'From: '.$From . "\r\n"; // Sner's Email Address
	$MailHeader .= 'Return-Path: '.$From.' <'.$From.'> /n'; // Indicates Return-path
	$MailHeader .= 'Reply-To: '. $From.' <'.$From.'> /n'; // Reply-to Address
	$MailHeader .= 'X-Mailer: PHP/' . phpversion(); // For X-Mailer
	$From = !validate_email_format($From)? 'info@'.domain : $From;

	$tpl = get_tpl(engine_dir.'templates/||mail.tpl', template_dir.'||mail.tpl');
	$tpl = new template($tpl[1], $tpl[0]);

	$tpl->assign(array(
		'{subject}' => $Subject,
		'{to}' => $To,
		'{from}' => $From,
		'{body}' => $Body,
	));

    if(@mail($To, $Subject, $tpl->get_var(), $MailHeader))
		return true;

    return false;
}

function get_friendly_size($size)
{
	if(!is_numeric($size))
	{
		return false;
	}

	// Yottabyte (1024 Zettabytes)
	if($size >= 1208925819614629174706176)
	{
		$size = pn_number_format(round(($size / 1208925819614629174706176), 2))." YB";
	}
	// Zetabyte (1024 Exabytes)
	elseif($size >= 1180591620717411303424)
	{
		$size = pn_number_format(round(($size / 1180591620717411303424), 2))." ZB";
	}
	// Exabyte (1024 Petabytes)
	elseif($size >= 1152921504606846976)
	{
		$size = pn_number_format(round(($size / 1152921504606846976), 2))." EB";
	}
	// Petabyte (1024 Terabytes)
	elseif($size >= 1125899906842624)
	{
		$size = pn_number_format(round(($size / 1125899906842624), 2))." PB";
	}
	// Terabyte (1024 Gigabytes)
	elseif($size >= 1099511627776)
	{
		$size = pn_number_format(round(($size / 1099511627776), 2))." TB";
	}
	// Gigabyte (1024 Megabytes)
	elseif($size >= 1073741824)
	{
		$size = pn_number_format(round(($size / 1073741824), 2))." GB";
	}
	// Megabyte (1024 Kilobytes)
	elseif($size >= 1048576)
	{
		$size = pn_number_format(round(($size / 1048576), 2))." MB";
	}
	// Kilobyte (1024 bytes)
	elseif($size >= 1024)
	{
		$size = pn_number_format(round(($size / 1024), 2))." KB";
	}
	elseif($size == 0)
	{
		$size = "0 bytes";
	}
	else
	{
		$size = pn_number_format($size)." bytes";
	}

	return $size;
}

function pn_number_format($number)
{
	if($number == "-")
	{
		return $number;
	}

	if(is_int($number))
	{
		return number_format($number, 0, '.', ',');
	}
	else
	{
		$parts = explode('.', $number);

		if(isset($parts[1]))
		{
			$decimals = strlen($parts[1]);
		}
		else
		{
			$decimals = 0;
		}

		return number_format((double)$number, $decimals, '.', ',');
	}
}

/* Author: Amir Hossein Hodjaty Pour ~ Boplo.ir */
function getPastTime($time, $year=true, $month=true, $day=true, $hour=true, $minute=true, $second=false)
{
	$output = array();
	$div = (time() - $time) / 31536000; // 365 * 24 * 60 * 60 = 31536000
	$floor = floor($div);
	$rest = $div - $floor;

	if($year && $floor > 0)
		$output[] = $floor ." سال";

	if($rest > 0) {
		$div = $rest * 31536000 / 2592000; // 30 * 24 * 60 * 60 = 2592000
		$floor = floor($div);
		$rest = $div - $floor;
		
		if($month && $floor > 0)
			$output[] = $floor ." ماه";
		
		if($rest > 0) {
			$div = $rest * 2592000 / 86400; // 24 * 60 * 60 = 86400
			$floor = floor($div);
			$rest = $div - $floor;
			
			if($day && $floor > 0)
				$output[] = $floor ." روز";
			
			if($rest > 0) {
				$div = $rest * 86400 / 3600; // 60 * 60 = 3600
				$floor = floor($div);
				$rest = $div - $floor;
				
				if($hour && $floor > 0)
					$output[] = $floor ." ساعت";
				
				if($rest > 0) {
					$div = $rest * 60;
					$floor = floor($div);
					$rest = $div - $floor;
					
					if($minute && $floor > 0)
						$output[] = $floor ." دقیقه";
					
					if($second && $rest > 0) {
						$div = $rest * 60;
						$floor = floor($div);
						
						$output[] = $floor ." ثانیه";
					}
				}
			}
		}
	}
	return (empty($output) ? "چند لحظه پیش" : join(" و ", $output) . " پیش");
}

function summarize($str, $limit=600, $offset=100, $nlineChars=array(' ','.','!','?',"\n",')',';',',','؟','،'))
{
    if(strlen($str)<=$limit)
        return $str;

    for($i=$limit; $i>$limit-$offset; $i--) {
        if(in_array($str{$i}, $nlineChars)) {
            $length = $i;
            break;
        }
        if(!isset($spaceLength) && $str{$i}==' ')
            $spaceLength = $i;
    }
    if(isset($length))
        return substr($str, 0, $length+1);

    for($i=$limit; $i<$limit+$offset; $i++) {
        if(in_array($str{$i}, $nlineChars)) {
            $length = $i;
            break;
        }
        if(!isset($spaceLength) && $str{$i}==' ')
            $spaceLength = $i;
    }
    if(isset($length))
        return substr($str, 0, $length+1);

    if(isset($spaceLength))
        return substr($str, 0, $spaceLength);

    return substr($str, 0, $limit+1);
}

function wysiwyg_textarea($name, $value, $config = 'ParsNuke', $class = null, $extra = null, $cols = 50, $rows = 10)
{
    if($config=='Class')
	{
		global $page;
		$page['head'][] = '<script language="JavaScript" src="'.url.'engine/editor/ckeditor/ckeditor.js" type="text/javascript"></script>';
        $class = !empty($class)? ' '.$class : null;
        $extra = !empty($extra)? ' '.$extra : null;
	    return '<textarea name="'.$name.'" rows="'.$rows.'" cols="'.$cols.'" class="ckeditor'.$class.'"'.$extra.'>'.$value.'</textarea>';
	}

	require_once root_dir.'engine/editor/ckeditor/ckeditor.php';
	$ckeditor = new CKEditor();
	$ckeditor->returnOutput = true;
	$ckeditor->basePath = url.'engine/editor/ckeditor/';
	$ckeditor->textareaAttributes['id'] = 'textarea_'.trim(str_replace(array('[', ']', '-', ' '), '_', $name), '_');
	$ckeditor->config['smiley_path'] = url.'engine/images/smiles/';
	$ckeditor->config['smiley_images'] = array(
		'1.gif','2.gif','3.gif','4.gif','5.gif','6.gif','7.gif','8.gif','9.gif','10.gif','11.gif','12.gif','13.gif','14.gif','15.gif','16.gif','17.gif','18.gif','19.gif','20.gif','21.gif','22.gif','23.gif','24.gif','25.gif','26.gif','27.gif','28.gif','29.gif','30.gif','31.gif','32.gif','33.gif','34.gif','35.gif','36.gif','37.gif','38.gif','39.gif','40.gif','41.gif','42.gif','43.gif','44.gif','45.gif','46.gif','47.gif','48.gif','49.gif','50.gif','51.gif','52.gif','53.gif','54.gif','55.gif','56.gif','57.gif','58.gif','59.gif','60.gif','61.gif','62.gif','63.gif','64.gif','65.gif','66.gif','67.gif','68.gif','69.gif','70.gif','71.gif','72.gif','73.gif','74.gif','75.gif'
	);
	$ckeditor->config['smiley_descriptions'] = array(
		'angel','Happy','Sad','smiley4','smiley5','smiley6','smiley7','smiley8','smiley9','smiley10','smiley11','smiley12','smiley13','smiley14','smiley15','smiley16','smiley17','smiley18','smiley19','smiley20','smiley21','smiley22','smiley23','smiley24','smiley25','smiley26','smiley27','smiley28','smiley29','smiley30','smiley31','smiley32','smiley33','smiley34','smiley35','smiley36','smiley37','smiley38','smiley39','smiley40','smiley41','smiley42','smiley43','smiley44','smiley45','smiley46','smiley47','smiley48','smiley49','smiley50','smiley51','smiley52','smiley53','smiley54','smiley55','smiley56','smiley57','smiley58','smiley59','smiley60','smiley61','smiley62','smiley63','smiley64','smiley65','smiley66','smiley67','smiley68','smiley69','smiley70','smiley71','smiley72','smiley73','smiley74','smiley75'
	);

	switch($config)
	{
	    case 'Basic':
		$ckeditor->config['toolbar'] = array(
			array( 'FontSize','Bold','Italic','TextColor','-','JustifyLeft','JustifyCenter','JustifyRight','-','Link','Unlink','Smiley' )
		);	
		break;	

	    case 'BBcode':
		$ckeditor->config['extraPlugins'] = 'bbcode';
		$ckeditor->config['removePlugins'] = 'bidi,button,dialogadvtab,div,filebrowser,flash,format,forms,horizontalrule,iframe,indent,justify,liststyle,pagebreak,showborders,stylescombo,table,tabletools,templates';
		$ckeditor->config['disableObjectResizing'] = true;
		$ckeditor->config['fontSize_sizes'] = '30/30%;50/50%;100/100%;120/120%;150/150%;200/200%;300/300%';
		$ckeditor->config['toolbar'] = array(
			array( 'Source', '-', 'NewPage','-','Undo','Redo' ),
			array( 'Find','Replace','-','SelectAll','RemoveFormat' ),
			array( 'Link', 'Unlink', 'Image', 'Smiley','SpecialChar' ),
			array( 'Bold', 'Italic','Underline' ),
			array( 'FontSize' ),
			array( 'TextColor' ),
			array( 'NumberedList','BulletedList','-','Blockquote' ),
			array( 'Maximize' )
		);
		break;
		
	    case 'ParsNuke':
		if(group_admin==1 && member::check_admin_page_access('media'))
		{
			global $options;
			$ckeditor->config['filebrowserBrowseUrl'] = url.'?a='.$options['admin'].'&b=media&noTemplate=true';
		}		
		break;
		
	    default:
		$ckeditor->config['toolbar'] = array(
			array( 'Source','FitWindow','-' ),
			array( 'Cut','Copy','Paste','PasteText','PasteWord','-','Print' ),
			array( 'Undo','Redo','-','Find','Replace','-','SelectAll','RemoveFormat',  'Maximize' ),
			array( 'Link','Unlink','Anchor','StrikeThrough','-','Subscript','Superscript' ),
			array( 'OrderedList','UnorderedList','-','Outdent','Indent', 'NumberedList', 'BulletedList', 'Blockquote' ),
			array( 'JustifyLeft','JustifyCenter','JustifyRight','JustifyFull','Table','Rule','SpecialChar','PageBreak' ),
			array( 'FontName','FontSize','Bold','Italic','Underline','TextColor','BGColor','Smiley', 'Image' ),
		);
		break;		
	}
	
	return $ckeditor->editor($name, $value, $config);
}

function blocks()
{
	global $tpl, $cache, $options;

	if(!isset($cache['blocks']) || !is_array($cache['blocks']) || !count($cache['blocks']))
	{
		if(!$cache['blocks'] = get_cache('blocks', 2592000))
		{
			global $d;
			$cache['blocks'] = array();
			$d->query("SELECT * FROM `#__blocks` WHERE `block_active`='1' ORDER BY `block_position`, `block_ordering` ASC");
			while($row = $d->fetch())
			{
				$cache['blocks'][ $row['block_position'] ][ $row['block_ordering'] ] = $row;
			}
			$d->freeResult();			
			set_cache('blocks', $cache['blocks']);
		}
	}

	$positions = template_info($options['theme']);
	$positions = explode(',', $positions['positions']);
	
	if(!isset($cache['blocks']) || !is_array($cache['blocks']) || !count($cache['blocks']) || !is_array($positions) || !count($positions))
		return null;

	foreach($positions as $position)
	{
		if(!isset($cache['blocks'][$position]) || !is_array($cache['blocks'][$position]) || !count($cache['blocks'][$position])) continue;

		ksort($cache['blocks'][$position]);
		foreach($cache['blocks'][$position] as $block)
		{
			if($block['block_view']==2 && !member) continue;
			if($block['block_view']==3 && member) continue;
			if($block['block_view']==4 && !group_admin) continue;
			if($block['block_view']==5 && !group_super_admin) continue;
			
			$block['block_content'] = trim($block['block_content']);
			$block['block_function'] = filter($block['block_function'], 'en-num');
			if(!empty($block['block_function']) && function_exists('block_'.$block['block_function']))
			{
				if(strpos($block['block_content'], '[- options -]') !== FALSE)
				{
					$block['block_content'] = trim(filter($block['block_content'], 'safe'));
					if(substr($block['block_content'], 0, 13) == '[- options -]')
					{
						$block['block_content'] = trim(substr($block['block_content'], 13));
						if(strpos($block['block_content'], '=') !== FALSE)
						{
							$content = array();
							$block['block_content'] = explode("\n", $block['block_content']);
							foreach($block['block_content'] as $c)
							{
								$c = explode('=', $c);
								if(!isset($c[0]) || !isset($c[1]) || trim($c[0])=='' || trim($c[1])=='') continue;
								$c[0] = trim($c[0]);
								$c[1] = trim($c[1]);
								$content[$c[0]] = $c[1];
							}
							$block['block_content'] = !count($content)? null : $content;
						}
						else
						{
							$block['block_content'] = null;
						}
					}
				}
				else
				{
					$block['block_content'] = null;
				}

				$block['block_function'] = 'block_'.$block['block_function'];
				$block['block_content'] = $block['block_function']($block['block_content'], $block['block_id'], $position);
			}
			elseif(!empty($block['block_function']))
				continue;

			$file = file_exists(template_dir.'block-'.$position.'.tpl')? 'block-'.$position.'.tpl' : null;
			$file = empty($file) && file_exists(template_dir.'block.tpl')? 'block.tpl' : $file;

			if(empty($file))
			{
				continue;
			}

			$itpl = new template($file, template_dir);
			$itpl->assign(array(
				'{id}' => $block['block_id'],
				'{title}' => $block['block_title'],
				'{content}' => $block['block_content'],
			));
			$tpl->assign(array(
				'{block-'.$position.'}' => $itpl->get_var(),
				'[block-'.$position.']' => null,
				'[/block-'.$position.']' => null,
			), null, 'add');
			unset($itpl);
			$test[$position] = true;
		}
	}
	
	foreach($positions as $position)
	{
		if(!isset($test[$position]))
		{
			$tpl->block('#\\[block-'.$position.'\\](.*?)\\[/block-'.$position.'\\]#s', '');
			$tpl->assign(array(
				'{block-'.$position.'}' => null,
				'[not-block-'.$position.']' => null,
				'[/not-block-'.$position.']' => null,
			));
		}
		else
		{
			$tpl->block('#\\[not-block-'.$position.'\\](.*?)\\[/not-block-'.$position.'\\]#s', '');
		}
	}

	unset($position, $blocks, $block, $page, $p, $positions, $test);
}

function dump($var, $filter = 1, $stop = 1)
{
	if($filter == 1)
		if(is_array($var))
			$var = array_map(create_function('$v', 'return filter($v, \'preview\');'), $var);

	echo('<pre style="direction:ltr;text-align:left">'.print_r($var, true).'</pre>');

	if($stop == 1)
		exit;
}

function template_exists($theme)
{
	$theme = filter($theme, 'en-num');
	if (!is_dir(root_dir.'templates') || !is_readable(root_dir.'templates'))
	{
		return false;
	}
	elseif(file_exists(root_dir.'templates/'.$theme.'/body.tpl') && file_exists(root_dir.'templates/'.$theme.'/content.tpl') && file_exists(root_dir.'templates/'.$theme.'/post.tpl') && file_exists(root_dir.'templates/'.$theme.'/comments.tpl') && file_exists(root_dir.'templates/'.$theme.'/pagination.tpl') && file_exists(root_dir.'templates/'.$theme.'/styles/engine.css'))
	{
		return true;
	}
	return false;
}

function template_info($theme)
{
	static $save;
	$array = array();
	$theme = filter($theme, 'en-num');

	if(isset($save[$theme]) && is_array($save[$theme]) && count($save[$theme]))
		return $save[$theme];

	if(!template_exists($theme))
		return false;

	if(file_exists(root_dir.'templates/'.$theme.'/styles/engine.css'))
	{
		$file = file_get_contents(root_dir.'templates/'.$theme.'/styles/engine.css');	
		if(!empty($file))
		{
			preg_match_all('|/\*\*(.*)\*/|is', $file, $a);
			if(isset($a[1][0]) && !empty($a[1][0]))
			{
				preg_match_all('~\*\s{0,}@\s{0,}([a-zA-Z0-9_-]+)\s{0,}:(.*)\s{0,}\$~isU', $a[1][0], $b);
				if(isset($b[1]) && is_array($b[1]) && count($b[1]))
				{
					foreach($b[1] as $i => $c)
					{
						$array[trim($c)] = trim($b[2][$i]);
					}
				}
			}
		}
		unset($file, $a, $b, $c, $i);
	}

	$array['name'] = !isset($array['name']) || empty($array['name'])? $theme : $array['name'];
	$array['version'] = !isset($array['version']) || empty($array['version'])? '1.1' : filter($array['version'], 'safe');
	$array['creationDate'] = !isset($array['creationDate']) || empty($array['creationDate'])? date('Y-m-d H:i:s') : filter($array['creationDate'], 'safe');
	$array['description'] = !isset($array['description']) || empty($array['description'])? null : $array['description'];
	$array['screenshot'] = !isset($array['screenshot']) || empty($array['screenshot'])? null : filter($array['screenshot'], 'safe');
	$array['author'] = !isset($array['author']) || empty($array['author'])? null : $array['author'];
	$array['authorEmail'] = !isset($array['authorEmail']) || !validate_email_format($array['authorEmail'])? null : $array['authorEmail'];
	$array['authorUrl'] = !isset($array['authorUrl']) || !validate_url($array['authorUrl'])? null : $array['authorUrl'];
	$array['positions'] = !isset($array['positions']) || empty($array['positions'])? null : filter($array['positions'], 'safe');
	$array['pages'] = !isset($array['pages']) || empty($array['pages'])? null : filter($array['pages'], 'safe');
	$array['compaction'] = !isset($array['compaction']) || empty($array['compaction'])? false : ($array['compaction']=='true'? true : false);
	$array['license'] = !isset($array['license']) || empty($array['license'])? 'GNU/GPL' : $array['license'];

	$array['positions'] = explode(',', $array['positions']);
	$array['positions'] = filter($array['positions'], 'en-num');
	$array['positions'] = implode(',', $array['positions']);

	$array['pages'] = explode(',', $array['pages']);
	$array['pages'] = filter($array['pages'], 'en-num');
	$array['pages'] = implode(',', $array['pages']);

	return $save[$theme] = $array;
}

function head()
{
	global $cache, $options, $page;
	$Header  = '<title>'.$page['title'].'</title>'.n;
	$Header .= '<base href="'.url.'" />'.n;
	$Header .= '<meta http-equiv="content-type" content="text/html; charset='.charset.'" />'.n;
	$Header .= '<meta name="author" content="'.$options['title'].'" />'.n;
	$Header .= '<meta name="generator" content="Pars Nuke Copyright (c) '.date('Y').' by Iman Moodi (www.parsnuke.com)." />'.n;
	$Header .= '<meta name="description" content="'.$page['meta']['description'].'" />'.n;
	$Header .= '<meta name="keywords" content="'.$page['meta']['keywords'].'" />'.n;
	$Header .= '<meta name="distribution" content="global" />'.n;
	$Header .= '<meta name="robots" content="'.(!empty($page['meta']['robots'])? $page['meta']['robots'] : 'index, follow').'" />'.n;
	$Header .= '<meta name="revisit-after" content="1 days" />'.n;
	$Header .= '<meta name="rating" content="general" />'.n;

    if (($_GET['a'] == $options['default-module'] && (!isset($_SERVER['QUERY_STRING']) || empty($_SERVER['QUERY_STRING']))) || (!isset($_SERVER['QUERY_STRING']) || empty($_SERVER['QUERY_STRING'])))
		$Header .= '<meta name="canonical" content="'.url.'" />'. n;
    elseif (!empty($page['meta']['canonical']))
		$Header .= '<meta name="canonical" content="'.url.$page['meta']['canonical'].'" />'. n;

	$Header .= '<link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />'.n;
	$Header .= '<link rel="start" href="'.url.'" title="Home" />'.n;
	$Header .= '<link rel="sitemap" href="'.url.($options['rewrite']==1? 'sitemap.xml' : '?a=sitemap').'" />'.n;
	$Header .= '<link rel="search" type="application/opensearchdescription+xml" href="'.url.url('search/opensearch').'" title="'.$options['title'].'" />'.n;
	$Header .= '<link rel="alternate" type="application/rss+xml" href="'.url.url('feed/posts/rss').'" title="'.$options['title'].'" />'.n;
	$Header .= '<script type="text/javascript" src="engine/javascript/parsnuke.js"></script>'. n;
	$Header .= is_array($page['head']) && count($page['head'])? implode(n, $page['head']).n : null;
    return trim($Header);
}

function set_content($title, $content, $type = 'add')
{
	global $tpl, $options;
	
	if(!admin_page)
		$itpl = new template('content.tpl', root_dir.'templates/'.$options['theme'].'/');
	else
		$itpl = new template('content.tpl', root_dir.'engine/admin/template/');
	
	if(!empty($title))
	{
		$itpl->assign(array(
			'[title]' => null,
			'[/title]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[title\\](.*?)\\[/title\\]#s', '');
	}
	
	$array['{title}'] = $title;
	$array['{content}'] = $content;
	
	$itpl->assign($array);
	$tpl->assign('{content}', $itpl->get_var(), $type);
	unset($itpl, $array);
}

function get_tpl($default, $custom)
{
	global $options;
	$custom = explode('||', $custom);
	if(file_exists($custom[0].$custom[1]))
	{
		return array_merge($custom, array('custom'));
	}
	else
	{
		return explode('||', $default);
	}
}

function global_tags($r = false)
{
	global $options, $member;
	$member = member::is('info');
	$array = array(
		'member-name' => defined('member') && member? $member['member_name'] : 'مهمان',
		'member-ip' => get_ip(),
		'today' => jdate('l ').Convertnumber2farsi(jdate('j')).jdate(' F ').Convertnumber2farsi(jdate('Y')).jdate(' ساعت ').Convertnumber2farsi(jdate('h:i')).jdate(' A'),
		'site-url' => url,
		'site-title' => $options['title'],
		'site-slogan' => $options['slogan'],
		'template' => 'templates/'.$options['theme'].'/',
		'description' => $options['meta-desc'],
		'keywords' => $options['meta-keys'],
		'admin-page' => defined('group_admin') && defined('admin_page') && (group_admin || admin_page)? $options['admin'] : '!ADMIN!',
	);
	
	if($r == true)
	foreach($array as $a=>$v)
	{
		$array['{'.$a.'}'] = $v;
		unset($array[$a]);
	}
	
	return $array;
}

function pn_die($title, $message)
{
	global $options;
    @Header('Content-type: text/html; charset='.charset);
	$tpl = get_tpl(engine_dir.'templates/||die.tpl', template_dir.'||die.tpl');
	$tpl = new template($tpl[1], $tpl[0]);
	$tpl->assign(array(
		'{title}' => $title,
		'{message}' => $message,
		'{year}' => date('Y'),
	));
	$tpl->display();
	die();
}

function html_compaction($html)
{
    $array = array();
	if($number = preg_match_all('/<script(.*)>(.*)<\/script>/sUi', $html, $matches))
	{
		for( $i = 0; $i < $number; $i++ )
		{
			if(!empty($matches[0][$i]))
			{
				$key = rand(11111111, 99999999).generate_password(20, null).rand(11111111, 99999999);
				$array[$key] = trim($matches[0][$i]);
				$html = str_replace($matches[0][$i], '<#script:'.$key.':script#>', $html);
			}
		}
	}

    $html = preg_replace('/<!--(.*)-->/', '', $html);

    // remove tabs, spaces, newlines, etc.
	$html = preg_replace('#\n\s+#', ' ', $html);
	$html = preg_replace('#[\r\n\t]+<#', '<', $html);
	$html = preg_replace('#>[\r\n\t]+#', '>', $html);
	$html = preg_replace('# {2,}#', ' ', $html);

    foreach($array as $key => $js)
    {
		$html = str_replace('<#script:'.$key.':script#>', $js, $html);
    }
    unset($array, $key, $js, $matches, $number);

    return $html;
}

function CheckCanGzip()
{
	if (headers_sent() || connection_aborted() || ! function_exists('ob_gzhandler') || ini_get('zlib.output_compression')) return 0;
	if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'x-gzip') !== false) return "x-gzip";
	if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false) return "gzip";
	return 0;
}

function gzipOut()
{
	$ENCODING = CheckCanGzip();
	if($ENCODING)
    {
		global $options, $d;
		$Contents = ob_get_contents();
		ob_end_clean();

		$compaction = template_info($options['theme']);
		if($compaction['compaction'] && !admin_page) $Contents = html_compaction($Contents);

		Header('Content-Encoding: '.$ENCODING);
		$Contents = gzencode($Contents, 9, FORCE_GZIP);
		echo $Contents;
		unset($Contents, $d, $compaction, $options, $ENCODING);
		exit();
	}
    else
    {
        ob_end_flush();
		exit();
	}
}

?>