<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

if(!file_exists(engine_dir.'config.inc.php') && is_dir(root_dir.'install'))
{
	Header('Location: install/');
    die('Link Redirect:<br /><br />Please click <a href="install/">here.</a>');
}
elseif(!file_exists(engine_dir.'config.inc.php') && !is_dir(root_dir.'install'))
{
    die('Could not find the "engine/config.inc.php" file!');
}
elseif(is_dir(root_dir.'install'))
{
    Header('Content-type: text/html; charset=utf-8');
    die('<div align="center" style="direction:rtl;font-family:Tahoma;color:red">لطفا پوشه ی <b>install</b> را حذف کنید!</div>');
}

if(function_exists('date_default_timezone_set'))
	date_default_timezone_set('Asia/Tehran');

if(function_exists('mb_internal_encoding'))
	mb_internal_encoding('UTF-8');

define('start_time', microtime(true));
define('time_now', time());
define('n', "\n");
define('rtl', true);
require_once(engine_dir.'config.inc.php');
require_once(engine_dir.'jalaliDate.function.php');
require_once(engine_dir.'functions.php');
require_once(engine_dir.'database.class.php');
require_once(engine_dir.'member.class.php');
require_once(engine_dir.'template.class.php');
require_once(engine_dir.'html.class.php');

if(error_reporting)
	error_reporting(E_ALL);
else
	error_reporting(0);

check_xss();
un_register_globals();

$d = new database;
$d->connect(array(
    'host' => database_host,
    'user' => database_user,
    'password' => database_password,
    'name' => database_name,
    'prefix' => database_prefix,
    'charset' => database_charset,
));

if(!$options = get_cache('options', 2592000)) /* 2592000 == 1 Month */
{
	$rows = $d->get_row("SELECT * FROM `#__options` WHERE `autoload`='1'");
	foreach($rows as $row)
	{
		$options[$row['option_name']] = $row['option_value'];
	};
	unset($rows, $row);
	set_cache('options', $options);
}

define('template_dir', root_dir.'templates/'.$options['theme'].'/');
check_banned();

if($options['rewrite'] == 1)
{
	if(!file_exists(root_dir.'.htaccess'))
		$options['rewrite'] = 0;
		
	mod_rewrite();
}

defined('mod_rewrite') or define('mod_rewrite', 0);

if(!$modules = get_cache('modules', 2592000))
{
    $modules = $d->get_row("SELECT * FROM `#__modules`", 'assoc', 'module_name');
	set_cache('modules', $modules);
}

if(!$member_groups = get_cache('member-groups', 2592000))
{
    $member_groups = $d->get_row("SELECT * FROM #__member_groups ORDER BY group_id ASC", 'assoc', 'group_id');
	set_cache('member-groups', $member_groups);
}

$member = member::is('info');
if($member && is_array($member) && count($member) && isset($member['member_id']) && isset($member['member_group']) && intval($member['member_id'])>0 && intval($member['member_group'])>0)
{
    define('member', 1);
    define('member_id', intval($member['member_id']));
    define('member_name', filter($member['member_name'], 'en-num'));
    define('member_group', intval($member['member_group']));
}
else
{
    define('member', 0);
    define('member_id', 0);
    define('member_name', 'GUEST');
    define('member_group', 5);
	$member = false;
}

if(is_array($member_groups[member_group]) && count($member_groups[member_group]))
{
    define('group_admin', intval($member_groups[member_group]['group_admin'])==1? 1 : 0);
    define('group_super_admin', intval($member_groups[member_group]['group_superAdmin'])==1? 1 : 0);
    define('group_rights', filter($member_groups[member_group]['group_rights'], 'safe'));
}
else
{
    define('group_admin', 0);
    define('group_super_admin', 0);
    define('group_rights', null);
}

$_GET['a'] = get_param($_GET, 'a');

if(empty($_GET['a']))
{
	$_GET['a'] = $options['default-module'];
}

$page['theme'] = null;
$page['title'] = empty($options['title'])? 'Pars Nuke v'.version : $options['title'];
$page['meta']['description'] = $options['meta-desc'];
$page['meta']['keywords'] = $options['meta-keys'];
$page['meta']['robots'] = null;
$page['meta']['canonical'] = null;
$page['head'] = array();
$cache = array();

if($_GET['a'] == $options['admin'])
{
	define('admin_page', $options['admin']);
	$tpl = new template('body.tpl', root_dir.'engine/admin/template/');
}
else
{
	define('admin_page', false);

	if($options['offline'] == 1)
	{
		if(!$options['offline-message'] = get_cache('options-offline-message', 2592000))
		{
			$options['offline-message'] = $d->get_row("SELECT * FROM `#__options` WHERE `option_name`='offline-message'");
			$options['offline-message'] = $options['offline-message'][0]['option_value'];
			set_cache('options-offline-message', $options['offline-message'], false);
		}
		pn_die('سایت غیرفعال است', $options['offline-message']);
	}
	
	if(!template_exists($options['theme']))
	{
		pn_die('خطا در تم سایت', 'متاسفانه تم سایت ناقص می باشد!');
	}
	
	$tpl = new template('body.tpl', root_dir.'templates/'.$options['theme'].'/', true);
}

$tpl->assign(array(
	'{loading}' => '<div id="parsnuke-loadingLayer" style="display:none"><div id="parsnuke-loadingLayerText">در حال بارگذاری اطلاعات ...</div></div>',
	'{copyright}' => copyright(),
));

foreach($modules as $___mod)
{
	if($___mod['module_status']==0 || ($___mod['module_status']==2 && !admin_page && $_GET['a']!=$___mod['module_name']))
		continue;

	if(file_exists(root_dir.'modules/'.$___mod['module_name'].'/config.php'))
		require_once(root_dir.'modules/'.$___mod['module_name'].'/config.php');
}
unset($___mod);

if(file_exists(engine_dir.'custom-file.php'))
	require_once(engine_dir.'custom-file.php');

if(file_exists(root_dir.'templates/'.$options['theme'].'/functions.php'))
	require_once(root_dir.'templates/'.$options['theme'].'/functions.php');

?>