<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function get_ip()
{
	if (!empty($_SERVER['HTTP_CLIENT_IP']))   //check ip from share internet
	{
		$ip=$_SERVER['HTTP_CLIENT_IP'];
	}
	elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))   //to check ip is pass from proxy
	{
		$ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else
	{
		$ip=$_SERVER['REMOTE_ADDR'];
	}
	$ip = filter($ip, "safe");
	return $ip;
}

function my_path()
{
    if(!isset($_SERVER['REQUEST_URI']))
        $url = $_SERVER['PHP_SELF'];
    else
	{
        $url = $_SERVER['REQUEST_URI'];
        $url = explode('?', $url);
		$url = str_ireplace(array('/install/install.php', '/install/upgrade.php'), '', $url[0]);
	}
    $url = str_ireplace(array('http://', 'https://'), null, $url);   
    $url = trim($url, '/');
	return $url.'/';
}

function generate_password($count = 8, $add = '!@#%^&*()_+=-:;?~{}|÷.,')
{
	mt_srand(microtime()*1000000);
	$words = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'.$add;
	$return = '';
	for ($i=0; $i<$count; $i++) $return .= $words[mt_rand(0, strlen($words)-1)];
	return $return;
}

function validate_email_format($email)
{
    if (phpversion() >= '5.2.0') {
        return filter_var($email, FILTER_VALIDATE_EMAIL);
    } else {
		if(strpos($email, ' ') !== false)
		{
			return false;
		}
		// Valid local characters for email addresses: http://www.remote.org/jochen/mail/info/chars.html
		return preg_match("/^[a-zA-Z0-9&*+\-_.{}~^\?=\/]+@[a-zA-Z0-9-]+\.([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]{2,}$/si", $email);
    }
}

function preg_check($expression, $value)
{
	if(is_string($value))
	{
		return preg_match($expression, $value);
	}
	else
	{
		return false;
	}
}

function filter($text, $type = 'preview', $space = FALSE)
{
	if(is_array($text))
	{
		foreach($text as $k => $v)
			$text[$k] = filter($v, $type, $space);
	}
	else
	{
		$text = @trim($text);

		if(empty($text))
			return $text;

		switch($type)
		{
			case'en':
			$pattern = 'A-Za-z-_';
			break;

			case'en-num':
			$pattern = 'A-Za-z-0-9-_';
			break;

			case'safe':
			case'nohtml':
			if($type=='safe')
			$text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
			$text = strip_tags($text);
			return @trim($text);
			break;

			case'htmldecode':
			return html_entity_decode($text, ENT_QUOTES, 'UTF-8');
			break;

			default:
			case'preview':
			$text = htmlentities($text, ENT_QUOTES, 'UTF-8');
			$text = str_replace(array('<','>','\'','"','&amp;'), array('&lt;','&gt;','&apos;','&quot;','&'), $text);
			return $text;
			break;
		}
		if($space) $pattern = $pattern.' ';
		$text = preg_replace('([^'.$pattern.']*)', null, $text);
	}
	return $text;
}

function clean_text($text, $urlencode = false)
{
	$text = filter($text, 'safe');
	$text = str_replace(array('!','@','#','$','%','^','*','÷','(',')','{','}','_','--','=','+','++','|','¦','/','\\','~','≈','`','´','\'','"','&','?','؟','>','<','»','«','⇔','⇒','→','×','.',',','،','¸','…','‌',' ','“','”','„','‛','¤','♦','•','►','—','–','¯','¨','º','·','€','©','®','¢','£','¶','™'),'-',$text);
	$text = preg_replace('#-{2,}#', '-', $text);
	$text = trim($text, '-');
	return ($urlencode? urlencode($text) : $text);
}

function posts_tags($data)
{
    global $d;
	$data = filter($data, 'safe');
	$data = trim($data, ',');
	$tags = explode(',', $data);
    $tags = array_map(create_function('$tag', 'if(empty($tag)) return null; else return filter($tag, \'safe\');'), $tags);

    $i = 0;
    if(is_array($tags) && count($tags))
    foreach($tags as $tag)
    {
        $tag = $d->escapeString($tag);
        $slug = clean_text($tag, true);

		if(empty($tag) || empty($slug))
		{
			unset($tags[$i]);
			continue;
		}
			
		if($d->numRows("SELECT * FROM `#__terms` WHERE `term_type`='p-tag' AND `term_name`='".$tag."'", true) <= 0)
        {
            $d->insert('terms', array(
                'term_type' => 'p-tag',
                'term_name' => $tag,
                'term_slug' => $slug,
            ));
        }
		$i++;
    }

    $id = array();
    foreach($tags as $tag)
    {
        if(!empty($tag))
        {
            $catID = $d->query("SELECT term_id FROM `#__terms` WHERE `term_type`='p-tag' AND `term_name`='".$d->escapeString($tag)."' limit 1");
			$catID = $d->fetch($catID);
            $catID = (int) $catID['term_id'];
            if($catID <= 0) continue;
            $id[] = $catID;
        }
    }

    return array(
		'id' => $id,
		'tags' => $tags
	);
}

?>