<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function account_options()
{
	if(!$options_account = get_cache('options-account', 2592000))
	{
		global $d;
		$d->query("SELECT `option_value` FROM `#__options` WHERE `option_name`='account' LIMIT 1");
		$result = $d->fetch();
		$d->freeResult();
		$options_account = maybe_unserialize($result['option_value']);
		set_cache('options-account', $options_account);
	}
	return $options_account;
}

function account_messages()
{
	global $d, $cache;
	if(!isset($cache['pm']['messages']) || !is_array($cache['pm']['messages']))
	{
		if(member)
		{
			$sql = $d->query("
				SELECT (SELECT COUNT(msg_id) FROM #__private_messages WHERE msg_receiver='".member_name."' AND msg_read='0') newpms,
				(SELECT COUNT(msg_id) FROM #__private_messages WHERE msg_receiver='".member_name."' AND msg_read='1') oldpms,
				(SELECT COUNT(msg_id) FROM #__private_messages WHERE msg_sender='".member_name."') sendpms,
				(SELECT COUNT(msg_id) FROM #__private_messages WHERE msg_sender='".member_name."' OR msg_receiver='".member_name."') allpms;
			");
			$cache['pm']['messages'] = $d->fetch($sql);
		}
		else
		{
			$cache['pm']['messages'] = array();	
		}
	}
	return $cache['pm']['messages'];
}

function block_account($op = null, $id = null, $position= null)
{
	if($op=='remove-cache') // admin
	{
		return true;
	}
	global $d, $cache, $member, $options;

	if(!isset($cache['block-counter']) || !is_array($cache['block-counter']) || !count($cache['block-counter']))
	{
		$t = strtotime(date('Y-m-d'));
		$t2 = strtotime(date('Y-m-d').' -1 days');
		$t3 = strtotime(date('Y-m-d').' +1 days');

		$result  = "SELECT (SELECT COUNT(*) FROM `#__members`) membersCount,".n;
		$result .= "(SELECT COUNT(`member_id`) FROM `#__members` WHERE `member_date` BETWEEN '$t2' AND '$t') membersYesterday,".n;
		$result .= "(SELECT COUNT(`member_id`) FROM `#__members` WHERE `member_date` BETWEEN '$t' AND '$t3') membersToday,".n;
		$result .= "(SELECT COUNT(`member_id`) FROM `#__members` WHERE `member_date` BETWEEN '".strtotime(date('Y-m'))."' AND '".strtotime(date('Y-m').' +1 month')."') membersMonth,".n;
		$result .= "(SELECT MAX(`member_id`) FROM `#__members`) memberNewID,".n;
		$result .= "(SELECT `member_name` FROM `#__members` WHERE `member_id`=memberNewID) memberNewName,".n;
		$result .= "(SELECT COUNT(`post_id`) FROM `#__posts` WHERE post_approve='1' AND post_date <= '".time_now."') postsCount,".n;
		$result .= "(SELECT COUNT(*) FROM `#__comments`) commentsCount,".n;
		$result .= is_module('simple-links')? "(SELECT COUNT(`link_id`) FROM `#__simple_links` WHERE `link_active`='1') linksCount,".n : null;
		$result .= is_module('newsletter')? "(SELECT COUNT(*) FROM `#__newsletter`) newsletterCount,".n : null;
		$result .= "(SELECT `counter_value` FROM `#__counter` WHERE `counter_name`='Total') totalCount,".n;
		$result .= "(SELECT `counter_value` FROM `#__counter` WHERE `counter_name`='Year-".jdate('Y')."') yearCount,".n;
		$result .= "(SELECT `counter_value` FROM `#__counter` WHERE `counter_name`='Month-".jdate('Y-m')."') monthCount,".n;
		$result .= "(SELECT `counter_value` FROM `#__counter` WHERE `counter_name`='Day-".jdate('Y-m-d')."') dayCount;".n;

		$result = $d->query($result);
		$cache['block-counter'] = $d->fetch($result);
	}
	$result = &$cache['block-counter'];

	$file = get_tpl(root_dir.'modules/account/html/||block.tpl', template_dir.'||account/block.tpl');
	$itpl = new template($file[1], $file[0]);
	
	if(member)
	{
		$member = member::is('info');
		$messages = account_messages();
		
		$itpl->assign(array(
			'{name}' => member::group_title($member['member_name'], $member['member_group']),
			'{avatar}' => member::avatar($member['member_avatar']),
			'{newpms}' => (int) $messages['newpms'],
			'{oldpms}' => (int) $messages['oldpms'],
			'{sendpms}' => (int) $messages['sendpms'],
			'{allpms}' => (int) $messages['allpms'],
			'[member]' => null,
			'[/member]' => null,
		));
		$itpl->block('#\\[guest\\](.*?)\\[/guest\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'{name}' => 'مهمان',
			'[guest]' => null,
			'[/guest]' => null,
		));
		$itpl->block('#\\[member\\](.*?)\\[/member\\]#s', '');
	}

	$online = $d->query("
		SELECT (SELECT COUNT(*) FROM `#__session` WHERE `session_guest`='1') count_guest,
		(SELECT COUNT(*) FROM `#__session` WHERE `session_guest`='0') count_member;
	");
	$online = $d->fetch($online);

	$itpl->assign(array(
		'{ip}' => get_ip(),
		'{last-member}' => $result['memberNewName'],
		'{members-today}' => (int) $result['membersToday'],
		'{members-yesterday}' => (int) $result['membersYesterday'],
		'{members-month}' => (int) $result['membersMonth'],
		'{members-total}' => (int) $result['membersCount'],
		'{count-guest}' => (int) $online['count_guest'],
		'{count-member}' => (int) $online['count_member'],
		'{count-total}' => (int) ($online['count_guest'] + $online['count_member']),
		'{captcha}' => create_captcha('login'),
	));
	
	if(file_exists(engine_dir.'GeoIP/geoip.php'))
	{
		require_once(engine_dir.'GeoIP/geoip.php');
		$geoip = geoip_open(engine_dir.'GeoIP/GeoIP.dat', 1);
	}

	$online = $d->query("
		SELECT s.*,m.member_group
		FROM #__session AS s
		LEFT JOIN #__members AS m ON (session_guest='0' AND m.member_name=s.session_member) 
		GROUP BY s.session_member
		ORDER BY s.session_guest ASC, s.session_member DESC
	");
	while($row = $d->fetch($online))
	{
		$array = array(
			'{name}' => !empty($row['member_group']) && $row['session_guest']==0? member::group_title($row['session_member'], $row['member_group']) : $row['session_member'],
			'{member}' => $row['session_member'],
			'{ip}' => $row['session_ip'],
			'{page}' => strpos($row['session_page'], '?a='.$options['admin']) !== FALSE? 'javascript:alert(\'صفحه محرمانه!\')' : $row['session_page'],
		);
		
		if($row['session_guest']==1)
		{
			$array['[guest]'] = null;
			$array['[/guest]'] = null;
			$array['replace']['#\\[user\\](.*?)\\[/user\\]#s'] = '';
		}
		else
		{
			$array['[user]'] = null;
			$array['[/user]'] = null;
			$array['replace']['#\\[guest\\](.*?)\\[/guest\\]#s'] = '';
		}
		
		if(isset($geoip))
		{
			$array['{flag}'] = strtolower(geoip_country_code_by_addr($geoip, $row['session_ip']));
			$array['{flag}'] = file_exists(root_dir.'modules/counter/images/flags/'.$array['{flag}'].'.gif')? $array['{flag}'] : 'xx';
			$array['{country}'] = $array['{flag}']=='xx'? 'Unknown' : geoip_country_name_by_addr($geoip, $row['session_ip']);
			$array['[flag]'] = null;
			$array['[/flag]'] = null;
		}
		else
		{
			$array['replace']['#\\[flag\\](.*?)\\[/flag\\]#s'] = '';
		}

		$itpl->add_for('online', $array);
	};

	if(isset($geoip))
	{
		geoip_close($geoip);
		unset($geoip);
	}
	unset($file, $array, $online, $sql, $messages, $row);
	return $itpl->get_var();	
}

function module_account_run()
{
	global $d, $options, $member;
	require_once(root_dir.'modules/account/functions.php');
	$_GET['b'] = get_param($_GET, 'b');
	switch($_GET['b'])
	{
		case 'register':
		func_account_register();
		break;

		case 'login':
		func_account_login();
		break;

		case 'logout':
		func_account_logout();
		break;
		
		case 'members':
		func_account_members();
		break;
		
		case 'profile':
		func_account_profile();
		break;

		case 'profile-edit':
		func_account_profile_edit();
		break;

		case 'change-password':
		func_account_change_password();
		break;

		case 'change-avatar':
		func_account_change_avatar();
		break;
		
		case 'remove-avatar':
		account_remove_avatar();
		break;

		case 'forget':
		func_account_forget();
		break;
		
		case 'pm':
		if(!member)
			redirect(url('account/login'));

		require_once(root_dir.'modules/account/functions-pm.php');

		$_GET['c'] = get_param($_GET, 'c');
		switch($_GET['c'])
		{
			case 'read':
			func_account_pm_read();
			break;

			case 'remove':
			func_account_pm_remove();
			break;
			
			case 'new':
			func_account_pm_new();
			break;

			case 'outbox':
			func_account_pm_outbox();
			break;
			
			default:
			func_account_pm_index();
			break;
		};
		break;
		
		default:
		if(!member)
			redirect(url('account/login'));

		func_account_index();
		break;
	}
}

function module_account_sitemap(&$sitemap)
{
	$sitemap->addItem(url('account/members'), 0, 'daily', '0.6');
	$sitemap->addItem(url('account/register'), 0, 'never', '0.6');
	$sitemap->addItem(url('account/login'), 0, 'never', '0.6');
	$sitemap->addItem(url('account/forget'), 0, 'never', '0.6');
}

?>