<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function func_account_pm_index() // inbox
{
	if(!member) 
		redirect(url('account/login'));

	global $d, $options, $tpl, $page;
	require_once(engine_dir.'pagination.class.php');
	$query = sprintf("SELECT * FROM `#__private_messages` WHERE `msg_receiver`='%s'", member_name);
	$total = $d->numRows($query, true);
	$get_pages = get_param($_GET, 'c', 1);
	
	$pagination = new pagination($total, 20, $get_pages);
	$query = sprintf("SELECT * FROM #__private_messages WHERE `msg_receiver`='%s' ORDER BY msg_date DESC, msg_id DESC LIMIT %d, %d", member_name, $pagination->Start, $pagination->End);
	$private_messages = $d->get_row($query, 'assoc', 'msg_id');

	$page['title'] .= ' &bull; پیام خصوصی';

	if($get_pages > 1)
		$page['title'] .= ' &bull; صفحه '.Convertnumber2farsi($get_pages);

	func_account_menu();
	func_account_pm_menu();

	$file = get_tpl(root_dir.'modules/account/html/pm/||index.tpl', template_dir.'||account/pm/index.tpl');
	$itpl = new template($file[1], $file[0]);

	if(is_array($private_messages) && count($private_messages))
	{
		foreach($private_messages as $msg)
		{
			$msg['msg_subject'] = $msg['msg_read']==0? '<font color=red>'.$msg['msg_subject'].'</font>' : $msg['msg_subject'];
			$itpl->add_for('list', array(
				'{odd-even}' => odd_even(),
				'{subject}' => $msg['msg_subject'],
				'{sender}' => $msg['msg_sender'],
				'{receiver}' => $msg['msg_receiver'],
				'{id}' => $msg['msg_id'],
				'{past-time}' => getPastTime($msg['msg_date']),
				'{date}' => jdate("j/m/Y h:i a", $msg['msg_date']),
			));
		}
		$itpl->assign(array(
			'[list]' => null,
			'[/list]' => null,
		));
		$itpl->block('#\\[not-list\\](.*?)\\[/not-list\\]#s', '');
	}
	else
	{
		$itpl->block('#\\[list\\](.*?)\\[/list\\]#s', '');
		$itpl->assign(array(
			'[not-list]' => null,
			'[/not-list]' => null,
		));
	}

	if(!isset($file[2])) set_content('پيام هاي دريافتي', $itpl->get_var()); else $tpl->assign('{content}', $itpl->get_var());	
	$pagination->build(url('account/pm/{page}'));
	unset($itpl, $pagination, $private_messages, $msg, $total, $query);
}

function func_account_pm_outbox()
{
	if(!member) 
		redirect(url('account/login'));

	global $d, $options, $tpl, $page;
	require_once(engine_dir.'pagination.class.php');
	$query = sprintf("SELECT * FROM `#__private_messages` WHERE `msg_sender`='%s'", member_name);
	$total = $d->numRows($query, true);
	$get_pages = get_param($_GET, 'd', 1);
	
	$pagination = new pagination($total, 20, $get_pages);
	$query = sprintf("SELECT * FROM #__private_messages WHERE `msg_sender`='%s' ORDER BY msg_date DESC, msg_id DESC LIMIT %d, %d", member_name, $pagination->Start, $pagination->End);
	$private_messages = $d->get_row($query, 'assoc', 'msg_id');

	$page['title'] .= ' &bull; پيام هاي ارسالي';

	if($get_pages > 1)
		$page['title'] .= ' &bull; صفحه '.Convertnumber2farsi($get_pages);
	
	func_account_menu();
	func_account_pm_menu();

	$file = get_tpl(root_dir.'modules/account/html/pm/||outbox.tpl', template_dir.'||account/pm/outbox.tpl');
	$itpl = new template($file[1], $file[0]);

	if(is_array($private_messages) && count($private_messages))
	{
		foreach($private_messages as $msg)
		{
			$msg['msg_subject'] = $msg['msg_read']==0? '<font color=red>'.$msg['msg_subject'].'</font>' : $msg['msg_subject'];
			$itpl->add_for('list', array(
				'{odd-even}' => odd_even(),
				'{subject}' => $msg['msg_subject'],
				'{sender}' => $msg['msg_sender'],
				'{receiver}' => $msg['msg_receiver'],
				'{id}' => $msg['msg_id'],
				'{past-time}' => getPastTime($msg['msg_date']),
				'{date}' => jdate("j/m/Y h:i a", $msg['msg_date']),
			));
		}
		$itpl->assign(array(
			'[list]' => null,
			'[/list]' => null,
		));
		$itpl->block('#\\[not-list\\](.*?)\\[/not-list\\]#s', '');
	}
	else
	{
		$itpl->block('#\\[list\\](.*?)\\[/list\\]#s', '');
		$itpl->assign(array(
			'[not-list]' => null,
			'[/not-list]' => null,
		));
	}

	if(!isset($file[2])) set_content('پيام هاي ارسالي', $itpl->get_var()); else $tpl->assign('{content}', $itpl->get_var());	
	$pagination->build(url('account/pm/outbox/{page}'));
	unset($itpl, $pagination, $private_messages, $msg, $total, $query);
}

function func_account_pm_read()
{
	if(!member) 
		redirect(url('account/login'));

	require_once(engine_dir.'bbcode.class.php');
	global $d, $tpl, $page;
	$id = get_param($_GET, 'd', 0);

	$query = sprintf("SELECT * FROM #__private_messages WHERE `msg_id`='%d' AND (`msg_receiver`='%s' OR `msg_sender`='%s') LIMIT 1", $id, member_name, member_name);
	$private_messages = $d->fetch($query, 'assoc', true);

	if(!is_array($private_messages) || !count($private_messages)) 
		redirect(url('account/pm'));

	if($private_messages['msg_read']==0 && $private_messages['msg_receiver']==member_name)
	{
		$where = sprintf("`msg_id`='%d' AND `msg_receiver`='%s'", $id, member_name);
		$d->update('private_messages', array(
			'msg_read' => 1
		), $where, 1);
	}
	
	$bbcode = new bbcode;
	$private_messages['msg_text'] = $bbcode->parse($private_messages['msg_text']);
	$private_messages['msg_subject'] = filter($private_messages['msg_subject'], 'preview');
	
	$page['title'] .= ' &bull; خواندن پیام';
	
	func_account_menu();
	func_account_pm_menu();

	$file = get_tpl(root_dir.'modules/account/html/pm/||read.tpl', template_dir.'||account/pm/read.tpl');
	$itpl = new template($file[1], $file[0]);

	$itpl->assign(array(
		'{subject}' => $private_messages['msg_subject'],
		'{sender}' => $private_messages['msg_sender'],
		'{receiver}' => $private_messages['msg_receiver'],
		'{text}' => $private_messages['msg_text'],
		'{id}' => $private_messages['msg_id'],
		'{past-time}' => getPastTime($private_messages['msg_date']),
		'{date}' => jdate('l j F Y ساعت h:i A', $private_messages['msg_date']),
	));

	if($private_messages['msg_sender'] != member_name)
	{
		$itpl->assign(array(
			'[reply]' => null,
			'[/reply]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[reply\\](.*?)\\[/reply\\]#s', '');
	}
	
	if(!isset($file[2])) set_content('خواندن پیام', $itpl->get_var()); else $tpl->assign('{content}', $itpl->get_var());	
	unset($itpl, $private_messages, $bbcode, $query);
}

function func_account_pm_new()
{
	if(!member) 
		redirect(url('account/login'));

	global $d, $tpl, $page;
	$msg = $success = false;
	$new = get_param($_POST, 'new', null, 1);

	if(is_array($new) && count($new) && isset($new['subject']) && isset($new['receiver']) && isset($new['text']))
	{
		$new['subject'] = filter($new['subject'], 'preview');
		$new['receiver'] = filter($new['receiver'], 'en-num');
		$new['text'] = filter($new['text'], 'preview');

		if(empty($new['subject']))
			$msg .= 'عنوان پیام را فراموش کرده اید!<br>';

		if(empty($new['receiver']))
			$msg .= 'گیرنده پیام را مشخص نکرده اید!<br>';
		else
		{
			if(!member::exists($new['receiver']) || $new['receiver']==member_name)
				$msg .= 'گیرنده پیام معتبر نمي باشد!<br>';
		}

		if(empty($new['text']))
			$msg .= 'متن پیام را ننوشته اید!';

		if(empty($msg))
		{
			$arr = array(
				'msg_sender' => member_name,
				'msg_receiver' => $new['receiver'],
				'msg_subject' => $new['subject'],
				'msg_text' => $new['text'],
				'msg_date' => time(),
			);
			$d->insert("private_messages", $arr);
			if ($d->affectedRows())
			{
				$msg = message('پيام با موفقيت ارسال شد.', 'success');
				refresh(url('account/pm/outbox'), 4);
				$success = true;
			}
			else
			{
				$msg = message("در ذخيره پيام خطايي رخ داده مجدد تلاش كنيد.", "error");
			}
		}
		else
		{
			$msg = message($msg, 'error');
		}
	}

	$page['title'] .= ' &bull; ارسال پیام جدید';

	func_account_menu();
	func_account_pm_menu();

	$receiver = get_param($_GET, 'd');
	$receiver = filter($receiver, 'en-num');
	if(!$success)
	{
		$file = get_tpl(root_dir.'modules/account/html/pm/||new.tpl', template_dir.'||account/pm/new.tpl');
		$itpl = new template($file[1], $file[0]);
		$itpl->assign(array(
			'{subject}' => isset($new['subject'])? $new['subject'] : false,
			'{receiver}' => isset($new['receiver'])? $new['receiver'] : $receiver,
			'{textarea}' => wysiwyg_textarea('new[text]', isset($new['text'])? $new['text'] : null, 'BBcode'),
		));
		
		if(!empty($msg))
		{
			$itpl->assign(array(
				'{message}' => $msg,
				'[message]' => null,
				'[/message]' => null,
			));
		}
		else
		{
			$itpl->block('#\\[message\\](.*?)\\[/message\\]#s', '');
		}
		
		$html = $itpl->get_var();
	}
	else
	{
		$html = $msg;
	}

	if(!isset($file[2])) set_content('ارسال پیام جدید', $html); else $tpl->assign('{content}', $html);	
	unset($html, $itpl, $private_messages, $query);
}

function func_account_pm_remove()
{
	if(!member) 
		redirect(url('account/login'));

	global $d, $tpl, $page;
	$id = get_param($_GET, 'd', 0);

	$query = sprintf("SELECT * FROM #__private_messages WHERE `msg_id`='%d' AND (`msg_receiver`='%s' OR `msg_sender`='%s') LIMIT 1", $id, member_name, member_name);
	$private_messages = $d->fetch($query, 'assoc', true);

	if(!is_array($private_messages) || !count($private_messages)) 
		redirect(url('account/pm'));

	if($private_messages['msg_receiver']==member_name || ($private_messages['msg_sender']==member_name && $private_messages['msg_read']==0))
	{
		$where = sprintf("`msg_id`='%d' AND (`msg_receiver`='%s' OR `msg_sender`='%s')", $id, member_name, member_name);
		$d->delete('private_messages', $where, 1);
		redirect(url('account/pm'));
	}

	$page['title'] .= ' &bull; حذف پیام';

	func_account_menu();
	func_account_pm_menu();
	set_content('حذف پیام', message('متاسفيم كاربر گيرنده اين پيام را خوانده است و فقط او مي توانيد اين پيام را حذف كند.', 'error'));
	unset($private_messages, $query);
}

function func_account_pm_unread_messages()
{
	global $d, $cache;
	if(!isset($cache['pm']['unread-messages']) || !is_numeric($cache['pm']['unread-messages']))
	{
		$query = sprintf("SELECT COUNT(`msg_id`) AS num FROM `#__private_messages` WHERE `msg_receiver`='%s' AND `msg_read`='0' LIMIT 1", member_name);
		$d->query($query);
		$num = $d->fetch();
		$cache['pm']['unread-messages'] = intval($num['num']);	
	}
	return $cache['pm']['unread-messages'];
}

function func_account_pm_menu()
{
	$num = account_messages();
	$file = get_tpl(root_dir.'modules/account/html/pm/||menu.tpl', template_dir.'||account/pm/menu.tpl');
	$itpl = new template($file[1], $file[0]);

	if($num['newpms']>=1)
	{
		$itpl->assign(array(
			'{unread-messages}' => $num['newpms'],
			'[unread-messages]' => null,
			'[/unread-messages]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[unread-messages\\](.*?)\\[/unread-messages\\]#s', '');
	}

	if(!isset($file[2])) set_content('دسترسی سریع', $itpl->get_var()); else $tpl->assign('{content}', $itpl->get_var());	
	unset($itpl, $num);
}

?>