<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function module_contact_us_run()
{
	global $page, $d, $options, $member_groups, $member;
	$member = member::is('info');

	$q = null;
	foreach($member_groups as $m)
	{
		if($m['group_admin']!=1) continue;
		$q .= " OR `member_group`='".intval($m['group_id'])."'";
	}
	$q = ltrim($q, ' OR');
	
	$d->query("SELECT `member_name`, `member_alias`, `member_email` FROM `#__members` WHERE {$q} ORDER BY `member_id` DESC");
	while($m = $d->fetch())
	{
		$members[$m['member_name']] = array(
			'alias' => empty($m['member_alias'])? $m['member_name'] : $m['member_alias'],
			'email' => $m['member_email']
		);
	};
	unset($m, $q);

	$contact = get_param($_POST, 'contact-us');
	if (isset($contact) && is_array($contact) && count($contact))
	{
		$message = null;
		$contact['name'] = filter($contact['name'], 'preview');
		$contact['receiver'] = filter($contact['receiver'], 'en-num');
		$contact['email'] = filter($contact['email'], 'safe');
		$contact['website'] = $contact['website']=='http://'? null : filter($contact['website'], 'safe');
		$contact['message'] = filter($contact['message'], 'preview');
	
		if(empty($contact['name']))
		{
			$message .= 'نام خود را ننوشته اید!<br>';
		}
	
		if(!validate_email_format($contact['email']))
		{
			$message .= 'ایمیل وارد شده معتبر نیست!<br>';
		}
		
		if(!empty($contact['website']) && !validate_url($contact['website']))
		{
			$message .= 'وبسایت وارد شده معتبر نیست!<br>';
		}
		
		if(!isset($members[$contact['receiver']]))
		{
			$message .= 'گیرنده پیام معتبر نیست!<br>';
		}
		
		if(empty($contact['message']))
		{
			$message .= 'متن پیام را ننوشته اید!<br>';
		}
		
		if(!validate_captcha('contact-us', $contact['captcha']))
		{
			$message .= 'کد امنیتی صحیح نمی باشد!<br>';
		}
		
		if(empty($message))
		{
			$Body  = 'ارسال کننده: <b>'.$contact['name'].'</b><br>';
			$Body .= 'وبسایت: <b dir="ltr">'.$contact['website'].'</b><br>';
			$Body .= 'متن پیام: <br>'.nl2br($contact['message']).'<br>';
			$Body .= '<hr><b>این پیام از طریق بخش تماس با ما ارسال شده است</b>';
			if(send_mail($members[$contact['receiver']]['email'], 'تماس از سایت '.$options['title'], $Body, $options['mail']))
			{
				echo message('پیام شما با موفقیت ارسال شد.', 'success');
				echo '<script>parsnuke.hideID("form-contact-us")</script>';
				un_set_cookie('security_code_contact-us');
			}
			else
			{
				echo message('متاسفانه در ارسال پیام خطایی رخ داده!', 'error');
			}
		}
		else
		{
			echo message($message, 'error');
		}
		die;
	}
	
	$page['title'] .= ' &bull; تماس با ما';
	$page['meta']['canonical'] = url('contact-us');

	$file = get_tpl(root_dir.'modules/contact-us/html/||form.tpl', template_dir.'||contact-us.tpl');
	$itpl = new template($file[1], $file[0]);

	if(isset($members) && is_array($members) && count($members))
	{
		foreach($members as $m=>$a)
		{
			$itpl->add_for('receiver', array(
				'{name}' => $m,
				'{alias}' => $a['alias'],
			));
		}
	}

	$itpl->assign(array(
		'{name}' => member? (empty($member['member_alias'])? $member['member_name'] : $member['member_alias']) : null,
		'{email}' => member? $member['member_email'] : null,
		'{website}' => member? (empty($member['member_web'])? 'http://' : $member['member_web']) : 'http://',
		'{captcha}' => create_captcha('contact-us'),
		'[form]' => null,
		'[/form]' => null,
	));

	if(!isset($file[2])) set_content('تماس با ما', $itpl->get_var()); else $tpl->assign('{content}', $itpl->get_var());	
	unset($itpl, $members, $m, $a);
}

function module_contact_us_sitemap(&$sitemap)
{
	$sitemap->addItem(url('contact-us'), 0, 'never', '0.6');
}

?>