<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function block_counter($op = null, $id = null, $position= null)
{
	if($op=='remove-cache') // admin
	{
		return true;
	}
	global $d, $cache;

	if(!isset($cache['block-counter']) || !is_array($cache['block-counter']) || !count($cache['block-counter']))
	{
		$t = strtotime(date('Y-m-d'));
		$t2 = strtotime(date('Y-m-d').' -1 days');
		$t3 = strtotime(date('Y-m-d').' +1 days');

		$result  = "SELECT (SELECT COUNT(*) FROM `#__members`) membersCount,".n;
		$result .= "(SELECT COUNT(`member_id`) FROM `#__members` WHERE `member_date` BETWEEN '$t2' AND '$t') membersYesterday,".n;
		$result .= "(SELECT COUNT(`member_id`) FROM `#__members` WHERE `member_date` BETWEEN '$t' AND '$t3') membersToday,".n;
		$result .= "(SELECT COUNT(`member_id`) FROM `#__members` WHERE `member_date` BETWEEN '".strtotime(date('Y-m'))."' AND '".strtotime(date('Y-m').' +1 month')."') membersMonth,".n;
		$result .= "(SELECT MAX(`member_id`) FROM `#__members`) memberNewID,".n;
		$result .= "(SELECT `member_name` FROM `#__members` WHERE `member_id`=memberNewID) memberNewName,".n;
		$result .= "(SELECT COUNT(`post_id`) FROM `#__posts` WHERE post_approve='1' AND post_date <= '".time_now."') postsCount,".n;
		$result .= "(SELECT COUNT(*) FROM `#__comments`) commentsCount,".n;
		$result .= is_module('simple-links')? "(SELECT COUNT(`link_id`) FROM `#__simple_links` WHERE `link_active`='1') linksCount,".n : null;
		$result .= is_module('newsletter')? "(SELECT COUNT(*) FROM `#__newsletter`) newsletterCount,".n : null;
		$result .= "(SELECT `counter_value` FROM `#__counter` WHERE `counter_name`='Total') totalCount,".n;
		$result .= "(SELECT `counter_value` FROM `#__counter` WHERE `counter_name`='Year-".jdate('Y')."') yearCount,".n;
		$result .= "(SELECT `counter_value` FROM `#__counter` WHERE `counter_name`='Month-".jdate('Y-m')."') monthCount,".n;
		$result .= "(SELECT `counter_value` FROM `#__counter` WHERE `counter_name`='Day-".jdate('Y-m-d')."') dayCount;".n;

		$result = $d->query($result);
		$cache['block-counter'] = $d->fetch($result);
	}
	$result = &$cache['block-counter'];

	$html  = '<ul id="parsnuke-block-counter">'.n;
	$html .= '<li id="counter-membersToday">کاربران عضو شده امروز: <b>'.$result['membersToday'].'</b></li>'.n;
	$html .= '<li id="counter-membersYesterday">کاربران عضو شده دیروز: <b>'.$result['membersYesterday'].'</b></li>'.n;
	$html .= '<li id="counter-membersMonth">کاربران عضو شده ماه: <b>'.$result['membersMonth'].'</b></li>'.n;
	$html .= '<li id="counter-membersCount">تعداد کل کاربران: <b>'.$result['membersCount'].'</b></li>'.n;	
	$html .= '<li id="counter-postsCount">تعداد کل پست ها: <b>'.$result['postsCount'].'</b></li>'.n;
	$html .= '<li id="counter-commentsCount">تعداد کل نظرات: <b>'.$result['commentsCount'].'</b></li>'.n;
	$html .= isset($result['linksCount'])? '<li id="counter-linksCount">تعداد تبادل لینک: <b>'.$result['linksCount'].'</b></li>'.n : null;
	$html .= isset($result['newsletterCount'])? '<li id="counter-newsletterCount">تعداد اعضا خبرنامه: <b>'.$result['newsletterCount'].'</b></li>'.n : null;
	$html .= '<li id="counter-dayCount">بازدید امروز: <b>'.$result['dayCount'].'</b></li>'.n;
	$html .= '<li id="counter-monthCount">بازدید ماه: <b>'.$result['monthCount'].'</b></li>'.n;
	$html .= '<li id="counter-yearCount">بازدید سال: <b>'.$result['yearCount'].'</b></li>'.n;
	$html .= '<li id="counter-totalCount">بازدید کل: <b>'.$result['totalCount'].'</b></li>'.n;
	$html .= '</ul>';
	return $html;
}

function module_counter_run()
{
	global $d, $options, $member;
	require_once(root_dir.'modules/counter/functions.php');
	$_GET['b'] = get_param($_GET, 'b');
	switch($_GET['b'])
	{
		case 'browser':
		if(isset($_GET['c']))
			func_counter_browser_version();
		else
			func_counter_browser();
		break;

		case 'os':
		if(isset($_GET['c']))
			func_counter_os_version();
		else
			func_counter_os();
		break;

		case 'robots':
		func_counter_robots();
		break;
		
		case 'month':
		func_counter_month();
		break;

		case 'day':
		func_counter_day();
		break;

		case 'year':
		default:
		func_counter_year();
		break;
	}
}

function module_counter_update()
{
	global $d;
	require_once(root_dir.'modules/counter/lib/counter.class.php');
	$counter = counter::analyse_user_agent();

	if($counter['robot'] !== FALSE)
	{
		$counter['browser'] = 'Bot';
		$counter['browser'] = 'robot.png';
		$counter['browser_version'] = FALSE;
	}
	$counter = $d->escapeString($counter);

	$query  = "SELECT `counter_name` FROM `#__counter` WHERE ";
	$query .= !empty($counter['browser_version'])? "(`counter_name`='Browser-".$counter['browser']."' AND `counter_version`='".$counter['browser_version']."') OR " : null;
	$query .= !empty($counter['os_version'])? "(`counter_name`='OS-".$counter['os']."' AND `counter_version`='".$counter['os_version']."') OR " : null;
	$query .= "(`counter_name`='Year-".jdate('Y')."') OR ";
	$query .= "(`counter_name`='Month-".jdate('Y-m')."') OR ";
	$query .= "(`counter_name`='Day-".jdate('Y-m-d')."')";
 	$d->query($query);
	while($date = $d->fetch())
	{
		if($date['counter_name'] == 'Browser-'.$counter['browser'])
			$TEST_Browser = true;
		elseif($date['counter_name'] == 'OS-'.$counter['os'])
			$TEST_OS = true;
		elseif($date['counter_name'] == 'Year-'.jdate('Y'))
			$TEST_Year = true;
		elseif($date['counter_name'] == 'Month-'.jdate('Y-m'))
			$TEST_Month = true;
		elseif($date['counter_name'] == 'Day-'.jdate('Y-m-d'))
			$TEST_Day = true;
	};

	if(!isset($TEST_Browser) && !empty($counter['browser_version']))
	{
		$d->insert('counter', array('counter_name'=>'Browser-'.$counter['browser'], 'counter_value'=>'0', 'counter_version'=>$counter['browser_version']));
	}

	if(!isset($TEST_OS) && !empty($counter['os_version']))
	{
		$d->insert('counter', array('counter_name'=>'OS-'.$counter['os'], 'counter_value'=>'0', 'counter_version'=>$counter['os_version']));
	}

	if(!isset($TEST_Year))
	{
	   $d->insert('counter', array('counter_name'=>'Year-'.jdate('Y'), 'counter_value'=>'0'));
	}

	if(!isset($TEST_Month))
	{
	   $d->insert('counter', array('counter_name'=>'Month-'.jdate('Y-m'), 'counter_value'=>'0'));
	}

	if(!isset($TEST_Day))
	{
	   $d->insert('counter', array('counter_name'=>'Day-'.jdate('Y-m-d'), 'counter_value'=>'0'));
	}

	unset($query, $date, $TEST_Browser, $TEST_OS, $TEST_Year, $TEST_Month, $TEST_Day);

	/* Save on the databases the obtained values */

 	$query  = "UPDATE `#__counter` SET `counter_value`=`counter_value`+1 WHERE ";
	$query .= "(counter_name='Browser-".$counter['browser']."' AND counter_version='') OR ";
	$query .= !empty($counter['browser_version'])? "(counter_name='Browser-".$counter['browser']."' AND counter_version='".$counter['browser_version']."') OR " : null;
	$query .= "(counter_name='OS-".$counter['os']."' AND counter_version='') OR ";
	$query .= !empty($counter['os_version'])? "(counter_name='OS-".$counter['os']."' AND counter_version='".$counter['os_version']."') OR " : null;
	$query .= !empty($counter['robot'])? "(counter_name='Robot-".$counter['robot']."' AND counter_version='') OR (counter_name='Browser-Bot' AND counter_version='') OR " : null;
	$query .= "(counter_name='Total') OR ";
	$query .= "(counter_name='Year-".jdate('Y')."') OR ";
	$query .= "(counter_name='Month-".jdate('Y-m')."') OR ";
	$query .= "(counter_name='Day-".jdate('Y-m-d')."')";
 	$d->query($query);
	unset($total, $query, $counter);
	
	/* session */
	
 	$d->delete('session', "`session_time` <= '".(time()-3600)."'");	
	$ip = get_ip();
	if(!empty($ip))
	{
		$page = filter($_SERVER['REQUEST_URI'], 'safe');
		$page = ltrim($page, '/');
		$dirname = trim(my_path(), '/');

		if($dirname != '')
		{
			$strlen = strlen($dirname) + 1;
			if(substr($page, 0, $strlen) == $dirname.'/')
			{
				$page = substr($page, $strlen);
			}
			else
			{
				$strlen = strlen($dirname);
				if(substr($page, 0, $strlen) == $dirname) 
					$page = substr($page, $strlen);
			}
		}	

		if(member) 
		{
			$member = member_name;
			$guest = 0;
		}
		else 
		{
			$member = $ip;
			$guest = 1;
		}
		
		$query = "SELECT `session_ip` FROM `#__session` WHERE `session_member`='".$d->escapeString($member)."' OR `session_ip`='".$d->escapeString($ip)."'";
		if($d->numRows($query, true) <= 0) 
		{
			$d->insert('session', array(
				'session_member' => $member,
				'session_ip' => $ip,
				'session_guest' => $guest,
				'session_page' => $page,
				'session_time' => time(),
			));
		}
		else
		{
			$d->update('session', array(
				'session_member' => $member,
				'session_ip' => $ip,
				'session_guest' => $guest,
				'session_page' => $page,
				'session_time' => time(),
			), "`session_member`='".$d->escapeString($member)."' OR `session_ip`='".$d->escapeString($ip)."'", 1);	
		}
	}
	unset($ip, $member, $guest, $page, $dirname, $query, $strlen);
}

function module_counter_sitemap(&$sitemap)
{
	$sitemap->addItem(url('counter/browser'), 0, 'daily', '0.1');
	$sitemap->addItem(url('counter/os'), 0, 'daily', '0.1');
	$sitemap->addItem(url('counter/robots'), 0, 'daily', '0.1');
	$sitemap->addItem(url('counter/year'), 0, 'daily', '0.1');
}

?>