<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function func_counter_chart($chartType, $chartTitle, $chartValue, $chartcolor)
{
	member::check_admin_page_access('counter') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	include_once root_dir .'engine/openChart/data.php';
	$chartTitle = urldecode('ParsNuke CMS is a Free Software - '.$chartTitle);
	switch($chartType)
	{
		case "bar":
		// ----- BAR CHART ----------
		$bar = new bar_value(5);
		$bar->set_colour( '#900000' );
		$bar->set_tooltip('Hello<br>#val#');
		$title = new title($chartTitle );
		$bar = new bar_3d();
		$bar->set_values( $chartValue );
		$bar->colour = '#D54C78';
		$x_axis = new x_axis();
		$x_axis->set_3d( 5 );
		$x_axis->colour = '#909090';
		$x_axis->set_labels( $chartValue );
		$y = new y_axis();
		$y->set_range( 0, 10000);
		$chart = new open_flash_chart();
		$chart->set_y_axis( $y );
		$chart->set_title( $title );
		$chart->add_element( $bar );
		$chart->set_x_axis( $x_axis );
		echo $chart->toPrettyString();
		break;

		case "pie":
		$pie = new pie();
		$pie->start_angle(35)
		->add_animation( new pie_fade() )
		->add_animation( new pie_bounce(10) )
		->label_colour('#000033') // <-- uncomment to see all labels set to blue
		->gradient_fill()
		->tooltip('#val# از #total#<br>#percent#')
		->colours($chartcolor);
		$pie->set_values( $chartValue );
		$chart = new open_flash_chart();
		$chart->add_element( $pie );
		echo $chart->toPrettyString();
		break;

		case "line":
		$default_dot = new dot();
		$default_dot->size(5)->colour('#DFC329');
		$line_dot = new line();
		$line_dot->set_default_dot_style($default_dot);
		$line_dot->set_width( 4 );
		$line_dot->set_colour( '#DFC329' );
		$line_dot->set_values( $chartValue );
		$line_dot->set_key( "$chartTitle", 10 );
		$y = new y_axis();
		$y->set_range( 0, 1000);
		$chart = new open_flash_chart();
		$chart->set_title( new title( $chartTitle ) );
		$chart->set_y_axis( $y );
		$chart->add_element( $line_dot );
		echo $chart->toPrettyString();
		break;
	}
	die;
}

?>