<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function module_m_run()
{
	global $d, $options, $page, $tpl;
	require_once(root_dir.'modules/posts/functions.php');
	$page['title'] .= ' &bull; نسخه موبایل';

	$b = get_param($_GET, 'b', 'page');
	if(!is_numeric($b))
	{
		require_once(engine_dir.'pagination.class.php');
		if(file_exists(template_dir.'mobile/index.tpl'))
		{
			$tpl->load('mobile/index.tpl');
		}
		else
		{
			$tpl->base_dir = root_dir.'modules/m/html/';
			$tpl->load('index.tpl');
		}
		$get_p = get_param($_GET, 'c', 1);
		$total = $d->numRows("SELECT `post_id` FROM `#__posts` WHERE `post_approve` = '1' AND `post_date` <= '".time_now."'", true);
		$pagination = new pagination($total, 40, $get_p);
		$query = func_posts_query(null, 'LIMIT '.$pagination->Start.', '.$pagination->End);
		$posts = $d->get_row($query, 'assoc');

		if(is_array($posts) && count($posts))
		{
			if($get_p > 1 && $pagination->Pages >= $get_p)
				$page['title'] .= ' &bull; صفحه '.Convertnumber2farsi($get_p);
			
			if($pagination->Pages<$get_p || $get_p<=1)
				$page['meta']['canonical'] = url('m');
			else
				$page['meta']['canonical'] = url('m/page/'.$get_p);
			
			foreach($posts as $post)
			{
				$tpl->add_for('posts', array(
					'{odd-even}' => odd_even(),
					'{id}' => $post['post_id'],
					'{url}' => url('m/'.$post['post_id']),
					'{title}' => $post['post_title'],
					'{author}' => empty($post['member_alias'])? $post['post_author'] : $post['member_alias'],
					'replace' => array(
						'|{date format=[\'"](.+?)[\'"]}|es' => 'jdate("\\1", "'.$post['post_date'].'")',
					),
				));
			}
			
			$p = $pagination->build(url('m/page/{page}'), true);
			if(is_array($p) && count($p)) 
			{
				foreach($p as $link) 
				{
					if(!isset($link['page'])) continue;

					$tpl->add_for('pages', array(
						'{number}' => $link['number'],
						'{url}' => $link['url'],
						'replace' => array(
							'#\\[selected\\](.*?)\\[/selected\\]#s' => $link['number']==$get_p? '\\1' : '',
						),
					));
				}

				$tpl->assign(array(
					'[pages]' => null,
					'[/pages]' => null,
				));
			}
			else
			{
				$tpl->block('#\\[pages\\](.*?)\\[/pages\\]#s', '');
			}
		}
		
		if(isset($tpl->foreach['posts']))
		{
			$tpl->assign(array(
				'[posts]' => null,
				'[/posts]' => null,
			));
			$tpl->block('#\\[not-posts\\](.*?)\\[/not-posts\\]#s', '');
		}
		else
		{
			$tpl->assign(array(
				'[not-posts]' => null,
				'[/not-posts]' => null,
			));
			$tpl->block('#\\[posts\\](.*?)\\[/posts\\]#s', '');
		}
	}
	else
	{
		if(file_exists(template_dir.'mobile/single.tpl'))
		{
			$tpl->load('mobile/single.tpl');
		}
		else
		{
			$tpl->base_dir = root_dir.'modules/m/html/';
			$tpl->load('single.tpl');
		}

		$query = func_posts_query("AND posts.post_id='".intval($b)."'", 'LIMIT 1');
		$post = $d->get_row($query, 'assoc');

		if(is_array($post[0]) && is_array($post[0]) && count($post[0]))
		{
			$page['title'] .= ' &bull; '.filter($post[0]['post_title'], 'safe');
			$page['meta']['description'] = $post[0]['post_title'].' - '.$page['meta']['description'];

			if(!empty($post[0]['myTag']))
				$page['meta']['keywords'] = $post[0]['myTag'].' - '.$page['meta']['keywords'];

			$page['meta']['canonical'] = url('posts/'.$post[0]['post_id'].url('/'.$post[0]['post_name'], 1));
		
			$tpl->assign(array(
				'{id}' => $post[0]['post_id'],
				'{url}' => url('m/'.$post[0]['post_id']),
				'{title}' => $post[0]['post_title'],
				'{text}' => $post[0]['post_text'].$post[0]['post_more'],
				'{author}' => empty($post[0]['member_alias'])? $post[0]['post_author'] : $post[0]['member_alias'],
				'[post]' => null,
				'[/post]' => null,
			));

			$tpl->block('|{date format=[\'"](.+?)[\'"]}|es', 'jdate("\\1", "'.$post[0]['post_date'].'")');
			$tpl->block('#\\[not-post\\](.*?)\\[/not-post\\]#s', '');
		}
		else
		{
			$page['title'] .= ' &bull; یافت نشد!';
			$page['meta']['canonical'] = url('m');
			$tpl->assign(array(
				'[not-post]' => null,
				'[/not-post]' => null,
			));
			$tpl->block('#\\[post\\](.*?)\\[/post\\]#s', '');
		}
	}

	unset($pagination, $posts, $total, $query, $get_p);
	define('no_blocks', true);
}

?>