<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function module_newsletter_info()
{
	return array(
		'name' => 'newsletter',
		'version' => '1.0',
		'creationDate' => '2012-07-21 18:00:03',
		'description' => 'ماژول خبرنامه برای پارس نیوک.',
		'author' => 'iman moodi',
		'authorEmail' => 'imanmoodi@yahoo.com',
		'authorUrl' => 'http://parsnuke.com',
		'license' => 'GNU/GPL',
	);
}

function module_newsletter_install()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->query("
		CREATE TABLE IF NOT EXISTS `#__newsletter` (
		  `mail` varchar(300) NOT NULL,
		  PRIMARY KEY  (`mail`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8;
	");
	$d->insert('modules', array(
		'module_name' => 'newsletter',
		'module_version' => '1.0',
		'module_status' => '0',
	));
	echo message('ماژول خبرنامه با موفقیت نصب شد.', 'success');
}

function module_newsletter_uninstall()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->query("DROP TABLE `#__newsletter`");
	$d->delete('modules', "module_name='newsletter'", 1);
	$d->delete('admin', "admin_rights='newsletter'", 1);
	echo message('ماژول خبرنامه با موفقیت حذف شد.', 'success');
}

function module_newsletter_active()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->update('modules', array('module_status'=>1), "module_name='newsletter'", 1);

	$d->insert('admin', array(
		'admin_rights' => 'newsletter',
		'admin_image' => 'engine/images/admin/clean.png',
		'admin_title' => 'خبرنامه',
		'admin_link' => '?a={admin-page}&b=mod&c=newsletter',
		'admin_page' => '1',
	));
	echo message('ماژول خبرنامه فعال شد.', 'success');
}

function module_newsletter_inactive()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->update('modules', array('module_status'=>0), "module_name='newsletter'", 1);
	$d->delete('admin', "admin_rights='newsletter'", 1);
	echo message('ماژول خبرنامه غیرفعال شد.', 'success');
}

function module_newsletter_admin()
{
	member::check_admin_page_access('newsletter') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	require_once(root_dir.'modules/newsletter/functions.admin.php');

	$_GET['do'] = get_param($_GET, 'do');
	switch($_GET['do'])
	{
		case 'new':
		admin_newsletter_new();
		break;

		case 'member':
		admin_newsletter_member();
		break;
		
		case 'delete':
		admin_newsletter_delete();
		break;
		
		default:
		admin_newsletter_index();
		break;
	}
}

?>