<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

member::check_admin_page_access('newsletter') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');

function admin_newsletter_index()
{
	global $options, $page, $d, $tpl;
	member::check_admin_page_access('newsletter') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	require_once(engine_dir.'pagination.class.php');

	$page['title'] .= ' &bull; خبرنامه';

	$order = get_param($_GET, 'order', 'DESC');
	$order = $order=='DESC'? 'DESC' : 'ASC';
	
	$total = get_param($_GET, 'total', 20);
	$total = $total<=0? 20 : $total;

	$_page = get_param($_GET, 'page', 1);
	$_page = $_page<=0? 1 : $_page;

	$total_posts = $d->numRows("SELECT `mail` FROM `#__newsletter`", true);

	$pagination = new pagination($total_posts, $total, $_page);

	$itpl = new template('modules/newsletter/html/admin/index.tpl');

	if(is_ajax())
	{
		$d->query("SELECT * FROM #__newsletter ORDER BY mail $order LIMIT $pagination->Start, $pagination->End");
		if($d->numRows()>=1)
		{
			while($data = $d->fetch()) 
			{
				$itpl->add_for('list', array(
					'{odd-even}' => odd_even(),
					'{mail}' => $data['mail'],
				));
			}
			$itpl->assign(array(
				'[list]' => null,
				'[/list]' => null,
			));
			$itpl->block('#\\[not-list\\](.*?)\\[/not-list\\]#s', '');
		}
		else
		{
			$itpl->assign(array(
				'[not-list]' => null,
				'[/not-list]' => null,
			));
			$itpl->block('#\\[list\\](.*?)\\[/list\\]#s', '');
		}

		$p = $pagination->build('{page}', true);
		if(is_array($p) && count($p)) 
		{	
			foreach($p as $link) 
			{
				if(!isset($link['page'])) continue;

				$itpl->add_for('pages', array(
					'{number}' => $link['number'],
					'replace' => array(
						'#\\[selected\\](.*?)\\[/selected\\]#s' => $link['number']==$_page? '\\1' : '',
					),
				));
			}

			$itpl->assign(array(
				'[pages]' => null,
				'[/pages]' => null,
			));
		}
		else
		{
			$itpl->block('#\\[pages\\](.*?)\\[/pages\\]#s', '');
		}
	}
	
	if($order=='DESC')
	{
		$itpl->assign(array(
			'[desc]' => null,
			'[/desc]' => null,
		));
		$itpl->block('#\\[asc\\](.*?)\\[/asc\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[asc]' => null,
			'[/asc]' => null,
		));
		$itpl->block('#\\[desc\\](.*?)\\[/desc\\]#s', '');
	}
	
	$itpl->assign(array(
		'{total}' => $total,
		'{textarea-1}' => wysiwyg_textarea('newsletter[text-1]', null),
		'{textarea-2}' => wysiwyg_textarea('newsletter[text-2]', null),
		'{members-0}' => $d->numRows("SELECT `member_id` FROM `#__members` WHERE `member_newsletter`='0'", true),
		'{members-1}' => $d->numRows("SELECT `member_id` FROM `#__members` WHERE `member_newsletter`='1'", true),
	));
	
	if(is_ajax())
	{
		define('no_template', true);
		$itpl->assign(global_tags());
		$itpl->display();
	}
	else
		$tpl->assign('{content}', $itpl->get_var());
}

function admin_newsletter_new()
{
	member::check_admin_page_access('newsletter') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	global $options, $page, $d;
	$newsletter = get_param($_POST, 'newsletter', null, 1);
	$newsletter['title'] = filter($newsletter['title'], 'preview');

	if(empty($newsletter['text-1']))
		$msg = 'متن خبرنامه را ننوشته اید!<br>';
	
	if(empty($newsletter['title']))
		$msg = 'عنوان خبرنامه را ننوشته اید!<br>';
	
	if(!empty($msg))
	{
		echo message($msg, 'error');
	}
	else
	{
		$send = $error = 0;
		$d->query("SELECT * FROM #__newsletter ORDER BY mail DESC");
		while($data = $d->fetch()) 
		{
			$Body = '<h2>'.$newsletter['title'].'</h2><br>'.stripslashes($newsletter['text-1']);
			if(send_mail($data['mail'], 'خبرنامه سایت '.$options['title'], $Body, $options['mail']))
			{
				$send++;
			}
			else
			{
				$error++;
			}
		}
		echo message($send.' خبرنامه با موفقیت ارسال شد و '.$error.' مورد در ارسال با خطا مواجه شد.', 'info');
		echo '<script>parsnuke.hideID("New-newsletter-form")</script>';
	}
	die;
}

function admin_newsletter_member()
{
	member::check_admin_page_access('newsletter') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	global $options, $page, $d;
	$newsletter = get_param($_POST, 'newsletter', null, 1);
	$newsletter['title'] = filter($newsletter['title'], 'preview');
	$newsletter['all'] = !isset($newsletter['all']) || intval($newsletter['all'])<=0? 0 : 1;

	if(empty($newsletter['text-2']))
		$msg = 'متن خبرنامه را ننوشته اید!<br>';
	
	if(empty($newsletter['title']))
		$msg = 'عنوان خبرنامه را ننوشته اید!<br>';
	
	if(!empty($msg))
	{
		echo message($msg, 'error');
	}
	else
	{
		$send = $error = 0;
		$d->query("SELECT `member_email` FROM #__members ".($newsletter['all']==0? "WHERE `member_newsletter`='1'" : null)." ORDER BY `member_id` DESC");
		while($data = $d->fetch()) 
		{
			$Body  = '<h2>'.$newsletter['title'].'</h2><br>'.stripslashes($newsletter['text-2']);
			$Body .= '<font size="1"><br>این پیام از طریق بخش خبرنامه اختصاصی اعضا ارسال شده است.';
			$Body .= '<br>در صورتی که مایل به دریافت آن نیستید می توانید از تنظیمات پروفایل خود آن را غیرفعال کنید.</font>';
			if(send_mail($data['member_email'], 'خبرنامه سایت '.$options['title'], $Body, $options['mail']))
			{
				$send++;
			}
			else
			{
				$error++;
			}
		}
		echo message($send.' خبرنامه با موفقیت ارسال شد و '.$error.' مورد در ارسال با خطا مواجه شد.', 'info');
		echo '<script>parsnuke.hideID("member-newsletter-form")</script>';
	}
	die;
}

function admin_newsletter_delete()
{
	member::check_admin_page_access('newsletter') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	global $tpl, $page, $d;
	
	$_GET['mail'] = get_param($_GET, 'mail');
	$d->query("SELECT * FROM #__newsletter WHERE mail='".$_GET['mail']."' LIMIT 1");
	$row = $d->fetch();

	if(!is_array($row) && !count($row))
		redirect('?a='.admin-page.'&b=mod&c=newsletter');
	
	$d->delete('newsletter', "mail='".$_GET['mail']."'", 1);
	echo message('ایمیل با موفقیت حذف شد.', 'success');
	admin_newsletter_index();
}

?>