<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function module_pages_info()
{
	return array(
		'name' => 'pages',
		'version' => '1.0',
		'creationDate' => '2012-07-21 18:00:03',
		'description' => 'ماژول صفحات اضافی برای پارس نیوک.',
		'author' => 'iman moodi',
		'authorEmail' => 'imanmoodi@yahoo.com',
		'authorUrl' => 'http://parsnuke.com',
		'license' => 'GNU/GPL',
	);
}

function module_pages_install()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->query("
		CREATE TABLE IF NOT EXISTS `#__pages` (
		  `page_id` int(11) NOT NULL auto_increment,
		  `page_title` varchar(300) NOT NULL,
		  `page_slug` varchar(400) NOT NULL,
		  `page_time` int(20) NOT NULL default '0',
		  `page_author` varchar(300) NOT NULL,
		  `page_text` longtext NOT NULL,
		  `page_theme` varchar(200) NOT NULL,
		  `page_view` int(1) NOT NULL default '1',
		  `page_approve` int(1) NOT NULL default '0',
		  PRIMARY KEY  (`page_id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
	");
	$d->insert('modules', array(
		'module_name' => 'pages',
		'module_version' => '1.0',
		'module_status' => '0',
	));
	echo message('ماژول صفحات اضافی با موفقیت نصب شد.', 'success');
}

function module_pages_uninstall()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->query("DROP TABLE `#__pages`");
	$d->delete('modules', "module_name='pages'", 1);
	$d->delete('admin', "admin_rights='pages'", 1);
	echo message('ماژول صفحات اضافی با موفقیت حذف شد.', 'success');
	remove_cache('module-pages', true);
}

function module_pages_active()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->update('modules', array('module_status'=>1), "module_name='pages'", 1);

	$d->insert('admin', array(
		'admin_rights' => 'pages',
		'admin_image' => 'engine/images/admin/posts.png',
		'admin_title' => 'صفحات اضافی',
		'admin_link' => '?a={admin-page}&b=mod&c=pages',
		'admin_page' => '2',
	));
	echo message('ماژول صفحات اضافی فعال شد.', 'success');
}

function module_pages_inactive()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->update('modules', array('module_status'=>0), "module_name='pages'", 1);
	$d->delete('admin', "admin_rights='pages'", 1);
	echo message('ماژول صفحات اضافی غیرفعال شد.', 'success');
}

function module_pages_admin()
{
	member::check_admin_page_access('pages') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	require_once(root_dir.'modules/pages/functions.admin.php');

	$_GET['do'] = get_param($_GET, 'do');
	switch($_GET['do'])
	{
		case 'new':
		admin_pages_new();
		break;

		case 'edit':
		admin_pages_edit();
		break;
		
		case 'approve':
		admin_pages_approve();
		break;

		case 'delete':
		admin_pages_delete();
		break;
		
		default:
		admin_pages_index();
		break;
	}
}

?>