<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function module_pages_run()
{
	global $page, $d, $tpl, $options;
	$id = get_param($_GET, 'b', 0);

	if(!$id)
	{
		$page['title'] .= ' &bull; صفحات';
		$page['meta']['description'] = 'صفحات سایت - '.$page['meta']['description'];
		$page['meta']['canonical'] = url('pages');

		set_content('جدیدترین صفحات', block_pages(array(
			'total' => 500
		), 'list'));
	}
	else
	{		
		if(!$row = get_cache('module-pages-'.md5($id), 2592000))
		{
			$d->query("
				SELECT pages.*,members.member_alias
				FROM #__pages AS pages	
				LEFT JOIN #__members AS members ON members.member_name=pages.page_author
				WHERE pages.page_approve = '1' AND pages.page_id = '".$id."'
				GROUP BY pages.page_id
				ORDER BY pages.page_time DESC, pages.page_id DESC
				LIMIT 1
			");
			$row = $d->fetch();

			if(is_array($row) && count($row))
				set_cache('module-pages-'.md5($row['page_id']), $row);
		}

		if(!isset($row) || !is_array($row) || !count($row))
		{
			module_error_run('404');
		}
		else
		{
			$row['page_theme'] = filter($row['page_theme'], 'en-num');

			if(!empty($row['page_theme']))
				$page['theme'] = $row['page_theme'];
			
			$page['title'] .= ' &bull; '.filter($row['page_title'], 'safe');
			$page['meta']['canonical'] = url('pages/'.$row['page_id'].url('/'.$row['page_slug'], 1));

			if($row['page_view']==2 && !member) $row['page_text'] = message('فقط کاربران عضو سایت می توانند این صفحه را ببینند!', 'error');
			elseif($row['page_view']==3 && member) $row['page_text'] = message('فقط کاربران مهمان می توانند این صفحه را ببینند!', 'error');
			elseif($row['page_view']==4 && !group_admin) $row['page_text'] = message('فقط مدیران می توانند این صفحه را ببینند!', 'error');
			elseif($row['page_view']==5 && !group_super_admin) $row['page_text'] = message('فقط مدیران کل سایت می توانند این صفحه را ببینند!', 'error');
			$row['page_text'] = replace_links($row['page_text']);
			
			if(!file_exists(template_dir.'page.tpl'))
			{
				set_content($row['page_title'], $row['page_text']);
			}
			else
			{
				$itpl = new template('page.tpl', template_dir);
				$itpl->assign(array(
					'{id}' => $row['page_id'],
					'{url}' => url('pages/'.$row['page_id'].url('/'.$row['page_slug'], 1)),
					'{title}' => $row['page_title'],
					'{author}' => empty($row['member_alias'])? $row['page_author'] : $row['member_alias'],
					'{author-profile}' => url('account/profile/'.$row['page_author']),
					'{text}' => $row['page_text'],
					'{theme}' => $row['page_theme']
				));
				$itpl->block('|{date format=[\'"](.+?)[\'"]}|es', 'jdate("\\1", "'.$row['page_time'].'")');
				$tpl->assign('{content}', $itpl->get_var());
				unset($itpl);
			}
		}
	}
}

function module_pages_search($search)
{
	global $d;
	$query  = $search['type']==0 || $search['type']==2? " OR `page_title` LIKE '%".$search['story']."%'" : null;
	$query .= $search['type']==1 || $search['type']==2? " OR `page_text` LIKE '%".$search['story']."%'" : null;
	$query .= !empty($search['author']) && $search['author-full']==0? " OR `page_author` LIKE '%".$search['author']."%'" : null;
	$query .= !empty($search['author']) && $search['author-full']==1? " OR `page_author`='".$search['author']."'" : null;
	$query  = trim($query, ' OR ');
	$query  = "SELECT * FROM #__pages WHERE `page_approve` = '1' AND (".$query.") ORDER BY page_id";
	$query = $d->query($query);
	while($p = $d->fetch($query)) 
	{
		if($p['page_view']==2 && !member) $p['page_text'] = message('فقط کاربران عضو سایت می توانند این صفحه را ببینند!', 'error');
		elseif($p['page_view']==3 && member) $p['page_text'] = message('فقط کاربران مهمان می توانند این صفحه را ببینند!', 'error');
		elseif($p['page_view']==4 && !group_admin) $p['page_text'] = message('فقط مدیران می توانند این صفحه را ببینند!', 'error');
		elseif($p['page_view']==5 && !group_super_admin) $p['page_text'] = message('فقط مدیران کل سایت می توانند این صفحه را ببینند!', 'error');
	
		$d->insert('search', array(
			'search_key' => $search['key'],
			'search_title' => str_replace($search['story'], '<span style="background:#FFCC33;color:#000000">'.$search['story'].'</span>', $p['page_title']),
			'search_author' => $p['page_author'],
			'search_content' => str_replace($search['story'], '<span style="background:#FFCC33;color:#000000">'.$search['story'].'</span>', nl2br(trim(strip_tags($p['page_text'])))),
			'search_date' => $p['page_time'],
			'search_module' => 'pages',
			'search_url' => url('pages/'.$p['page_id'].url('/'.$p['page_slug'], 1)),
			'search_time' => time(),
			'search_keywords' => $search['story']
		));
	}
}

function module_pages_sitemap(&$sitemap)
{
	global $d;
	$query = "SELECT * FROM `#__pages` WHERE `page_approve` = '1' ORDER BY `page_time` DESC, `page_id` DESC";	
	$pages = $d->get_row($query, 'assoc');
	if(is_array($pages) && count($pages))
	{
		foreach($pages as $p)
		{
			$sitemap->addItem(url('pages/'.$p['page_id'].url('/'.$p['page_slug'], 1)), $p['page_time'], 'monthly', '0.7');
		}
	}
	unset($pages, $query, $p);
}

function module_pages_feed(&$feeds)
{
	global $d, $options;
	$query = "SELECT * FROM `#__pages` WHERE `page_approve` = '1' ORDER BY `page_time` DESC, `page_id` DESC LIMIT ".intval($options['feed-limit']);	
	$pages = $d->get_row($query, 'assoc');
	if(is_array($pages) && count($pages))
	{
		foreach($pages as $p)
		{
			$url = url . url('pages/'.$p['page_id'].url('/'.$p['page_slug'], 1));
			$feeds->addItem(new FeedItem($url, $p['page_title'], $url, $p['page_text'], date3339($p['page_time'])));
		}
	}
	unset($pages, $query, $p);
}

function block_pages($op = null, $id = null, $position= null)
{
	if($op=='remove-cache') // admin
	{
		remove_cache('module-pages-block-'.$id);
		return true;
	}
	if(!$rows = get_cache('module-pages-block-'.$id))
	{
		$op['total'] = !isset($op['total']) || $op['total']<=0? 10 : intval($op['total']);
		$op['order'] = !isset($op['order'])? 'DESC' : strtoupper($op['order']);
		$op['order'] = $op['order']!='DESC' && $op['order']!='ASC'? 'DESC' : $op['order'];
		
		global $d;
		$query = "SELECT page_title,page_slug,page_id FROM #__pages WHERE page_approve='1' ORDER BY page_time {$op['order']}, page_id {$op['order']} LIMIT {$op['total']}";
		$rows = $d->get_row($query);
		set_cache('module-pages-block-'.$id, $rows);
	}

	if(is_array($rows) && count($rows))
	{
		$html = '<ul id="parsnuke-block-pages">'.n;
		foreach($rows as $row)
		{
			$row['page_title'] = filter($row['page_title'], 'safe');
			$html .= '<li><a href="'.url('pages/'.$row['page_id'].url('/'.$row['page_slug'], 1)).'">'.$row['page_title'].'</a></li>'.n;
		}
		$html .= '</ul>';
	}
	else
	{
		$html = 'هیچ صفحه ای وجود ندارد!';
	}
	return $html;
}

?>