<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

member::check_admin_page_access('pages') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');

function admin_pages_index()
{
	global $options, $page, $d, $tpl;
	member::check_admin_page_access('pages') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	require_once(engine_dir.'pagination.class.php');

	$page['title'] .= ' &bull; صفحات اضافی';

	$order = get_param($_GET, 'order', 'DESC');
	$order = $order=='DESC'? 'DESC' : 'ASC';
	
	$total = get_param($_GET, 'total', 20);
	$total = $total<=0? 20 : $total;

	$_page = get_param($_GET, 'page', 1);
	$_page = $_page<=0? 1 : $_page;

	$total_posts = $d->numRows("SELECT `page_id` FROM `#__pages`", true);

	$pagination = new pagination($total_posts, $total, $_page);

	$itpl = new template('modules/pages/html/admin/index.tpl');

	$theme = template_info($options['theme']);
	$theme = $theme['pages'];
	$theme = explode(',', $theme);
	$theme2 = array();
	foreach($theme as $t) if(!empty($t) && is_string($t)) $theme2[] = $t;
	if(is_array($theme2) && count($theme2))
	{
		$itpl->add_for('templates', array('{name}' => 'بدون قالب'));
		foreach($theme2 as $t)
		{
			if(!empty($t) && is_string($t))
			{
				$itpl->add_for('templates', array('{name}' => $t));
			}
		}
		$itpl->assign(array(
			'[templates]' => null,
			'[/templates]' => null,
		));
		$itpl->block('#\\[not-templates\\](.*?)\\[/not-templates\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[not-templates]' => null,
			'[/not-templates]' => null,
		));
		$itpl->block('#\\[templates\\](.*?)\\[/templates\\]#s', '');
	}
	unset($theme, $theme2, $t);

	if(is_ajax())
	{
		$d->query("SELECT * FROM #__pages ORDER BY page_id {$order} LIMIT $pagination->Start, $pagination->End");
		if($d->numRows()>=1)
		{
			while($data = $d->fetch()) 
			{
				$itpl->add_for('list', array(
					'{odd-even}' => odd_even(),
					'{id}' => $data['page_id'],
					'{title}' => $data['page_title'],
					'{slug}' => urldecode($data['page_slug']),
					'{author}' => $data['page_author'],
					'{time}' => $data['page_time'],
					'{past-time}' => getPastTime($data['page_time']),
					'{text}' => $data['page_text'],
					'{theme}' => $data['page_theme'],
					'{view}' => $data['page_view'],
					'{approve}' => $data['page_approve'],
					'replace' => array(
						'#\\[approve\\](.*?)\\[/approve\\]#s' => $data['page_approve']==1? '\\1' : '',
						'#\\[not-approve\\](.*?)\\[/not-approve\\]#s' => $data['page_approve']!=1? '\\1' : ''
					)
				));
			}

			$itpl->assign(array(
				'[list]' => null,
				'[/list]' => null,
			));
			$itpl->block('#\\[not-list\\](.*?)\\[/not-list\\]#s', '');
		}
		else
		{
			$itpl->assign(array(
				'[not-list]' => null,
				'[/not-list]' => null,
			));
			$itpl->block('#\\[list\\](.*?)\\[/list\\]#s', '');
		}

		$p = $pagination->build('{page}', true);
		if(is_array($p) && count($p)) 
		{	
			foreach($p as $link) 
			{
				if(!isset($link['page'])) continue;

				$itpl->add_for('pages', array(
					'{number}' => $link['number'],
					'replace' => array(
						'#\\[selected\\](.*?)\\[/selected\\]#s' => $link['number']==$_page? '\\1' : '',
					),
				));
			}

			$itpl->assign(array(
				'[pages]' => null,
				'[/pages]' => null,
			));
		}
		else
		{
			$itpl->block('#\\[pages\\](.*?)\\[/pages\\]#s', '');
		}
	}
	
	if($order=='DESC')
	{
		$itpl->assign(array(
			'[desc]' => null,
			'[/desc]' => null,
		));
		$itpl->block('#\\[asc\\](.*?)\\[/asc\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[asc]' => null,
			'[/asc]' => null,
		));
		$itpl->block('#\\[desc\\](.*?)\\[/desc\\]#s', '');
	}
	
	$itpl->assign(array(
		'{total}' => $total,
		'{textarea}' => wysiwyg_textarea('pages[text]', null),
		'{textarea-edit}' => wysiwyg_textarea('pages[text-edit]', null),
	));
	
	if(is_ajax())
	{
		define('no_template', true);
		$itpl->assign(global_tags());
		$itpl->display();
	}
	else
		$tpl->assign('{content}', $itpl->get_var());
}

function admin_pages_new()
{
	member::check_admin_page_access('pages') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	global $options, $page, $d;
	$pages = get_param($_POST, 'pages', null, 1);
	$pages['title'] = filter($pages['title'], 'preview');
	$pages['slug'] = filter($pages['slug'], 'safe');
	$pages['slug'] = clean_text($pages['slug'], true);
	$pages['theme'] = isset($pages['theme'])? filter($pages['theme'], 'en-num') : null;
	$pages['theme'] = $pages['theme']==''? null : $pages['theme'];
	$pages['view'] = intval($pages['view']);
	$pages['approve'] = intval($pages['approve']);
	
	if(empty($pages['title']))
		$msg = 'عنوان صفحه را ننوشته اید!<br>';
	
	if(empty($pages['slug']))
		$msg = 'نام مستعار را ننوشته اید!';
	
	if(!empty($msg))
	{
		echo message($msg, 'error');
	}
	else
	{
		$d->insert('pages', array(
			'page_title' => $pages['title'],
			'page_slug' => $pages['slug'],
			'page_text' => $pages['text'],
			'page_theme' => $pages['theme'],
			'page_view' => $pages['view'],
			'page_approve' => $pages['approve'],
			'page_author' => member_name,
			'page_time' => time(),
		));

		if($d->affectedRows())
		{
			remove_cache('module-pages-block', true);
			echo message('صفحه با موفقیت ذخیره شد.', 'success');
			echo '<script>parsnuke.hideID("New-Pages-form")</script>';
		}
		else
		{
			echo message('در ذخیره اطلاعات خطایی رخ داده مجدد تلاش کنید!', 'error');
		}
	}
	die;
}

function admin_pages_edit()
{
	member::check_admin_page_access('pages') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	global $tpl, $page, $d, $options;
	
	$_GET['id'] = get_param($_GET, 'id', 0);
	$d->query("SELECT * FROM #__pages WHERE page_id='".$_GET['id']."' LIMIT 1");
	$row = $d->fetch();

	if(!is_array($row) && !count($row))
		redirect('?a='.admin-page.'&b=mod&c=pages');
	
	if($row['page_author']==member_name || group_super_admin==1)
	{
		$pages = get_param($_POST, 'pages', null, 1);
		
		if(is_array($pages) && count($pages))
		{
			$pages['title'] = filter($pages['title'], 'preview');
			$pages['slug'] = filter($pages['slug'], 'safe');
			$pages['slug'] = clean_text($pages['slug'], true);
			$pages['theme'] = isset($pages['theme'])? filter($pages['theme'], 'en-num') : null;
			$pages['theme'] = $pages['theme']==''? null : $pages['theme'];
			$pages['view'] = intval($pages['view']);
			$pages['approve'] = intval($pages['approve']);
			
			if(empty($pages['title']))
				$msg = 'عنوان صفحه را ننوشته اید!<br>';
			
			if(empty($pages['slug']))
				$msg = 'نام مستعار را ننوشته اید!';

			if(!empty($msg))
			{
				echo message($msg, 'error');
			}
			else
			{
				$d->update('pages', array(
					'page_title' => $pages['title'],
					'page_slug' => $pages['slug'],
					'page_text' => $pages['text-edit'],
					'page_theme' => $pages['theme'],
					'page_view' => $pages['view'],
					'page_approve' => $pages['approve'],
				), "page_id='".$_GET['id']."'", 1);
				
				if($d->affectedRows())
				{
					echo message('صفحه با موفقیت ویرایش شد', 'success');
					remove_cache('module-pages-block', true);
					remove_cache('module-pages-'.md5($_GET['id']));
				}
				else
				{
					echo message('در ذخیره اطلاعات خطایی رخ داده مجدد تلاش کنید!', 'error');
				}
			}
		}
	}
	else
	{
		echo message('شما دسترسی لازم برای ویرایش این صفحه را ندارید!', 'error');
	}
	die;
}

function admin_pages_approve()
{
	member::check_admin_page_access('pages') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	global $tpl, $page, $d;
	$_GET['id'] = get_param($_GET, 'id', 0);
	$_GET['approve'] = get_param($_GET, 'approve', 0);
	
	$d->query("SELECT page_author FROM #__pages WHERE page_id='".$_GET['id']."' LIMIT 1");
	$row = $d->fetch();

	if((!is_array($row) || !count($row)) || ($row['page_author']!=member_name && group_super_admin!=1))
		die('شما دسترسی لازم برای ویرایش این صفحه را ندارید!');

	$approve = $_GET['approve']==0? 1 : 0;
	
	$d->update('pages', array(
		'page_approve' => $approve,
	), "`page_id`='{$_GET['id']}'", 1);

	if($d->affectedRows())
	{
		remove_cache('module-pages-block', true);
		remove_cache('module-pages-'.md5($_GET['id']));
		die($approve==1? 'active' : 'inactive');
	}
	else
	{
		die('در ذخیره خطایی رخ داده!');
	}
}

function admin_pages_delete()
{
	member::check_admin_page_access('pages') or pn_die('عدم دسترسی!', 'شما دسترسی لازم برای مشاهده این بخش را ندارید!');
	global $tpl, $page, $d;
	
	$_GET['id'] = get_param($_GET, 'id', 0);
	$d->query("SELECT * FROM #__pages WHERE page_id='".$_GET['id']."' LIMIT 1");
	$row = $d->fetch();

	if(!is_array($row) && !count($row))
		redirect('?a='.admin-page.'&b=mod&c=pages');
	
	if($row['page_author']==member_name || group_super_admin==1)
	{
		$d->delete('pages', "page_id='".$_GET['id']."'", 1);
		remove_cache('module-pages-block', true);
		remove_cache('module-pages-'.md5($_GET['id']));
		echo message('صفحه با موفقیت حذف شد.', 'success');
	}
	else
	{
		echo message('شما دسترسی لازم برای حذف این صفحه را ندارید!', 'error');
	}
	admin_pages_index();
}

?>