<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function posts_options()
{
	if(!$options = get_cache('posts-options', 2592000))
	{
		global $d;
		$d->query("SELECT `option_value` FROM `#__options` WHERE `option_name`='posts' LIMIT 1");
		$result = $d->fetch();
		$d->freeResult();
		$options = maybe_unserialize($result['option_value']);
		set_cache('posts-options', $options);
	}
	return $options;
}

function posts_categories()
{
	global $cache, $d; 
	if(!$cache['posts_categories'] = get_cache('module-posts-categories', 2592000))
	{
		$cache['posts_categories'] = $d->get_row("SELECT * FROM `#__terms` WHERE `term_type`='p-cat'", 'assoc', 'term_id');
		set_cache('module-posts-categories', $cache['posts_categories']);
	}
}

function block_categories($op = null, $id = null, $position= null)
{
	if($op=='remove-cache') return true;
	global $cache;	
	posts_categories();
	if(isset($cache['posts_categories']) && is_array($cache['posts_categories']) && count($cache['posts_categories']))
	{
		$html = '<ul id="parsnuke-block-posts-categories">'.n;
		foreach($cache['posts_categories'] as $cat)
		{
			if($cat['term_parent'] != 0) continue;
			$html .= '<li class="cat-item cat-item-'.$cat['term_id'].'"><a href="'.url('posts/category/'.$cat['term_id'].url('/'.$cat['term_slug'], 1)).'">'.$cat['term_name'].'</a></li>'.n;
			
			$i = 0;
			foreach($cache['posts_categories'] as $cat2)
			{
				if($cat2['term_parent'] != $cat['term_id']) continue;
				if($i == 0) $html .= '<ul class="children">'.n;
				$html .= '<li class="cat-item cat-item-'.$cat2['term_id'].'"><a href="'.url('posts/category/'.$cat2['term_id'].url('/'.$cat2['term_slug'], 1)).'">'.$cat2['term_name'].'</a></li>'.n;
				$i++;
			}
			if($i >= 1)
				$html .= '</ul>'.n;
		}
		$html .= '</ul>'.n;
		unset($cat, $cat2);
	}
	else
	{
		$html = 'بدون موضوع';
	}
	return $html;
}

function block_last_posts($op = null, $id = null, $position= null)
{
	if($op=='remove-cache') // admin
	{
		remove_cache('module-posts-block-last-'.$id);
		return true;
	}
	if(!$rows = get_cache('module-posts-block-last-'.$id))
	{
		$op['total'] = !isset($op['total']) || intval($op['total'])<=0? 10 : intval($op['total']);
		$op['hits'] = !isset($op['hits']) || strtolower($op['hits'])!='true'? false : true;
		$op['order'] = !isset($op['order'])? 'DESC' : strtoupper($op['order']);
		$op['order'] = $op['order']!='DESC' && $op['order']!='ASC'? 'DESC' : $op['order'];
		
		global $d;
		$query = "SELECT post_title,post_name,post_id,post_hits FROM `#__posts` WHERE post_approve='1' AND post_date <= '".time_now."' ORDER BY ".($op['hits']==1? "post_hits {$op['order']}" : "post_date {$op['order']}, post_id {$op['order']}")." LIMIT {$op['total']}";
		$rows = $d->get_row($query);
		set_cache('module-posts-block-last-'.$id, $rows);
	}

	if(is_array($rows) && count($rows))
	{
		$html = '<ul id="parsnuke-block-last-posts">'.n;
		foreach($rows as $row)
		{
			$row['post_title'] = filter($row['post_title'], 'safe');
			if(strlen($row['post_title']) > 30)
			{
				$row['post_title'] = function_exists('mb_substr')? mb_substr($row['post_title'], 0, 28) : substr($row['post_title'], 0, 28);
				$row['post_title'] .= ' ...';
			}
			$html .= '<li><a href="'.url('posts/'.$row['post_id'].url('/'.$row['post_name'], 1)).'">'.$row['post_title'].'</a>'.(isset($op['hits']) && $op['hits']? '<span>&nbsp;'.$row['post_hits'].' بازدید</span>' : null).'</li>'.n;
		}
		$html .= '</ul>';
	}
	else
	{
		$html = 'هیچ پستی وجود ندارد!';
	}
	return $html;
}

function block_posts_comments($op = null, $id = null, $position= null)
{
	if($op=='remove-cache') // admin
	{
		remove_cache('module-posts-comments-block-'.$id);
		return true;
	}
	if(!$rows = get_cache('module-posts-comments-block-'.$id))
	{
		$op['total'] = !isset($op['total']) || intval($op['total'])<=0? 10 : intval($op['total']);
		$op['order'] = !isset($op['order'])? 'DESC' : strtoupper($op['order']);
		$op['order'] = $op['order']!='DESC' && $op['order']!='ASC'? 'DESC' : $op['order'];
		
		global $d;
		$query = "
			SELECT c.*,p.post_name,p.post_title
			FROM #__comments AS c
			LEFT JOIN #__posts AS p ON (p.post_id = c.comment_link)
			WHERE c.comment_type='post' AND c.comment_approve='1'
			GROUP BY c.comment_id
			ORDER BY c.comment_id {$op['order']}
			LIMIT {$op['total']}
		";
		$rows = $d->get_row($query);
		set_cache('module-posts-comments-block-'.$id, $rows);
	}

	if(is_array($rows) && count($rows))
	{
		require_once(engine_dir.'bbcode.class.php');
		$bbcode = new bbcode();

		$html = '<ul id="parsnuke-block-posts-last-comments">'.n;
		foreach($rows as $row)
		{
			$row['comment_text'] = $bbcode->parse($row['comment_text']);
			$row['comment_text'] = nl2br(filter($row['comment_text'], 'safe'));
			if(empty($row['comment_text'])) continue;
			if(strlen($row['comment_text']) > 50)
			{
				$row['comment_text'] = function_exists('mb_substr')? mb_substr($row['comment_text'], 0, 46) : substr($row['comment_text'], 0, 46);
				$row['comment_text'] .= ' ...';
			}
			if(strlen($row['post_title']) > 30)
			{
				$row['post_title'] = function_exists('mb_substr')? mb_substr($row['post_title'], 0, 25) : substr($row['post_title'], 0, 25);
				$row['post_title'] .= ' ...';
			}
			$html .= '<li><b>'.(validate_url($row['comment_author_url'])? '<a href="'.$row['comment_author_url'].'" target="_blank" rel="nofollow">'.$row['comment_author'].'</a>' : $row['comment_author']).'</b><a href="'.url('posts/'.$row['comment_link'].url('/'.$row['post_name'], 1)).'#comment-'.$row['comment_id'].'"> در '.$row['post_title'].' گفته: '.$row['comment_text'].'</a></li>'.n;
		}
		$html .= '</ul>';
	}
	else
	{
		$html = 'هیچ نظری وجود ندارد!';
	}
	return $html;
}

function module_posts_run()
{
	global $d, $options, $member;
	require_once(root_dir.'modules/posts/functions.php');
	$_GET['b'] = get_param($_GET, 'b');
	switch($_GET['b'])
	{
		case 'category':
		if(!isset($_GET['c']) || !is_numeric($_GET['c']))
			module_error_run('404');
		else
			func_posts_category();
		break;
		
		case 'tag':
		if(!isset($_GET['c']) || empty($_GET['c']))
			module_error_run('404');
		else
			func_posts_tag();
		break;
		
		case 'author':
		if(!isset($_GET['c']) || empty($_GET['c']))
			module_error_run('404');
		else
			func_posts_author();
		break;

		case 'pdf':
		if(!isset($_GET['c']) || empty($_GET['c']))
			module_error_run('404');
		else
			func_posts_pdf();
		break;

		default:
		if(!is_numeric($_GET['b']))
			func_posts_index();
		else
			func_posts_single();
		break;
	}
}

function module_posts_search($search)
{
	global $d;
	$query  = $search['type']==0 || $search['type']==2? " OR `post_title` LIKE '%".$search['story']."%'" : null;
	$query .= $search['type']==1 || $search['type']==2? " OR `post_text` LIKE '%".$search['story']."%' OR `post_more` LIKE '%".$search['story']."%'" : null;
	$query .= !empty($search['author']) && $search['author-full']==0? " OR `post_author` LIKE '%".$search['author']."%'" : null;
	$query .= !empty($search['author']) && $search['author-full']==1? " OR `post_author`='".$search['author']."'" : null;
	$query  = trim($query, ' OR ');
	$query  = "SELECT * FROM #__posts WHERE `post_approve` = '1' AND `post_date` <= '".time_now."' AND (".$query.") ORDER BY post_id";
	$query = $d->query($query);
	while($p = $d->fetch($query)) 
	{
		$d->insert('search', array(
			'search_key' => $search['key'],
			'search_title' => str_replace($search['story'], '<span style="background:#FFCC33;color:#000000">'.$search['story'].'</span>', $p['post_title']),
			'search_author' => $p['post_author'],
			'search_content' => str_replace($search['story'], '<span style="background:#FFCC33;color:#000000">'.$search['story'].'</span>', nl2br(trim(strip_tags($p['post_text'])))),
			'search_date' => $p['post_date'],
			'search_module' => 'posts',
			'search_url' => url('posts/'.$p['post_id'].url('/'.$p['post_name'], 1)),
			'search_time' => time(),
			'search_keywords' => $search['story']
		));
	}
}

function module_posts_sitemap(&$sitemap)
{
	global $d;
	require_once(root_dir.'modules/posts/functions.php');
	$query = func_posts_query(null, null);
	$posts = $d->get_row($query, 'assoc');
	if(is_array($posts) && count($posts))
	{
		foreach($posts as $p)
		{
			$sitemap->addItem(url('posts/'.$p['post_id'].url('/'.$p['post_name'], 1)), $p['post_date'], 'monthly', '0.8');
		}
	}
	unset($posts, $p, $query);
}

function module_posts_feed(&$feeds)
{
	global $d, $options;
	require_once(root_dir.'modules/posts/functions.php');
	$query = func_posts_query(null, 'LIMIT '.intval($options['feed-limit']));
	$posts = $d->get_row($query, 'assoc');
	if(is_array($posts) && count($posts))
	{
		foreach($posts as $p)
		{
			$url = url . url('posts/'.$p['post_id'].url('/'.$p['post_name'], 1));
			$feeds->addItem(new FeedItem($url, $p['post_title'], $url, $p['post_text'], date3339($p['post_date'])));
		}
	}
	unset($posts, $p, $query);
}

if(admin_page !== false)
{
	$tpl->add_for('navmenu-modules', array(
		'{title}' => 'پست ها',
		'{url}' => '?a='.admin_page.'&b=mod&c=posts',
		'{child}' => '<ul><li><a href="?a='.admin_page.'&b=mod&c=posts&do=posts-new">ارسال پست جدید</a></li><li><a href="?a='.admin_page.'&b=mod&c=posts&do=categories">موضوعات پست ها</a></li><li><a href="?a='.admin_page.'&b=mod&c=posts&do=comments">نظرات پست ها</a></li><li><a href="?a='.admin_page.'&b=mod&c=posts&do=options">تنظیمات پست ها</a></li></ul>',
		'replace' => array(
			'#\\[extra\\](.*?)\\[/extra\\]#s' => '',
			'#\\[child\\](.*?)\\[/child\\]#s' => '\\1',
		)
	));
}

?>