<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function func_admin_posts()
{
	global $page, $tpl, $d;
	member::check_admin_page_access('posts') or die('Warning access!');
	require_once(engine_dir.'pagination.class.php');
	$page['title'] .= ' &bull; پست ها';

	$order = get_param($_GET, 'order', 'DESC');
	$order = $order=='DESC'? 'DESC' : 'ASC';
	
	$total = get_param($_GET, 'total', 20);
	$total = $total<=0? 20 : $total;

	$_page = get_param($_GET, 'page', 1);
	$_page = $_page<=0? 1 : $_page;

	$total_posts = $d->numRows("SELECT `post_id` FROM `#__posts`", true);

	$pagination = new pagination($total_posts, $total, $_page);

	$itpl = new template('modules/posts/html/admin/posts.tpl');

	$d->query("SELECT * FROM #__posts ORDER BY post_fixed {$order}, post_date {$order}, post_id {$order} LIMIT $pagination->Start, $pagination->End");
	if($d->numRows()>=1)
	{
		while($data = $d->fetch()) 
		{	
			$itpl->add_for('posts', array(
				'{odd-even}' => odd_even(),
				'{id}' => $data['post_id'],
				'{title}' => $data['post_title'],
				'{hits}' => $data['post_hits'],
				'{approve}' => $data['post_approve'],
				'{fixed}' => $data['post_fixed'],
				'replace' => array(
					'#\\[next\\](.*?)\\[/next\\]#s' => $data['post_date']>time_now? '\\1' : '',
					'#\\[not-next\\](.*?)\\[/not-next\\]#s' => $data['post_date']<time_now? '\\1' : '',
					'#\\[fixed\\](.*?)\\[/fixed\\]#s' => $data['post_fixed']==1? '\\1' : '',
					'#\\[not-fixed\\](.*?)\\[/not-fixed\\]#s' => $data['post_fixed']!=1? '\\1' : '',
					'#\\[approve\\](.*?)\\[/approve\\]#s' => $data['post_approve']==1? '\\1' : '',
					'#\\[not-approve\\](.*?)\\[/not-approve\\]#s' => $data['post_approve']!=1? '\\1' : '',
				),
			));
		}

		$itpl->assign(array(
			'[posts]' => null,
			'[/posts]' => null,
		));
		$itpl->block('#\\[not-posts\\](.*?)\\[/not-posts\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[not-posts]' => null,
			'[/not-posts]' => null,
		));
		$itpl->block('#\\[posts\\](.*?)\\[/posts\\]#s', '');
	}

	$p = $pagination->build('{page}', true);
	if(is_array($p) && count($p)) 
	{	
		foreach($p as $link) 
		{
			if(!isset($link['page'])) continue;

			$itpl->add_for('pages', array(
				'{number}' => $link['number'],
				'replace' => array(
					'#\\[selected\\](.*?)\\[/selected\\]#s' => $link['number']==$_page? '\\1' : '',
				),
			));
		}

		$itpl->assign(array(
			'[pages]' => null,
			'[/pages]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[pages\\](.*?)\\[/pages\\]#s', '');
	}
	
	if($order=='DESC')
	{
		$itpl->assign(array(
			'[desc]' => null,
			'[/desc]' => null,
		));
		$itpl->block('#\\[asc\\](.*?)\\[/asc\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[asc]' => null,
			'[/asc]' => null,
		));
		$itpl->block('#\\[desc\\](.*?)\\[/desc\\]#s', '');
	}
	
	$itpl->assign(array(
		'{total}' => $total,
	));
	
	if(is_ajax())
	{
		define('no_template', true);
		$itpl->assign(global_tags());
		$itpl->display();
	}
	else
		$tpl->assign('{content}', $itpl->get_var());
}

function func_admin_posts_title()
{
	global $page, $tpl, $d;
	member::check_admin_page_access('posts') or die('Warning access!');

	$id = get_param($_GET, 'id', 0);

	$d->query("SELECT * FROM #__posts WHERE `post_id`='$id' LIMIT 1");
	$data = $d->fetch();

	if(!is_array($data) || !count($data))
		die('این پست وجود ندارد!');

	$title = get_param($_GET, 'title', null, 1);
	$title = filter($title, 'preview');

	if(empty($title))
	{
		die('عنوان را ننوشته اید!');
	}
	else
	{
		$d->update('posts', array(
			'post_title' => $title,
		), "`post_id`='{$id}'", 1);	
		
		if($d->affectedRows())
		{
			remove_cache('module-posts', true);
			die('ok');
		}
		else
		{
			die('در ذخیره خطایی رخ داده مجدد تلاش کنید!');
		}
	}
	die;
}

function func_admin_posts_approve()
{
	global $page, $tpl, $d;
	member::check_admin_page_access('posts') or die('Warning access!');

	$id = get_param($_GET, 'id', 0);
	$approve = get_param($_GET, 'approve', 0);

	$d->query("SELECT post_author FROM #__posts WHERE `post_id`='$id' LIMIT 1");
	$data = $d->fetch();

	if(!is_array($data) || !count($data))
		die('این پست وجود ندارد!');

	if($data['post_author']==member_name || group_super_admin==1)
	{
		$d->update('posts', array(
			'post_approve' => $approve==1? 0 : 1,
		), "`post_id`='{$id}'", 1);	

		if($d->affectedRows())
		{
			remove_cache('module-posts', true);
			die($approve==1? 'no' : 'ok');
		}
		else
		{
			die('در ذخیره خطایی رخ داده مجدد تلاش کنید!');
		}
	}
	else
	{
		die('شما دسترسی لازم را ندارید!');
	}
	die;
}

function func_admin_posts_fixed()
{
	global $page, $tpl, $d;
	member::check_admin_page_access('posts') or die('Warning access!');

	$id = get_param($_GET, 'id', 0);
	$fixed = get_param($_GET, 'fixed', 0);

	$d->query("SELECT post_author FROM #__posts WHERE `post_id`='$id' LIMIT 1");
	$data = $d->fetch();

	if(!is_array($data) || !count($data))
		die('این پست وجود ندارد!');

	if($data['post_author']==member_name || group_super_admin==1)
	{
		$d->update('posts', array(
			'post_fixed' => $fixed==1? 0 : 1,
		), "`post_id`='{$id}'", 1);	

		if($d->affectedRows())
		{
			remove_cache('module-posts', true);
			die($fixed==1? 'no' : 'ok');
		}
		else
		{
			die('در ذخیره خطایی رخ داده مجدد تلاش کنید!');
		}
	}
	else
	{
		die('شما دسترسی لازم را ندارید!');
	}
	die;
}

function func_admin_posts_date($year, $month, $day, $hour, $minute, $second)
{
	if(!is_numeric($year) || !is_numeric($month) || !is_numeric($day) || !is_numeric($hour) || !is_numeric($minute) || !is_numeric($second)) return 'numeric';
	if(strlen($year)<4 || $year<1370 || $year>jdate('Y')+5) return 'year';
	if($month<=0 || $month>12) return 'month';
	if($day<=0 || $day>31 || ($month>6 && $day>30)) return 'day';
	if($hour<=0 || $hour>24) return 'hour';
	if($minute<=0 || $minute>59) return 'minute';
	if($second<=0 || $second>59) return 'second';
	return 'true';
}

function func_admin_posts_tags($data)
{
    global $d;
	$data = filter($data, 'safe');
	$data = trim($data, ',');
	$tags = explode(',', $data);
    $tags = array_map(create_function('$tag', 'if(empty($tag)) return null; else return filter($tag, \'safe\');'), $tags);

    $i = 0;
    if(is_array($tags) && count($tags))
    foreach($tags as $tag)
    {
        $tag = $d->escapeString($tag);
        $slug = clean_text($tag, true);

		if(empty($tag) || empty($slug))
		{
			unset($tags[$i]);
			continue;
		}
			
		if($d->numRows("SELECT * FROM `#__terms` WHERE `term_type`='p-tag' AND `term_name`='".$tag."'", true) <= 0)
        {
            $d->insert('terms', array(
                'term_type' => 'p-tag',
                'term_name' => $tag,
                'term_slug' => $slug,
            ));
        }
		$i++;
    }

    $id = array();
    foreach($tags as $tag)
    {
        if(!empty($tag))
        {
            $catID = $d->query("SELECT term_id FROM `#__terms` WHERE `term_type`='p-tag' AND `term_name`='".$d->escapeString($tag)."' limit 1");
			$catID = $d->fetch($catID);
            $catID = (int) $catID['term_id'];
            if($catID <= 0) continue;
            $id[] = $catID;
        }
    }

    return array(
		'id' => $id,
		'tags' => $tags
	);
}

function func_admin_posts_cats($cats)
{
	global $d;
	$cats = explode(',', $cats);
	$cats = array_map('intval', $cats);

	$id = array();
	foreach($cats as $i)
	{
		if($i <= 0) continue;
		$id[] = (int) $i;
	}

	return $id;
}

function func_admin_posts_new()
{
	global $page, $tpl, $d, $cache;
	member::check_admin_page_access('posts') or die('Warning access!');

	$page['title'] .= ' &bull; پست جدید';

	$opp = posts_options();
	$opp['fields'] = explode("\n", $opp['fields']);
	$opp['fields'] = filter($opp['fields'], 'en-num');
	$opp['fields'] = array_map('trim', $opp['fields']);
	
	$posts = get_param($_POST, 'posts', null, 1);
	if(isset($posts) && is_array($posts) && count($posts))
	{
		$msg = null;
		$posts['title'] = filter($posts['title'], 'preview');
		$posts['name'] = clean_text($posts['name'], true);
		if(!isset($posts['categories']) || !is_array($posts['categories'])) $posts['categories'] = array();

		$categories = func_admin_posts_cats(implode(',', $posts['categories']));
		$tags = func_admin_posts_tags($posts['tags']);

		$posts['text'] = preg_replace('#(\A[\s]*<br[^>]*>[\s]*|<br[^>]*>[\s]*\Z)#is', '', $posts['text']); // remove <br/> at end of string
		$posts['more'] = preg_replace('#(\A[\s]*<br[^>]*>[\s]*|<br[^>]*>[\s]*\Z)#is', '', $posts['more']); // remove <br/> at end of string

		if(empty($posts['title']))
			$msg .= "عنوان پست را ننوشته اید!<br>";

		if(empty($posts['name']))
			$msg .= "نام مستعار پست را ننوشته اید!<br>";

		if($posts['text'] == '')
			$msg .= "متن پست را ننوشته اید!<br>";

		$date = func_admin_posts_date($posts['year'], $posts['month'], $posts['day'], $posts['hour'], $posts['minute'], $posts['second']);
		if($date != 'true')
		{
			if($date=='numeric') $msg .= "تاريخ ويا زمان انتخاب شده براي پست معتبر نيست!<br>";
			if($date=='year') $msg .= "سال انتخاب شده براي انتشار پست معتبر نيست!<br>";
			if($date=='month') $msg .= "ماه انتخاب شده براي انتشار پست معتبر نيست!<br>";
			if($date=='day') $msg .= "روز انتخاب شده براي انتشار پست معتبر نيست!<br>";
			if($date=='hour') $msg .= "ساعت انتخاب شده براي انتشار پست معتبر نيست!<br>";
			if($date=='minute') $msg .= "دقيقه انتخاب شده براي انتشار پست معتبر نيست!<br>";
			if($date=='second') $msg .= "ثانيه انتخاب شده براي انتشار پست معتبر نيست!<br>";
		}
		else
		{
			$date = Jalali_to_gregorian($posts['year'], $posts['month'], $posts['day']);
			$date = strtotime($date[0].'-'.$date[1].'-'.$date[2].' '.$posts['hour'].':'.$posts['minute'].':'.$posts['second']);
		}
		
		if(!empty($msg))
		{
			echo message($msg, 'error');
		}
		else
		{
			$id = $d->insert('posts', array(
				'post_title' => filter($posts['title'], 'preview'),
				'post_image' => filter($posts['image'], 'safe'),
				'post_name' => $posts['name'],
				'post_text' => trim($posts['text']),
				'post_more' => trim($posts['more']),
				'post_date' => intval($date),
				'post_comment' => $posts['comment']==1? 1 : 0,
				'post_fixed' => $posts['fixed']==1? 1 : 0,
				'post_approve' => $posts['approve']==1? 1 : 0,
				'post_view' => intval($posts['view']),
				'post_categories' => implode(',', $categories),
				'post_tags' => implode(',', $tags['id']),
				'post_author' => member_name,
			));
			
			if($d->affectedRows())
			{
				if(isset($posts['fields']) && is_array($posts['fields']) && count($posts['fields']) && $id>0)
				{
					foreach($posts['fields'] as $f=>$v)
					{
						$v = trim($v);
						if(!in_array($f, $opp['fields']) || empty($v)) continue;
						$d->insert('fields', array(
							'field_link' => intval($id),
							'field_name' => trim($f),
							'field_value' => $v,
							'field_type' => 'p',
						));
					}
				}

				echo message('پست جدید با موفقیت ذخیره شد!', 'success');
				echo message('<a href="javascript:return false;" onclick="post_reset()">برای ارسال پست جدید کلیک کنید ...</a>', 'info');
				echo '<script>parsnuke.hideID("form-new-posts")</script>';
				remove_cache('module-posts', true);
			}
			else
			{
				echo message('در ذخیره اطلاعات خطایی رخ داده مجدد تلاش کنید!', 'error');
			}
		}
		die;
	}

	posts_categories();

	$itpl = new template('modules/posts/html/admin/posts-new.tpl');

	$array['{textarea}'] = wysiwyg_textarea('posts[text]', null);
	$array['{textarea-more}'] = wysiwyg_textarea('posts[more]', null);
	$array['{watch}'] = jdate('Y-m-d ساعت H:i:s');
	$array['{approve}'] = html::radio('posts[approve]', array(1=>'منتشر شده', 0=>'چرکنويس'), 1);
	$array['{comment}'] = html::radio('posts[comment]', array(1=>'فعال', 0=>'غيرفعال'), 1);
	$array['{fixed}'] = html::radio('posts[fixed]', array(1=>'فعال', 0=>'غيرفعال'), 0);
	$array['{view}'] = html::select('posts[view]', array(1=>'همه کاربران', 2=>'فقط کاربران عضو سایت', 3=>'فقط کاربران غیر عضو سایت', 4=>'فقط مدیران سایت', 5=>'فقط مدیر کل سایت'), 1);

	$data = explode(' ', jdate('Y-m-d H:i:s'));
	$date = explode('-', $data[0]);
	$date['year'] = $date[0];
	$date['month'] = $date[1];
	$date['day'] = $date[2];
	$date['hour'] = explode(':', $data[1]);
	$date['minute'] = $date['hour'][1];
	$date['second'] = $date['hour'][2];
	$date['hour'] = $date['hour'][0];

	$array['{categories}'] = '<select name="posts[categories][]" size="8" style="width: 100%" multiple="multiple">';
	$array['{categories}'] .= '<option value="0" style="font-weight: bold">-->&nbsp;بدون موضوع!</option>';
	if(isset($cache['posts_categories']) && is_array($cache['posts_categories']) && count($cache['posts_categories']))
	foreach($cache['posts_categories'] as $c)
	{
		if($c['term_parent'] != 0) continue;
		$array['{categories}'] .= '<option value="'.$c['term_id'].'" style="font-weight: bold">-->&nbsp;'.$c['term_name'].'</option>';
		foreach($cache['posts_categories'] as $p)
		{
			if($p['term_parent'] != $c['term_id']) continue;
			$array['{categories}'] .= '<option value="'.$p['term_id'].'">::: '.$p['term_name'].'</option>';
		}
	}
	$array['{categories}'] .= '</select>';

	$year = $date['year'] - 5;
	$op = array();
	for($year; $year<jdate('Y')+5; $year++)
	$op[$year] = $year;
	$array['{year}'] = html::select('posts[year]', $op, $date['year']);

	$op = array();
	for($i=1; $i<=12; $i++)
	$op[$i<=9? '0'.$i : $i] = $i<=9? '0'.$i : $i;
	$array['{month}'] = html::select('posts[month]', $op, $date['month']);

	$op = array();
	for($i=1; $i<=31; $i++)
	$op[$i] = $i;
	$array['{day}'] = html::select('posts[day]', $op, $date['day']);

	$op = array();
	for($i=1; $i<=24; $i++)
	$op[$i] = $i;
	$array['{hour}'] = html::select('posts[hour]', $op, $date['hour']);

	$op = array();
	for($i=1; $i<=59; $i++)
	$op[$i] = $i;
	$array['{minute}'] = html::select('posts[minute]', $op, $date['minute']);

	$op = array();
	for($i=1; $i<=59; $i++)
	$op[$i] = $i;
	$array['{second}'] = html::select('posts[second]', $op, $date['second']);

	$itpl->assign($array);
	
	if(isset($opp['fields']) && is_array($opp['fields']) && count($opp['fields']))
	{
		foreach($opp['fields'] as $f)
		{
			if(!empty($f))
			{
				$itpl->add_for('fields', array(
					'{name}' => trim($f),
					'{value}' => null,
				));
			}
		}
	}
	
	if(isset($itpl->foreach['fields']))
	{
		$itpl->assign(array(
			'[is-fields]' => null,
			'[/is-fields]' => null,
		));
		$itpl->block('#\\[is-not-fields\\](.*?)\\[/is-not-fields\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[is-not-fields]' => null,
			'[/is-not-fields]' => null,
		));
		$itpl->block('#\\[is-fields\\](.*?)\\[/is-fields\\]#s', '');
	}
	
	$tpl->assign('{content}', $itpl->get_var());
	unset($itpl);
}

function func_admin_posts_edit()
{
	global $page, $tpl, $d, $cache;
	member::check_admin_page_access('posts') or die('Warning access!');

	$page['title'] .= ' &bull; ویرایش پست';
	$id = get_param($_GET, 'id', 0);

	$d->query("
		SELECT posts.*,terms_tag.term_name,
		GROUP_CONCAT(DISTINCT terms_tag.term_name) AS myTag
		FROM #__posts AS posts	
		LEFT JOIN #__terms AS terms_tag ON FIND_IN_SET(terms_tag.term_id, posts.post_tags) AND terms_tag.term_type='p-tag'
		WHERE posts.post_id = '$id'
		LIMIT 1
	");
	$data = $d->fetch();

	if(!is_array($data) || !count($data))
		redirect('?a='.admin_page.'&b=mod&c=posts');

	if($data['post_author']==member_name || group_super_admin==1)
	{
		$opp = posts_options();
		$opp['fields'] = explode("\n", $opp['fields']);
		$opp['fields'] = filter($opp['fields'], 'en-num');
		$opp['fields'] = array_map('trim', $opp['fields']);
			
		$posts = get_param($_POST, 'posts', null, 1);
		if(isset($posts) && is_array($posts) && count($posts))
		{
			$msg = null;
			$posts['title'] = filter($posts['title'], 'preview');
			$posts['name'] = clean_text($posts['name'], true);
			if(!isset($posts['categories']) || !is_array($posts['categories'])) $posts['categories'] = array();

			$categories = func_admin_posts_cats(implode(',', $posts['categories']));
			$tags = func_admin_posts_tags($posts['tags']);

			$posts['text'] = preg_replace('#(\A[\s]*<br[^>]*>[\s]*|<br[^>]*>[\s]*\Z)#is', '', $posts['text']); // remove <br/> at end of string
			$posts['more'] = preg_replace('#(\A[\s]*<br[^>]*>[\s]*|<br[^>]*>[\s]*\Z)#is', '', $posts['more']); // remove <br/> at end of string

			if(empty($posts['title']))
				$msg .= "عنوان پست را ننوشته اید!<br>";

			if(empty($posts['name']))
				$msg .= "نام مستعار پست را ننوشته اید!<br>";

			if($posts['text'] == '')
				$msg .= "متن پست را ننوشته اید!<br>";

			$date = func_admin_posts_date($posts['year'], $posts['month'], $posts['day'], $posts['hour'], $posts['minute'], $posts['second']);
			if($date != 'true')
			{
				if($date=='numeric') $msg .= "تاريخ ويا زمان انتخاب شده براي پست معتبر نيست!<br>";
				if($date=='year') $msg .= "سال انتخاب شده براي انتشار پست معتبر نيست!<br>";
				if($date=='month') $msg .= "ماه انتخاب شده براي انتشار پست معتبر نيست!<br>";
				if($date=='day') $msg .= "روز انتخاب شده براي انتشار پست معتبر نيست!<br>";
				if($date=='hour') $msg .= "ساعت انتخاب شده براي انتشار پست معتبر نيست!<br>";
				if($date=='minute') $msg .= "دقيقه انتخاب شده براي انتشار پست معتبر نيست!<br>";
				if($date=='second') $msg .= "ثانيه انتخاب شده براي انتشار پست معتبر نيست!<br>";
			}
			else
			{
				$date = Jalali_to_gregorian($posts['year'], $posts['month'], $posts['day']);
				$date = strtotime($date[0].'-'.$date[1].'-'.$date[2].' '.$posts['hour'].':'.$posts['minute'].':'.$posts['second']);
			}
			
			if(!empty($msg))
			{
				echo message($msg, 'error');
			}
			else
			{
				$save = 0;
				if(isset($posts['fields']) && is_array($posts['fields']) && count($posts['fields']) && $id>0)
				{
					$d->delete('fields', "`field_type`='p' AND `field_link`='".intval($id)."'");
					foreach($posts['fields'] as $f=>$v)
					{
						$v = trim($v);
						if(!in_array($f, $opp['fields']) || empty($v) || empty($id)) continue;
						$d->insert('fields', array(
							'field_link' => intval($id),
							'field_name' => trim($f),
							'field_value' => $v,
							'field_type' => 'p',
						));
						if($d->affectedRows()) $save++;
					}
				}
			
				$d->update('posts', array(
					'post_title' => filter($posts['title'], 'preview'),
					'post_image' => filter($posts['image'], 'safe'),
					'post_name' => $posts['name'],
					'post_text' => trim($posts['text']),
					'post_more' => trim($posts['more']),
					'post_date' => intval($date),
					'post_comment' => $posts['comment']==1? 1 : 0,
					'post_fixed' => $posts['fixed']==1? 1 : 0,
					'post_approve' => $posts['approve']==1? 1 : 0,
					'post_view' => intval($posts['view']),
					'post_categories' => implode(',', $categories),
					'post_tags' => implode(',', $tags['id']),
				), "post_id = '$id'", 1);
				
				if($d->affectedRows() || $save>0)
				{
					remove_cache('module-posts', true);
					echo message('پست با موفقیت ویرایش شد!', 'success');
				}
				else
				{
					echo message('در ذخیره اطلاعات خطایی رخ داده مجدد تلاش کنید!', 'error');
				}
			}
			die;
		}

		posts_categories();

		$itpl = new template('modules/posts/html/admin/posts-edit.tpl');

		$array['{id}'] = $data['post_id'];
		$array['{title}'] = $data['post_title'];
		$array['{name}'] = urldecode($data['post_name']);
		$array['{image}'] = $data['post_image'];
		$array['{textarea}'] = wysiwyg_textarea('posts[text]', $data['post_text']);
		$array['{textarea-more}'] = wysiwyg_textarea('posts[more]', $data['post_more']);
		$array['{watch}'] = jdate('Y-m-d ساعت H:i:s');
		$array['{approve}'] = html::radio('posts[approve]', array(1=>'منتشر شده', 0=>'چرکنويس'), $data['post_approve']);
		$array['{comment}'] = html::radio('posts[comment]', array(1=>'فعال', 0=>'غيرفعال'), $data['post_comment']);
		$array['{fixed}'] = html::radio('posts[fixed]', array(1=>'فعال', 0=>'غيرفعال'), $data['post_fixed']);
		$array['{view}'] = html::select('posts[view]', array(1=>'همه کاربران', 2=>'فقط کاربران عضو سایت', 3=>'فقط کاربران غیر عضو سایت', 4=>'فقط مدیران سایت', 5=>'فقط مدیر کل سایت'), $data['post_view']);

		$data['post_date'] = explode(' ', jdate('Y-m-d H:i:s', $data['post_date']));
		$date = explode('-', $data['post_date'][0]);
		$date['year'] = $date[0];
		$date['month'] = $date[1];
		$date['day'] = $date[2];
		$date['hour'] = explode(':', $data['post_date'][1]);
		$date['minute'] = $date['hour'][1];
		$date['second'] = $date['hour'][2];
		$date['hour'] = $date['hour'][0];

		$data['post_categories'] = explode(',', $data['post_categories']);
		$array['{categories}'] = '<select name="posts[categories][]" size="8" style="width: 100%" multiple="multiple">';
		$array['{categories}'] .= '<option value="0" style="font-weight: bold">-->&nbsp;بدون موضوع!</option>';
		if(isset($cache['posts_categories']) && is_array($cache['posts_categories']) && count($cache['posts_categories']))
		foreach($cache['posts_categories'] as $c)
		{
			if($c['term_parent'] != 0) continue;
			$array['{categories}'] .= '<option value="'.$c['term_id'].'"'.(in_array($c['term_id'], $data['post_categories'])? ' selected="selected"' : null).' style="font-weight: bold">-->&nbsp;'.$c['term_name'].'</option>';
			foreach($cache['posts_categories'] as $p)
			{
				if($p['term_parent'] != $c['term_id']) continue;
				$array['{categories}'] .= '<option value="'.$p['term_id'].'"'.(in_array($p['term_id'], $data['post_categories'])? ' selected="selected"' : null).'>::: '.$p['term_name'].'</option>';
			}
		}
		$array['{categories}'] .= '</select>';

		$array['{tags}'] = null;
		$data['myTag'] = explode(',', $data['myTag']);
		for($i=0; $i<count($data['myTag']); $i++)
		{
			if(empty($data['myTag'][$i])) continue;
			$array['{tags}'] .= $data['myTag'][$i].',';
		}
		$array['{tags}'] = trim($array['{tags}'], ',');

		$year = $date['year'] - 5;
		$op = array();
		for($year; $year<jdate('Y')+5; $year++)
		$op[$year] = $year;
		$array['{year}'] = html::select('posts[year]', $op, $date['year']);

		$op = array();
		for($i=1; $i<=12; $i++)
		$op[$i<=9? '0'.$i : $i] = $i<=9? '0'.$i : $i;
		$array['{month}'] = html::select('posts[month]', $op, $date['month']);

		$op = array();
		for($i=1; $i<=31; $i++)
		$op[$i] = $i;
		$array['{day}'] = html::select('posts[day]', $op, $date['day']);

		$op = array();
		for($i=1; $i<=24; $i++)
		$op[$i] = $i;
		$array['{hour}'] = html::select('posts[hour]', $op, $date['hour']);

		$op = array();
		for($i=1; $i<=59; $i++)
		$op[$i] = $i;
		$array['{minute}'] = html::select('posts[minute]', $op, $date['minute']);

		$op = array();
		for($i=1; $i<=59; $i++)
		$op[$i] = $i;
		$array['{second}'] = html::select('posts[second]', $op, $date['second']);

		$itpl->assign($array);
		
		if(isset($opp['fields']) && is_array($opp['fields']) && count($opp['fields']))
		{
			foreach($opp['fields'] as $f)
			{
				if(!empty($f))
				{
					$d->query("SELECT * FROM #__fields WHERE field_type='p' AND field_name='".$f."' AND field_link='".$id."' LIMIT 1");
					$fdata = $d->fetch();
				
					$itpl->add_for('fields', array(
						'{name}' => trim($f),
						'{value}' => isset($fdata['field_value'])? $fdata['field_value'] : null,
					));
				}
			}
		}
		
		if(isset($itpl->foreach['fields']))
		{
			$itpl->assign(array(
				'[is-fields]' => null,
				'[/is-fields]' => null,
			));
			$itpl->block('#\\[is-not-fields\\](.*?)\\[/is-not-fields\\]#s', '');
		}
		else
		{
			$itpl->assign(array(
				'[is-not-fields]' => null,
				'[/is-not-fields]' => null,
			));
			$itpl->block('#\\[is-fields\\](.*?)\\[/is-fields\\]#s', '');
		}

		$tpl->assign('{content}', $itpl->get_var());
		unset($itpl);
	}
	else
	{
		set_content(false, message('شما دسترسی لازم برای ویرایش این پست را ندارید!', 'error'));
	}
}

function func_admin_posts_delete()
{
	global $page, $tpl, $d, $cache;
	member::check_admin_page_access('posts') or die('Warning access!');

	$id = get_param($_GET, 'id', 0);

	$d->query("
		SELECT posts.*,terms_tag.term_name,
		GROUP_CONCAT(DISTINCT terms_tag.term_name) AS myTag
		FROM #__posts AS posts	
		LEFT JOIN #__terms AS terms_tag ON FIND_IN_SET(terms_tag.term_id, posts.post_tags) AND terms_tag.term_type='p-tag'
		WHERE posts.post_id = '$id'
		LIMIT 1
	");
	$data = $d->fetch();

	if(!is_array($data) || !count($data))
		redirect('?a='.admin_page.'&b=mod&c=posts');

	if($data['post_author']==member_name || group_super_admin==1)
	{
		$data['post_tags'] = explode(',', $data['post_tags']);
		if(is_array($data['post_tags']) && count($data['post_tags']))
		foreach($data['post_tags'] as $tag)
		{
			if($d->numRows("SELECT * FROM `#__posts` WHERE FIND_IN_SET(".intval($tag).", post_tags) AND `post_id`!='".intval($id)."'", true) <= 0)
			{
				$d->delete('terms', "`term_type`='p-tag' AND `term_id`='".intval($tag)."'", 1);
			}
		}
		$d->delete('fields', "`field_type`='p' AND `field_link`='".intval($id)."'");
		$d->delete('comments', "`comment_type`='post' AND `comment_link`='".intval($id)."'");
		$d->delete('posts', "`post_id`='".intval($id)."'", 1);
		echo message('پست با موفقیت حذف شد!', 'success');
		remove_cache('module-posts', true);
	}
	else
	{
		echo message('شما دسترسی لازم برای حذف این پست را ندارید!', 'error');
	}
	func_admin_posts();
}

######################## COMMENTS FUNCTIONS ########################

function func_admin_posts_comments()
{
	global $page, $tpl, $d;
	member::check_admin_page_access('posts-comments') or die('Warning access!');
	require_once(engine_dir.'pagination.class.php');
	$page['title'] .= ' &bull; نظرات پست ها';
	
	$order = get_param($_GET, 'order', 'DESC');
	$order = $order=='DESC'? 'DESC' : 'ASC';
	
	$total = get_param($_GET, 'total', 20);
	$total = $total<=0? 20 : $total;

	$_page = get_param($_GET, 'page', 1);
	$_page = $_page<=0? 1 : $_page;

	$total_posts = $d->numRows("SELECT `comment_id` FROM `#__comments` WHERE `comment_type`='post'", true);

	$pagination = new pagination($total_posts, $total, $_page);

	$itpl = new template('modules/posts/html/admin/comments.tpl');
	
	$d->query("
		SELECT c.*,m.member_avatar,m.member_group,m.member_name
		FROM #__comments AS c
		LEFT JOIN #__members AS m ON (m.member_id = c.comment_member_id)
		WHERE c.comment_type='post'
		GROUP BY c.comment_id
		ORDER BY c.comment_id $order
		LIMIT $pagination->Start, $pagination->End
	");
	
	if($d->numRows()>=1)
	{
		while($data = $d->fetch()) 
		{
			$itpl->add_for('comments', array(
				'{odd-even}' => odd_even(),
				'{id}' => $data['comment_id'],
				'{type}' => $data['comment_type'],
				'{link}' => $data['comment_link'],
				'{member-id}' => $data['comment_member_id'],
				'{member-name}' => $data['member_name'],
				'{author}' => $data['comment_author'],
				'{author-email}' => $data['comment_author_email'],
				'{author-url}' => $data['comment_author_url'],
				'{author-ip}' => $data['comment_author_ip'],
				'{date}' => jdate("l j F Y ساعت h:i A", $data['comment_date']),
				'{past-time}' => getPastTime($data['comment_date']),
				'{text}' => $data['comment_text'],
				'{abstract}' => smiles_replace(substr($data['comment_text'], 0, 111)),
				'{answer-author}' => $data['comment_answer_author'],
				'{answer}' => $data['comment_answer'],
				'{approve}' => $data['comment_approve'],
				'{language}' => $data['comment_language'],
				'replace' => array(
					'#\\[approve\\](.*?)\\[/approve\\]#s' => $data['comment_approve']==1? '\\1' : '',
					'#\\[not-approve\\](.*?)\\[/not-approve\\]#s' => $data['comment_approve']!=1? '\\1' : '',
					'#\\[member-name\\](.*?)\\[/member-name\\]#s' => !empty($data['member_name'])? '\\1' : '',
					'#\\[not-member-name\\](.*?)\\[/not-member-name\\]#s' => empty($data['member_name'])? '\\1' : '',
				)
			));
		}
		
		$itpl->assign(array(
			'[comments]' => null,
			'[/comments]' => null,
		));
		$itpl->block('#\\[not-comments\\](.*?)\\[/not-comments\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[not-comments]' => null,
			'[/not-comments]' => null,
		));
		$itpl->block('#\\[comments\\](.*?)\\[/comments\\]#s', '');
	}

	$p = $pagination->build('{page}', true);
	if(is_array($p) && count($p)) 
	{	
		foreach($p as $link) 
		{
			if(!isset($link['page'])) continue;

			$itpl->add_for('pages', array(
				'{number}' => $link['number'],
				'replace' => array(
					'#\\[selected\\](.*?)\\[/selected\\]#s' => $link['number']==$_page? '\\1' : '',
				),
			));
		}

		$itpl->assign(array(
			'[pages]' => null,
			'[/pages]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[pages\\](.*?)\\[/pages\\]#s', '');
	}
	
	if($order=='DESC')
	{
		$itpl->assign(array(
			'[desc]' => null,
			'[/desc]' => null,
		));
		$itpl->block('#\\[asc\\](.*?)\\[/asc\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[asc]' => null,
			'[/asc]' => null,
		));
		$itpl->block('#\\[desc\\](.*?)\\[/desc\\]#s', '');
	}
	
	$itpl->assign(array(
		'{total}' => $total,
		'{textarea-text}' => wysiwyg_textarea('comment[text]', null, 'BBcode'),
		'{textarea-answer}' => wysiwyg_textarea('comment[answer]', null, 'BBcode'),
	));

	if(is_ajax())
	{
		define('no_template', true);
		$itpl->assign(global_tags());
		$itpl->display();
	}
	else
		$tpl->assign('{content}', $itpl->get_var());
}

function func_admin_posts_comments_edit()
{
	global $page, $tpl, $d;
	member::check_admin_page_access('posts-comments') or die('Warning access!');

	$id = get_param($_GET, 'id', 0);

	$d->query("SELECT * FROM #__comments WHERE `comment_id`='$id' LIMIT 1");
	$data = $d->fetch();

	if(!is_array($data) || !count($data))
		die('این نظر وجود ندارد!');

	$comment = get_param($_POST, 'comment', null, 1);
	if(isset($comment) && is_array($comment) && count($comment))
	{
		$msg = null;
		$comment['author'] = filter($comment['author'], 'preview');
		$comment['author-email'] = filter($comment['author-email'], 'safe');
		$comment['author-url'] = filter($comment['author-url'], 'safe');
		$comment['approve'] = !isset($comment['approve']) || $comment['approve']<=0? 0 : 1;
		$comment['text'] = filter($comment['text'], 'preview');
		$comment['answer'] = filter($comment['answer'], 'preview');

		if(empty($comment['author']))
			$msg .= "نام نویسنده نظر را ننوشته اید!<br>";
		
		if(empty($comment['text']))
			$msg .= "متن نظر را پاک کرده اید!<br>";
		
		if(empty($comment['author-email']) || !validate_email_format($comment['author-email']))
			$msg .= "ايميل وارد شده صحيح نيست!<br>";
		
		if(!validate_url($comment['author-url']))
			$comment['author-url'] = null;

		if(!empty($msg))
		{
			echo message($msg, 'error');
		}
		else
		{
			$d->update('comments', array(
				'comment_author' => $comment['author'],
				'comment_author_email' => $comment['author-email'],
				'comment_author_url' => $comment['author-url'],
				'comment_text' => $comment['text'],
				'comment_answer' => $comment['answer'],
				'comment_answer_author' => empty($comment['answer'])? null : member_name,
				'comment_approve' => $comment['approve'],
			), "`comment_id`='{$id}'", 1);	

			if($d->affectedRows())
			{
				echo message('نظر با موفقیت ویرایش شد.', 'success');
				remove_cache('module-posts-comments', true);
			}
			else
			{
				echo message('در ذخیره خطایی رخ داده مجدد تلاش کنید!', 'error');
			}
		}
	}
	die;
}

function func_admin_posts_comments_approve()
{
	global $page, $tpl, $d;
	member::check_admin_page_access('posts-comments') or die('Warning access!');

	$id = get_param($_GET, 'id', 0);
	$approve = get_param($_GET, 'approve', 0);

	$d->query("SELECT * FROM #__comments WHERE `comment_id`='$id' LIMIT 1");
	$data = $d->fetch();

	if(!is_array($data) || !count($data))
		die('این نظر وجود ندارد!');

	$d->update('comments', array(
		'comment_approve' => $approve==1? 0 : 1,
	), "`comment_id`='{$id}'", 1);	

	if($d->affectedRows())
	{
		remove_cache('module-posts-comments', true);
		die($approve==1? 'no' : 'ok');
	}
	else
	{
		die('در ذخیره خطایی رخ داده مجدد تلاش کنید!');
	}
	die;
}

function func_admin_posts_comments_delete()
{
	global $page, $tpl, $d;
	member::check_admin_page_access('posts-comments') or die('Warning access!');

	$id = get_param($_GET, 'id', 0);

	$d->query("SELECT * FROM #__comments WHERE `comment_id`='$id' LIMIT 1");
	$data = $d->fetch();

	if(!is_array($data) || !count($data))
		die('این نظر وجود ندارد!');

	$d->delete('comments', "`comment_id`='{$id}'", 1);	

	if($d->affectedRows())
	{
		$d->query("UPDATE `#__posts` SET `post_comment_count`=`post_comment_count`-1 WHERE `post_id`='".intval($data['comment_link'])."' LIMIT 1");
		echo message('نظر با موفقیت حذف شد.', 'success');
		remove_cache('module-posts-comments', true);
	}
	func_admin_posts_comments();
}

######################## CATEGORIES FUNCTIONS ########################

function func_admin_categories()
{
	global $page, $tpl;
	member::check_admin_page_access('posts-categories') or die('Warning access!');
	posts_categories();
	$page['title'] .= ' &bull; موضوعات پست ها';

	$itpl = new template('modules/posts/html/admin/categories.tpl');
	$tpl->assign('{content}', $itpl->get_var());
}

function func_admin_categories_parent()
{
	global $page, $cache;
	member::check_admin_page_access('posts-categories') or die('Warning access!');
	posts_categories();

	$array = array();
	$array[0] = 'بدون سردسته (این موضوع سردسته است)';
	if(isset($cache['posts_categories']) && is_array($cache['posts_categories']) && count($cache['posts_categories']))
	foreach($cache['posts_categories'] as $cat)
	{
		if($cat['term_parent'] != 0) continue;
		$array[$cat['term_id']] = $cat['term_name'];
	}

	echo html::select('categories[parent]', $array, 0, isset($_GET['edit'])? 'id="categories-parent-edit"' : 'id="categories-parent"');
	die;
}

function func_admin_categories_new()
{
	global $page, $cache, $d;
	member::check_admin_page_access('posts-categories') or die('Warning access!');
	posts_categories();

	$categories = get_param($_POST, 'categories', null, 1);
	if(isset($categories) && is_array($categories) && count($categories))
	{
		$categories['parent'] = intval($categories['parent']);
		$categories['name'] = filter($categories['name'], 'nohtml');
		$categories['name'] = str_replace(',', ' ',$categories['name']);
		$categories['description'] = filter($categories['description'], 'preview');
		$categories['slug'] = filter($categories['slug'], '_nohtml');
		$categories['slug'] = clean_text($categories['slug'], true);

		$msg = null;

		if(!isset($categories['name']) || empty($categories['name']))
			$msg .= 'عنوان موضوع را ننوشته اید!<br>';
		
		if(!isset($categories['slug']) || empty($categories['slug']))
			$msg .= 'نام مستعار موضوع را ننوشته اید!<br>';
		/* else
		{
			if($d->numRows("SELECT `term_id` FROM `#__terms` WHERE `term_type`='p-cat' AND `term_slug`='".$categories['slug']."'", true) >= 1)
				$msg .= 'نام مستعار تکراری است یک نام مستعار دیگر انتخاب کنید!<br>';
		} */

		if($categories['parent'] != 0 && !isset($cache['posts_categories'][$categories['parent']]))
			$msg .= 'سردسته انتخاب شده معتبر نیست!<br>';

		if(!empty($msg))
		{
			echo message($msg, 'error');
		}
		else
		{
			$d->insert('terms', array(
				'term_name' => $categories['name'],
				'term_slug' => $categories['slug'],
				'term_parent' => $categories['parent'],
				'term_description' => $categories['description'],
				'term_type' => 'p-cat',
			));	
			
			if($d->affectedRows())
			{
				remove_cache('module-posts-categories', true);
				echo message('موضوع با موفقیت ذخیره شد!', 'success');
				echo '<script>parsnuke.hideID("form-new-categories")</script>';
			}
			else
			{
				echo message('در ذخیره خطایی رخ داده مجدد تلاش کنید!', 'error');
			}
		}
	}

	define('no_template', true);
}

function func_admin_categories_edit()
{
	global $page, $cache, $d;
	member::check_admin_page_access('posts-categories') or die('Warning access!');

	$id = get_param($_GET, 'id', 0);

	$d->query("SELECT * FROM #__terms WHERE `term_id`='$id' LIMIT 1");
	$data = $d->fetch();

	if(!is_array($data) || !count($data))
	{
		echo message('این موضوع وجود ندارد!', 'error');
		die;
	}

	posts_categories();
	$categories = get_param($_POST, 'categories', null, 1);
	if(isset($categories) && is_array($categories) && count($categories))
	{
		$categories['parent'] = intval($categories['parent']);
		$categories['name'] = filter($categories['name'], 'nohtml');
		$categories['name'] = str_replace(',', ' ',$categories['name']);
		$categories['description'] = filter($categories['description'], 'preview');
		$categories['slug'] = filter($categories['slug'], '_nohtml');
		$categories['slug'] = clean_text($categories['slug'], true);

		$msg = null;

		if($categories['parent'] == $id)
			$msg .= 'یک موضوع نمی تواند خودش سردسته خودش باشد!<br>';
		
		if(!isset($categories['name']) || empty($categories['name']))
			$msg .= 'عنوان موضوع را ننوشته اید!<br>';
		
		if(!isset($categories['slug']) || empty($categories['slug']))
			$msg .= 'نام مستعار موضوع را ننوشته اید!<br>';
		/* else
		{
			if($categories['slug']!=$data['term_slug'] && $d->numRows("SELECT `term_id` FROM `#__terms` WHERE `term_type`='p-cat' AND `term_slug`='".$categories['slug']."'", true) >= 1)
				$msg .= 'نام مستعار تکراری است یک نام مستعار دیگر انتخاب کنید!<br>';
		} */

		if($categories['parent'] != 0 && !isset($cache['posts_categories'][$categories['parent']]))
			$msg .= 'سردسته انتخاب شده معتبر نیست!<br>';

		if(!empty($msg))
		{
			echo message($msg, 'error');
		}
		else
		{
			$d->update('terms', array(
				'term_name' => $categories['name'],
				'term_slug' => $categories['slug'],
				'term_parent' => $categories['parent'],
				'term_description' => $categories['description'],
			), "`term_type`='p-cat' AND `term_id`='{$id}'", 1);	
			
			if($d->affectedRows())
			{
				remove_cache('module-posts-categories', true);
				echo message('موضوع با موفقیت ویرایش شد!', 'success');

				if($categories['parent'] != 0)
				{
					$d->update('terms', array(
						'term_parent' => $categories['parent'],
					), "`term_type`='p-cat' AND `term_parent`='{$id}'");

					if($d->affectedRows())
						echo message('سردسته موضوعاتی که این موضوع سردسته آنها بود به سردسته این موضوع تغییر کرد!', 'success');
				}
			}
			else
			{
				echo message('در ذخیره خطایی رخ داده مجدد تلاش کنید!', 'error');
			}
		}
	}
	define('no_template', true);
}

function func_admin_categories_list()
{
	global $page, $cache, $d;
	member::check_admin_page_access('posts-categories') or die('Warning access!');
	posts_categories();

	$itpl = new template('modules/posts/html/admin/categories-list.tpl');

	if(isset($cache['posts_categories']) && is_array($cache['posts_categories']) && count($cache['posts_categories']))
	{
		foreach($cache['posts_categories'] as $c)
		{
			if($c['term_parent'] != 0) continue;
			
			$itpl->add_for('categories', array(
				'{odd-even}' => odd_even(),
				'{id}' => $c['term_id'],
				'{name}' => $c['term_name'],
				'{description}' => $c['term_description'],
				'{slug}' => urldecode($c['term_slug']),
				'{parent}' => $c['term_parent'],
				'{parent-name}' => 'بدون سردسته',
				'[not-child]' => null,
				'[/not-child]' => null,
				'replace' => array(
					'#\\[child\\](.*?)\\[/child\\]#s' => ''
				)
			));
			
			foreach($cache['posts_categories'] as $p)
			{
				if($p['term_parent'] != $c['term_id']) continue;
				
				$itpl->add_for('categories', array(
					'{odd-even}' => odd_even(),
					'{id}' => $p['term_id'],
					'{name}' => $p['term_name'],
					'{description}' => $p['term_description'],
					'{slug}' => urldecode($p['term_slug']),
					'{parent}' => $p['term_parent'],
					'{parent-name}' => $c['term_name'],
					'[child]' => null,
					'[/child]' => null,
					'replace' => array(
						'#\\[not-child\\](.*?)\\[/not-child\\]#s' => ''
					)
				));
			}
		}
		
		$itpl->assign(array(
			'[categories]' => null,
			'[/categories]' => null,
		));
		$itpl->block('#\\[not-categories\\](.*?)\\[/not-categories\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[not-categories]' => null,
			'[/not-categories]' => null,
		));
		$itpl->block('#\\[categories\\](.*?)\\[/categories\\]#s', '');
	}

	$itpl->display();
	define('no_template', true);
}

function func_admin_categories_delete()
{
	global $page, $cache, $d;
	member::check_admin_page_access('posts-categories') or die('Warning access!');

	$id = get_param($_GET, 'id', 0);

	$d->delete('terms', "`term_type`='p-cat' AND `term_id`='{$id}'", 1);

	if($d->affectedRows())
	{
		remove_cache('module-posts-categories', true);
		$d->update('terms', array(
			'term_parent' => 0,
		), "`term_type`='p-cat' AND `term_parent`='{$id}'");

		$q = $d->query("SELECT post_categories,post_id FROM #__posts WHERE FIND_IN_SET(".$id.", post_categories) ORDER BY post_id");
		while($data = $d->fetch($q)) 
		{
			$data['post_categories'] = explode(',', $data['post_categories']);
			$index = array_search($id, $data['post_categories']);
			unset($data['post_categories'][$index]);
			$data['post_categories'] = implode(',', $data['post_categories']);

			$d->update('posts', array(
				'post_categories' => $data['post_categories'],
			), "`post_id`='{$data['post_id']}'", 1);
		}
		
		echo message('موضوع با موفقیت حذف شد.', 'success');
	}
	else
	{
		echo message('در حذف موضوع خطایی رخ داده مجدد تلاش کنید!', 'error');
	}

	func_admin_categories_list();
}

######################## OPTIONS FUNCTION ########################

function func_admin_posts_options()
{
	global $d, $tpl;
	member::check_admin_page_access('posts-options') or die('Warning access!');
	
	$opp = posts_options();
	$op = get_param($_POST, 'op');
	if(isset($op) && is_array($op) && count($op))
	{
		$op['total-posts'] = intval($op['total-posts'])<=0? 1 : intval($op['total-posts']);
		$op['total-category'] = intval($op['total-category'])<=0? 1 : intval($op['total-category']);
		$op['total-tag'] = intval($op['total-tag'])<=0? 1 : intval($op['total-tag']);
		$op['total-author'] = intval($op['total-author'])<=0? 1 : intval($op['total-author']);
		$op['fields'] = preg_replace("#\n{2,}#", "\n", $op['fields']);
		$op['fields'] = explode("\n", $op['fields']);
		$op['fields'] = filter($op['fields'], 'en-num');

		$opp['fields'] = explode("\n", $opp['fields']);
		$opp['fields'] = filter($opp['fields'], 'en-num');
		if(isset($opp['fields']) && is_array($opp['fields']) && count($opp['fields']))
		foreach($opp['fields'] as $f)
		{
			if(!in_array($f, $op['fields']))
			{
				$d->delete('fields', "`field_type`='p' AND `field_name`='".$f."'");
				if($d->affectedRows())
				{
					echo message('اطلاعات فیلد <u>'.$f.'</u> با موفقیت از دیتابیس حذف شد!', 'success');
				}
			}
		}
		
		$op['fields'] = implode("\n", $op['fields']);
		$op['fields'] = trim($op['fields']);
		
		$d->update('options', array(
			'option_value' => serialize($op)
		), "`option_name`='posts'", 1);	
		
		if($d->affectedRows())
		{
			remove_cache('posts-options');
			echo message('تنظیمات با موفقیت ذخیره شد!', 'success');
		}
		else
		{
			echo message('در ذخیره خطایی رخ داده مجدد تلاش کنید!', 'error');
		}
		die;
	}

	$itpl = new template('modules/posts/html/admin/options.tpl');

	$itpl->assign(array(
		'{posts}' => $opp['total-posts'],
		'{category}' => $opp['total-category'],
		'{tag}' => $opp['total-tag'],
		'{author}' => $opp['total-author'],
		'{fields}' => $opp['fields'],
	));

	set_content(false, $itpl->get_var());
}

?>