<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function func_posts_query($query = null, $limit = null)
{
	return "
		SELECT posts.*,terms.term_name,terms_tag.term_name,members.member_alias,
		GROUP_CONCAT(DISTINCT terms.term_name) AS myCategory,
		GROUP_CONCAT(DISTINCT terms.term_slug) AS slugCategory,
		GROUP_CONCAT(DISTINCT terms_tag.term_name) AS myTag,
		GROUP_CONCAT(DISTINCT terms_tag.term_slug) AS slugTag
		FROM #__posts AS posts	
		LEFT JOIN #__members AS members ON members.member_name=posts.post_author
		LEFT JOIN #__terms AS terms ON FIND_IN_SET(terms.term_id, posts.post_categories) AND terms.term_type='p-cat'
		LEFT JOIN #__terms AS terms_tag ON FIND_IN_SET(terms_tag.term_id, posts.post_tags) AND terms_tag.term_type='p-tag'
		WHERE posts.post_approve = '1' AND posts.post_date <= '".time_now."' {$query}
		GROUP BY posts.post_id
		ORDER BY posts.post_fixed DESC, posts.post_date DESC, posts.post_id DESC
		{$limit}
	";
}

function func_posts_index()
{
	global $d, $page, $options, $cache;

	require_once(engine_dir.'pagination.class.php');
	$posts_options = posts_options();
	$get_p = get_param($_GET, 'c', 1);
	$total = $d->numRows("SELECT `post_id` FROM `#__posts` WHERE `post_approve` = '1' AND `post_date` <= '".time_now."'", true);
	$pagination = new pagination($total, $posts_options['total-posts'], $get_p);
	$query = func_posts_query(null, 'LIMIT '.$pagination->Start.', '.$pagination->End);
	$posts = $d->get_row($query, 'assoc');

	if(!is_array($posts) || !count($posts))
	{
		set_content('بدون پست!', message('هیچ پستی برای نمایش در سایت یافت نشد!', 'error'));
	}
	else
	{
		if($get_p > 1 && $pagination->Pages>=$get_p)
			$page['title'] .= ' &bull; صفحه '.Convertnumber2farsi($get_p);
		
		if($pagination->Pages<$get_p || $get_p<=1)
			$page['meta']['canonical'] = url('posts');
		else
			$page['meta']['canonical'] = url('posts/page/'.$get_p);

		$links = null;
		foreach($posts as $post)
		{
			$links .= $post['post_id'].',';
		}
		$cache['posts-fields'] = func_posts_fields($links, 'p');
		unset($links, $post);
		
		foreach($posts as $post)
		{
			func_posts_theme($post);
		}
		$pagination->build(url('posts/page/{page}'));
	}

	unset($pagination, $posts, $total, $query, $get_p);
}

function func_posts_category()
{
	global $d, $page, $options, $cache;
	posts_categories();

	$get_c = get_param($_GET, 'c', 0);
	$get_p = get_param($_GET, $options['rewrite']==1? 'e' : 'd', 1);

	if(!isset($cache['posts_categories'][$get_c]))
	{
		module_error_run('404');
	}
	else
	{
		$term = &$cache['posts_categories'][$get_c];

		if(!is_array($term) || !count($term))
		{
			module_error_run('404');
		}
		else
		{
			require_once(engine_dir.'pagination.class.php');
			$posts_options = posts_options();
			$where = "FIND_IN_SET(".$term['term_id'].", posts.post_categories)";
			if($term['term_parent'] == 0)
			foreach($cache['posts_categories'] as $cat)
			{
				if($cat['term_parent'] != $term['term_id']) continue;
				$where .= " OR FIND_IN_SET(".$cat['term_id'].", posts.post_categories)";
			}
			
			$total = $d->numRows("SELECT `post_id` FROM `#__posts` WHERE `post_approve` = '1' AND `post_date` <= '".time_now."' AND (".str_replace('posts.', null, $where).")", true);
			$pagination = new pagination($total, $posts_options['total-category'], $get_p);
			$query = func_posts_query(" AND (".$where.")", 'LIMIT '.$pagination->Start.', '.$pagination->End);
			$posts = $d->get_row($query, 'assoc');

			$page['title'] .= ' &bull; '.$term['term_name'];
			
			if(!empty($term['term_description']))
				$page['meta']['description'] = $term['term_description'].' - '.$page['meta']['description'];

			if($get_p > 1 && $pagination->Pages>=$get_p)
				$page['title'] .= ' &bull; صفحه '.Convertnumber2farsi($get_p);
			
			if($pagination->Pages<$get_p || $get_p<=1)
				$page['meta']['canonical'] = url('posts/category/'.$term['term_id'].url('/'.$term['term_slug'], 1));
			else
				$page['meta']['canonical'] = url('posts/category/'.$term['term_id'].url('/'.$term['term_slug'], 1).'/'.$get_p);

			if(!is_array($posts) || !count($posts))
			{
				set_content('بدون پست!', message('هیچ پستی برای موضوع <u>'.$term['term_name'].'</u> در سایت یافت نشد!', 'error'));
			}
			else 
			{
				$links = null;
				foreach($posts as $post)
				{
					$links .= $post['post_id'].',';
				}
				$cache['posts-fields'] = func_posts_fields($links, 'p');
				unset($links, $post);
		
				foreach($posts as $post)
				{
					func_posts_theme($post);
				}
				$pagination->build(url('posts/category/'.$term['term_id'].url('/'.$term['term_slug'], 1).'/{page}'));
			}
		}
	}

	unset($pagination, $posts, $total, $query, $get_p);
}

function func_posts_tag()
{
	global $d, $tpl, $page, $options, $cache;
	require_once(engine_dir.'pagination.class.php');

	$get_t = get_param($_GET, 'c');
	$get_t = filter($get_t, 'safe');
	$get_p = get_param($_GET, 'd', 1);

	if(!empty($get_t))
		$get_t = clean_text(urldecode($get_t), true);

	if(empty($get_t))
	{
		module_error_run('404');
	}
	else
	{
		$d->query("SELECT `term_id`,`term_name`,`term_slug` FROM `#__terms` WHERE term_type='p-tag' AND term_slug='{$get_t}' LIMIT 1");
		$term = $d->fetch();

		if(!is_array($term) || !count($term))
		{
			module_error_run('404');
		}
		else
		{
			$posts_options = posts_options();
			$get_t = $term['term_slug'];

			$total = $d->numRows("SELECT `post_id` FROM `#__posts` WHERE `post_approve` = '1' AND `post_date` <= '".time_now."' AND FIND_IN_SET(".$term['term_id'].", post_tags)", true);
			$pagination = new pagination($total, $posts_options['total-tag'], $get_p);
			$query = func_posts_query("AND FIND_IN_SET(".$term['term_id'].", posts.post_tags)", 'LIMIT '.$pagination->Start.', '.$pagination->End);
			$posts = $d->get_row($query, 'assoc');

			if(!is_array($posts) || !count($posts))
			{
				module_error_run('404');
			}
			else 
			{
				$page['title'] .= ' &bull; '.$term['term_name'];
				$page['meta']['description'] = $term['term_name'].' - '.$page['meta']['description'];

				if($pagination->Pages<$get_p || $get_p<=1)
					$page['meta']['canonical'] = url('posts/tag/'.$get_t);
				else
					$page['meta']['canonical'] = url('posts/tag/'.$get_t.'/'.$get_p);
				
				if($get_p > 1 && $pagination->Pages>=$get_p)
					$page['title'] .= ' &bull; صفحه '.Convertnumber2farsi($get_p);
				
				$links = null;
				foreach($posts as $post)
				{
					$links .= $post['post_id'].',';
				}
				$cache['posts-fields'] = func_posts_fields($links, 'p');
				unset($links, $post);
				
				foreach($posts as $post)
				{
					func_posts_theme($post);
				}
				$pagination->build(url('posts/tag/'.$get_t.'/{page}'));
			}
		}
	}
	unset($pagination, $posts, $total, $query, $get_p);
}

function func_posts_author()
{
	global $d, $tpl, $page, $options, $cache;
	require_once(engine_dir.'pagination.class.php');
	$posts_options = posts_options();

	$get_a = get_param($_GET, 'c');
	$get_a = filter($get_a, 'en-num');
	$get_p = get_param($_GET, 'd', 1);

	$total = $d->numRows("SELECT `post_id` FROM `#__posts` WHERE `post_approve` = '1' AND `post_date` <= '".time_now."' AND post_author='".$get_a."'", true);
	$pagination = new pagination($total, $posts_options['total-author'], $get_p);
	$query = func_posts_query("AND posts.post_author='".$get_a."'", 'LIMIT '.$pagination->Start.', '.$pagination->End);
	$posts = $d->get_row($query, 'assoc');

	if(!is_array($posts) || !count($posts))
	{
		module_error_run('404');
	}
	else 
	{
		$page['title'] .= ' &bull; پست های '.(isset($posts[0]['member_alias']) && !empty($posts[0]['member_alias'])? filter($posts[0]['member_alias']) : $get_a);

		if($get_p > 1 && $pagination->Pages>=$get_p)
			$page['title'] .= ' &bull; صفحه '.Convertnumber2farsi($get_p);
		
		if($pagination->Pages<$get_p || $get_p<=1)
			$page['meta']['canonical'] = url('posts/author/'.$get_a);
		else
			$page['meta']['canonical'] = url('posts/author/'.$get_a.'/'.$get_p);
		
		$links = null;
		foreach($posts as $post)
		{
			$links .= $post['post_id'].',';
		}
		$cache['posts-fields'] = func_posts_fields($links, 'p');
		unset($links, $post);
		
		foreach($posts as $post)
		{
			func_posts_theme($post);
		}
		$pagination->build(url('posts/author/'.$get_a.'/{page}'));
	}
	unset($pagination, $posts, $total, $query, $get_p);
}

function func_posts_single()
{
	global $d, $page, $options, $cache;

	$id = get_param($_GET, 'b', 0);
	$query = func_posts_query("AND posts.post_id='".intval($id)."'", 'LIMIT 1');
	$post = $d->get_row($query);

	if(!is_array($post) || !count($post))
	{
		module_error_run('404');
	}
	else
	{
		$page['theme'] = 'single';
		$page['title'] .= ' &bull; '.filter($post[0]['post_title'], 'safe');
		$page['meta']['description'] = $post[0]['post_title'].' - '.$page['meta']['description'];

		if(!empty($post[0]['myTag']))
			$page['meta']['keywords'] = $post[0]['myTag'].' - '.$page['meta']['keywords'];

		$page['meta']['canonical'] = url('posts/'.$post[0]['post_id'].url('/'.$post[0]['post_name'], 1));
		
		$d->query("UPDATE `#__posts` SET `post_hits`=`post_hits`+1 WHERE `post_id`='".$post[0]['post_id']."' AND `post_approve`='1' LIMIT 1");
		$post[0]['post_hits']++;

		$cache['posts-fields'] = func_posts_fields($post[0]['post_id'], 'p');
		
		func_posts_theme($post[0], true);
	
		if($post[0]['post_comment'] == 1)
		{
			require_once(engine_dir.'comments.class.php');
			$comments = new comments('post', $post[0]['post_id'], url('posts/'.$post[0]['post_id'].url('/'.$post[0]['post_name'], 1)));
			$comments->build('func_posts_comments');
		}
	}

	unset($post, $query, $id, $com, $comments);
}

function func_posts_pdf()
{
	global $d, $page, $options;

	$id = get_param($_GET, 'c', 0);
	$query = func_posts_query("AND posts.post_id='".intval($id)."'", 'LIMIT 1');
	$post = $d->fetch($query, 'assoc', true);

	if(!is_array($post) || !count($post))
	{
		module_error_run('404');
	}
	else
	{
		header('Content-type: text/html; charset='.charset);
		require_once(engine_dir.'PDF/PDF.php');

		$author = empty($post['member_alias'])? $post['post_author'] : $post['member_alias'];
		$content  = '<h3>'.$post['post_title'].'</h3>';
		$content .= str_replace('src="'.url, 'src="', $post['post_text']).'<br />';
		$content .= str_replace('src="'.url, 'src="', $post['post_more']).'<br /><hr />';
		$content .= 'نویسنده: '.$author.'، ';
		$content .= 'تاریخ ارسال: '.jdate("l j F Y ساعت h:i A", $post['post_date']).' ';

		// set document information
		$pdf->SetHeaderData('', '', $options['title'], $options['slogan']);
		$pdf->SetCreator(PDF_CREATOR);
		$pdf->SetAuthor($author);
		$pdf->SetTitle($post['post_title']);
		// set font
		$pdf->SetFont('dejavusans', '', 11);
		// add a page
		$pdf->AddPage();
		$pdf->WriteHTML($content, true, 0, true, 0);
		// ---------------------------------------------------------
		//Close and output PDF document
		$pdf->Output('post-'.$post['post_id'].'.pdf', 'I');
		die;
	}

	unset($post, $query, $id, $com, $comments);
}

function func_posts_theme($post, $single = false)
{
	global $tpl, $options, $cache;
	if(!$single)
	{
		$post['post_more'] = trim(filter($post['post_more'], 'safe'));
		$post['post_more'] = empty($post['post_more'])? false : true;
	}

	$categories = null;
	$post['myCategory'] = explode(',', $post['myCategory']);
	$post['slugCategory'] = explode(',', $post['slugCategory']);
	$post['post_categories'] = explode(',', $post['post_categories']);
	for($i=0; $i<count($post['myCategory']); $i++)
	{
		if(empty($post['myCategory'][$i]) || empty($post['slugCategory'][$i]) || empty($post['post_categories'][$i])) continue;
		$categories .= '<a href="'.url('posts/category/'.$post['post_categories'][$i].url('/'.$post['slugCategory'][$i], 1)).'">'.$post['myCategory'][$i].'</a> ,';
	}
	$categories = trim($categories, ' ,');
	
	$tags = null;
	$post['myTag'] = explode(',', $post['myTag']);
	$post['slugTag'] = explode(',', $post['slugTag']);
	for($i=0; $i<count($post['myTag']); $i++)
	{
		if(empty($post['slugTag'][$i]) || empty($post['myTag'][$i])) continue;
		$tags .= '<a href="'.url('posts/tag/'.$post['slugTag'][$i]).'">'.$post['myTag'][$i].'</a> ,';
	}
	$tags = trim($tags, ' ,');

	$itpl = new template('post.tpl', $tpl->base_dir, true);
	$array = array(
		'{url}' => url('posts/'.$post['post_id'].url('/'.$post['post_name'], 1)),
		'{pdf}' => url('posts/pdf/'.$post['post_id']),
		'{id}' => $post['post_id'],
		'{title}' => $post['post_title'],
		'{author}' => empty($post['member_alias'])? $post['post_author'] : $post['member_alias'],
		'{author-profile}' => url('account/profile/'.$post['post_author']),
		'{author-url}' => url('posts/author/'.$post['post_author']),
		'{image}' => empty($post['post_image'])? null : $post['post_image'],
		'{text1}' => replace_links($post['post_text']),
		'{text2}' => null,
		'{hits}' => $post['post_hits'],
		'{categories}' => !empty($categories)? $categories : 'بدون موضوع',
		'{tags}' => !empty($tags)? $tags : 'بدون برچسب',
		'{comment-count}' => $post['post_comment_count'],
		'{language}' => $post['post_language'],
	);
	
	if($post['post_image'])
	{
		$itpl->assign(array(
			'[image]' => null,
			'[/image]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[image\\](.*?)\\[/image\\]#s', '');
	}
	
	if(!empty($categories))
	{
		$itpl->assign(array(
			'[categories]' => null,
			'[/categories]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[categories\\](.*?)\\[/categories\\]#s', '');
	}
	
	if(!empty($tags))
	{
		$itpl->assign(array(
			'[tags]' => null,
			'[/tags]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[tags\\](.*?)\\[/tags\\]#s', '');
	}
	
	if($post['post_comment']==1)
	{
		$itpl->assign(array(
			'[comment]' => null,
			'[/comment]' => null,
		));
	}
	else
	{
		$itpl->block('#\\[comment\\](.*?)\\[/comment\\]#s', '');
	}
	
	if(($post['post_view']==2 && !member) || ($post['post_view']==3 && member) || ($post['post_view']==4 && !group_admin) || ($post['post_view']==5 && !group_super_admin))
	{
		$itpl->assign(array(
			'[not-view]' => null,
			'[/not-view]' => null,
		));
		$itpl->block('#\\[view\\](.*?)\\[/view\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[view]' => null,
			'[/view]' => null,
		));
		$itpl->block('#\\[not-view\\](.*?)\\[/not-view\\]#s', '');
	}
	
	if($single)
	{
		$itpl->assign(array(
			'[single]' => null,
			'[/single]' => null,
		));
		$itpl->block('#\\[not-single\\](.*?)\\[/not-single\\]#s', '');
		
		if($post['post_view']==2 && !member) $array['{text2}'] = message('این بخش فقط برای اعضا نمایش داده می شود!', 'error');
		elseif($post['post_view']==3 && member) $array['{text2}'] = message('این بخش فقط برای کاربران مهمان نمایش داده می شود!', 'error');
		elseif($post['post_view']==4 && !group_admin) $array['{text2}'] = message('این بخش فقط برای مدیران سایت نمایش داده می شود!', 'error');
		elseif($post['post_view']==5 && !group_super_admin) $array['{text2}'] = message('این بخش فقط برای مدیر کل سایت نمایش داده می شود!', 'error');
		else
		{
			$array['{text2}'] = replace_links($post['post_more']);
		}
		
		$itpl->assign(array(
			'[text2]' => null,
			'[/text2]' => null,
		));
		$itpl->block('#\\[more\\](.*?)\\[/more\\]#s', '');
	}
	else
	{
		if($post['post_more'])
		{
			$itpl->assign(array(
				'[more]' => null,
				'[/more]' => null,
			));
		}
		else
		{
			$itpl->block('#\\[more\\](.*?)\\[/more\\]#s', '');
		}
		
		$itpl->assign(array(
			'[not-single]' => null,
			'[/not-single]' => null,
		));
		
		$itpl->block('#\\[single\\](.*?)\\[/single\\]#s', '');
		$itpl->block('#\\[text2\\](.*?)\\[/text2\\]#s', '');
	}

	$opp = posts_options();
	$opp['fields'] = explode("\n", $opp['fields']);
	$opp['fields'] = filter($opp['fields'], 'en-num');
	$opp['fields'] = array_map('trim', $opp['fields']);
	foreach($opp['fields'] as $f)
	{
		if(!empty($f))
		{
			$array['{field-'.$f.'}'] = isset($cache['posts-fields'][$post['post_id']][$f])? $cache['posts-fields'][$post['post_id']][$f] : false;

			if(!empty($array['{field-'.$f.'}']))
			{
				$itpl->assign(array(
					'[field-'.$f.']' => null,
					'[/field-'.$f.']' => null,
				));
				$itpl->block('#\\[not-field-'.$f.'\\](.*?)\\[/not-field-'.$f.'\\]#s', '');
			}
			else
			{
				$itpl->assign(array(
					'[not-field-'.$f.']' => null,
					'[/not-field-'.$f.']' => null,
				));
				$itpl->block('#\\[field-'.$f.'\\](.*?)\\[/field-'.$f.'\\]#s', '');
			}
		}
	}

	$itpl->assign($array);
	$itpl->block('|{date format=[\'"](.+?)[\'"]}|es', 'jdate("\\1", "'.$post['post_date'].'")');
	$tpl->assign('{content}', $itpl->get_var(), 'add');

	unset($categories, $tags, $single, $post, $array, $itpl, $opp, $fields);
}

function func_posts_fields($links, $type = 'p')
{
	$opp = posts_options();
	$opp['fields'] = explode("\n", $opp['fields']);
	$opp['fields'] = filter($opp['fields'], 'en-num');
	$opp['fields'] = array_map('trim', $opp['fields']);

	if(!is_array($opp['fields']) || !count($opp['fields']))
	{
		return false;
	}
	unset($opp);
	
	$string = null;
	$type = filter($type, 'en-num');
	$links = explode(',', $links);
	$links = array_map('intval', $links);
	
	foreach($links as $l)
	{
		if(empty($l)) continue;
		$string .= "`field_link`='".$l."' OR ";
	}
	$string = trim($string, ' OR ');
	
	if(empty($string) || empty($type))
	{
		return false;
	}
	else
	{
		global $d;
		$data = array();
		$d->query("SELECT * FROM `#__fields` WHERE `field_type`='".$type."' AND (".$string.") ORDER BY field_link DESC");
		while($fdata = $d->fetch())
		{
			$data[$fdata['field_link']][$fdata['field_name']] = $fdata['field_value'];
		};
		unset($string, $links, $fdata);
		return $data;
	}
}
	
function func_posts_comments($type, $info)
{
	if($type == 'check')
	{
		return null;
	}
	elseif($type == 'success')
	{
		if(!isset($info['comment_link']) || $info['comment_link']<=0 || !is_numeric($info['comment_link'])) return false;
		global $d;
		$d->query("UPDATE `#__posts` SET `post_comment_count`=`post_comment_count`+1 WHERE `post_id`='".$info['comment_link']."' AND `post_approve`='1' LIMIT 1");
	}
	unset($info);
}

?>