<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function module_simple_links_info()
{
	return array(
		'name' => 'simple_links',
		'version' => '1.0',
		'creationDate' => '2012-07-21 18:00:03',
		'description' => 'ماژول پیوندهای پارس نیوک.',
		'author' => 'iman moodi',
		'authorEmail' => 'imanmoodi@yahoo.com',
		'authorUrl' => 'http://parsnuke.com',
		'license' => 'GNU/GPL',
	);
}

function module_simple_links_install()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->query("
		CREATE TABLE IF NOT EXISTS `#__simple_links` (
		  `link_id` int(255) NOT NULL auto_increment,
		  `link_title` varchar(100) NOT NULL,
		  `link_description` varchar(400) NOT NULL,
		  `link_href` varchar(600) NOT NULL,
		  `link_target` varchar(10) NOT NULL,
		  `link_direct_link` int(1) NOT NULL default '1',
		  `link_color` varchar(100) NOT NULL default '',
		  `link_bold` int(1) NOT NULL default '0',
		  `link_strikethrough` int(1) NOT NULL default '0',
		  `link_active` int(1) NOT NULL default '1',
		  `link_language` varchar(100) NOT NULL default 'persian',
		  PRIMARY KEY  (`link_id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
	");
	$d->insert('modules', array(
		'module_name' => 'simple-links',
		'module_version' => '1.0',
		'module_status' => '0',
	));
	echo message('ماژول پیوندها با موفقیت نصب شد.', 'success');
}

function module_simple_links_uninstall()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->query("DROP TABLE `#__simple_links`");
	$d->delete('modules', "module_name='simple-links'", 1);
	$d->delete('admin', "admin_rights='simple-links'", 1);
	echo message('ماژول پیوندها با موفقیت حذف شد.', 'success');
	remove_cache('simple-links');
}

function module_simple_links_active()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->update('modules', array('module_status'=>1), "module_name='simple-links'", 1);
	$d->insert('admin', array(
		'admin_rights' => 'simple-links',
		'admin_image' => 'engine/images/admin/posts.png',
		'admin_title' => 'پیوندها',
		'admin_link' => '?a={admin-page}&b=mod&c=simple-links',
		'admin_page' => '2',
	));
	echo message('ماژول پیوندها فعال شد.', 'success');
}

function module_simple_links_inactive()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->update('modules', array('module_status'=>0), "module_name='simple-links'", 1);
	$d->delete('admin', "admin_rights='simple-links'", 1);
	echo message('ماژول پیوندها غیرفعال شد.', 'success');
}

function module_simple_links_admin()
{
	group_admin==1 or die('Warning access!');
	member::check_admin_page_access('simple-links') or die('Warning access!');

	global $tpl, $d, $options, $cache;
	require(root_dir.'modules/simple-links/functions.admin.php');
	$_GET['do'] = get_param($_GET, 'do');

	switch($_GET['do'])
	{
		case 'list';
		func_admin_simple_links_list();
		break;

		case 'active';
		func_admin_simple_links_active();
		break;
		
		case 'delete';
		func_admin_simple_links_delete();
		break;
		
		case 'new';
		func_admin_simple_links_new();
		break;
		
		case 'edit';
		func_admin_simple_links_edit();
		break;
		
		default:
		func_admin_simple_links();
		break;
	}
}

?>