<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function module_sitemap_run()
{
	global $modules;
	require_once(engine_dir.'sitemap/sitemap.class.php');
	$sitemap = new sitemap();
	$sitemap->baseDir = url;
	$sitemap->cache = caching;
	$sitemap->cacheLife = 14400;
	$sitemap->cacheFile = engine_dir.'cache/sitemap.cache';

	if(!$sitemap->is_cache())
	{
		$sitemap->addItem(null, time(), 'always', '1.0');

		foreach($modules as $mod)
		{
			if(is_module($mod['module_name']) && function_exists('module_'.str_replace('-', '_', $mod['module_name']).'_sitemap'))
			{
				$func = 'module_'.str_replace('-', '_', $mod['module_name']).'_sitemap';
				$func($sitemap);
			}
		}
		unset($mod, $func);
	}

	$sitemap->display();
}

?>