<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function module_voting_info()
{
	return array(
		'name' => 'voting',
		'version' => '1.0',
		'creationDate' => '2012-07-21 18:00:03',
		'description' => 'ماژول نظرسنجی حرفه ای برای پارس نیوک.',
		'author' => 'iman moodi',
		'authorEmail' => 'imanmoodi@yahoo.com',
		'authorUrl' => 'http://parsnuke.com',
		'license' => 'GNU/GPL',
	);
}

function module_voting_install()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->query("
		CREATE TABLE IF NOT EXISTS `#__voting` (
		  `vote_id` int(11) NOT NULL auto_increment,
		  `vote_title` varchar(255) NOT NULL default '',
		  `vote_case` text NOT NULL,
		  `vote_ip` text,
		  `vote_members` text,
		  `vote_date` varchar(20) NOT NULL,
		  `vote_result` text,
		  `vote_button` varchar(200) NOT NULL default 'Submit',
		  `vote_status` int(1) NOT NULL default '0',
		  `vote_language` varchar(25) default NULL,
		  PRIMARY KEY  (`vote_id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
	");
	$d->insert('modules', array(
		'module_name' => 'voting',
		'module_version' => '1.0',
		'module_status' => '0',
	));
	echo message('ماژول نظرسنجی با موفقیت نصب شد.', 'success');
}

function module_voting_uninstall()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->query("DROP TABLE `#__voting`");
	$d->delete('modules', "module_name='voting'", 1);
	$d->delete('admin', "admin_rights='voting'", 1);
	echo message('ماژول نظرسنجی با موفقیت حذف شد.', 'success');
	remove_cache('module-voting', true);
}

function module_voting_active()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->update('modules', array('module_status'=>1), "module_name='voting'", 1);

	$d->insert('admin', array(
		'admin_rights' => 'voting',
		'admin_image' => 'engine/images/admin/obmen.png',
		'admin_title' => 'نظرسنجی',
		'admin_link' => '?a={admin-page}&b=mod&c=voting',
		'admin_page' => '2',
	));
	echo message('ماژول نظرسنجی فعال شد.', 'success');
}

function module_voting_inactive()
{
	member::check_admin_page_access('modules') or die('Warning access!');
	global $d;
	$d->update('modules', array('module_status'=>0), "module_name='voting'", 1);
	$d->delete('admin', "admin_rights='voting'", 1);
	echo message('ماژول نظرسنجی غیرفعال شد.', 'success');
}

function module_voting_admin()
{
	group_admin==1 or die('Warning access!');
	member::check_admin_page_access('voting') or die('Warning access!');

	global $tpl, $d, $options, $cache;
	require(root_dir.'modules/voting/functions.admin.php');
	$_GET['do'] = get_param($_GET, 'do');

	switch($_GET['do'])
	{
		case 'list';
		func_admin_voting_list();
		break;

		case 'status';
		func_admin_voting_status();
		break;
		
		case 'delete';
		func_admin_voting_delete();
		break;
		
		case 'new';
		func_admin_voting_new();
		break;
		
		case 'edit';
		func_admin_voting_edit();
		break;
		
		default:
		func_admin_voting();
		break;
	}
}

?>