<?php
/**
 * @In the name of God!
 * @author: Iman Moodi (Iman92)
 * @email: info@parsnuke.com
 * @link: http://www.parsnuke.com
 * @license: http://www.gnu.org/licenses/
 * @copyright: Copyright (C) 2012 ParsNuke.com. All rights reserved.
 * @ParsNuke CMS is a Free Software
 */

defined('security') or die('Direct Access to this location is not allowed.');

function module_voting_run()
{
	global $tpl, $page, $d, $options;

	$_GET['b'] = get_param($_GET, 'b');
	switch($_GET['b'])
	{
		case 'save':
		func_module_voting_save();
		break;
		
		case 'result':
		func_module_voting_result();
		break;
		
		default:
		func_module_voting_index();
		break;
	}
}

function module_voting_sitemap(&$sitemap)
{
	$sitemap->addItem(url('voting'), 0, 'monthly', '0.6');
}

function block_voting($op = null, $id = null, $position= null)
{
	if($op=='remove-cache') // admin
	{
		return true;
	}
	
	$op['id'] = !isset($op['id']) || intval($op['id'])<=0? 0 : intval($op['id']);

	global $d;
	$d->query("SELECT * FROM #__voting WHERE `vote_status`='1'".($op['id']? " AND vote_id = '".$op['id']."'" : null)." ORDER BY vote_id DESC LIMIT 1");
	$row = $d->fetch();
	
	if(is_array($row) || !count($row))
	{
		$ip = explode(',', $row['vote_ip']);
		$members = explode(',', $row['vote_members']);

		if(isset($_COOKIE['vote-'.$row['vote_id']]) || in_array(get_ip(), $ip) || (member && in_array(member_name, $members)))
			$form = false;
		else
			$form = true;

		$html = func_module_voting_show($row, $form, false, null, $row['vote_id'].rand(88,888));
	}
	else
	{
		$html = 'رای گیری یافت نشد!';
	}

	return $html;
}

function func_module_voting_index()
{
	global $d, $page;

	$d->query("SELECT * FROM #__voting WHERE `vote_status`='1' ORDER BY vote_id DESC");
	if($d->numRows() >= 1)
	{
		$html = '<ul id="parsnuke-voting-list">'.n;
		while($row = $d->fetch())
		{
			$html .= '<li><a href="'.url('voting/result/'.$row['vote_id']).'" title="ساخته شده در '.jdate("l j F Y ساعت h:i A", $row['vote_date']).'">'.$row['vote_title'].'</a></li>'.n;
		}
		$html .= '</ul>';
	}
	else
	{
		$html = message('هیچ نظرسنجی در سیستم یافت نشد!', 'error');
	}
	
	$page['title'] .= ' &bull; نظرسنجی ها';
	$page['meta']['description'] = 'نظرسنجی ها -'.$page['meta']['description'];
	$page['meta']['canonical'] = url('voting');
	set_content('نظرسنجی ها', $html);
}

function func_module_voting_result()
{
	$id = get_param($_GET, 'c', 0);
	$key = get_param($_GET, 'key', 'result');
	$key = filter($key, 'safe');
	$vote = get_param($_GET, 'vote', 0);
		
	global $d;
	$d->query("SELECT * FROM #__voting WHERE `vote_status`='1' AND vote_id = '".$id."' ORDER BY vote_id DESC LIMIT 1");

	if($d->numRows() >= 1)
	{
		$row = $d->fetch();
		$msg = null;
		
		$ip = explode(',', $row['vote_ip']);
		$members = explode(',', $row['vote_members']);
		if(isset($_COOKIE['vote-'.$row['vote_id']]) || in_array(get_ip(), $ip) || (member && in_array(member_name, $members)))
			$form = false;
		else
			$form = true;
			
		if(!$form && $vote)
		{
			$msg = '<font color="red">قبلا رای داده اید!!</font><br>';
			$vote = 0;
		}

		$html = func_module_voting_show($row, $vote? true : false, true, $msg, $key);
		
		if(is_ajax())
			die($html);
		{
			global $page;
			$page['title'] .= ' &bull; نتایج نظرسنجی';
			$page['meta']['description'] = 'نتایج نظرسنجی - '.$row['vote_title'].' -'.$page['meta']['description'];
			$page['meta']['canonical'] = url('voting/result/'.$row['vote_id']);
			set_content('نتایج نظرسنجی', $html);
		}
	}
	else
	{
		module_error_run('404');
	}
}

function func_module_voting_show($row, $form = false, $showPercent = false, $message = null, $key = 92)
{
	global $tpl, $page, $d, $options;

	$key = filter($key, 'en-num');
	$key = substr($key, 0, 5);
	$row['vote_case'] = trim($row['vote_case'], '|');
	$row['vote_case'] = explode('|', $row['vote_case']);
	$row['vote_result'] = explode(',', $row['vote_result']);
	$totalItemp = count($row['vote_case']);
	$totalCount = array_sum($row['vote_result']);

	$itpl = new template('modules/voting/html/block.tpl');

	$progress = 1;
	for ($i=1; $i<=$totalItemp; $i++)
	{
		$count = isset($row['vote_result'][$i-1]) && isset($row['vote_result'][$i-1])>0? intval($row['vote_result'][$i-1]) : 0;
		$percent = $count * 100;

		if($totalCount!=0)
			$percent /= $totalCount;
		else
			$percent = 0;

		$percent = floor($percent);
		$percent = $percent>100? 100 : $percent;
	
		$itpl->add_for('vote', array(
			'{name}' => $row['vote_case'][$i-1],
			'{progress}' => $progress,
			'{percent}' => $percent,
			'{count}' => $count,
			'replace' => array(
				'#\\[showPercent\\](.*?)\\[/showPercent\\]#s' => $showPercent? '\\1' : '',
				'#\\[not-showPercent\\](.*?)\\[/not-showPercent\\]#s' => !$showPercent? '\\1' : ''
			),
		));
		
		$progress++;
		if($progress>5) $progress = 1;
	};
	
	$itpl->assign(array(
		'{id}' => $row['vote_id'],
		'{key}' => md5($key.$row['vote_id']),
		'{key1}' => $key,
		'{total}' => $totalCount,
		'{title}' => $row['vote_title'],
		'{button}' => $row['vote_button'],
		'{message}' => $message,
	));

	if($form)
	{
		$itpl->assign(array(
			'[form]' => null,
			'[/form]' => null,
		));
		$itpl->block('#\\[not-form\\](.*?)\\[/not-form\\]#s', '');
	}
	else
	{
		$itpl->assign(array(
			'[not-form]' => null,
			'[/not-form]' => null,
		));
		$itpl->block('#\\[form\\](.*?)\\[/form\\]#s', '');
	}

	return $itpl->get_var();
}

function func_module_voting_save()
{
	$message = null;
	$showPercent = false;
	$id = get_param($_POST, 'id', 0);
	$vote = get_param($_POST, 'vote');
	$vote = filter($vote, 'safe');
	$key = get_param($_GET, 'key');
	$key = filter($key, 'safe');
		
	global $d;
	$d->query("SELECT * FROM #__voting WHERE `vote_status`='1' AND vote_id = '".$id."' ORDER BY vote_id DESC LIMIT 1");

	if($d->numRows() >= 1)
	{
		$row = $d->fetch();
		$ip = explode(',', $row['vote_ip']);
		$members = explode(',', $row['vote_members']);

		if(isset($_COOKIE['vote-'.$row['vote_id']]) || in_array(get_ip(), $ip) || (member && in_array(member_name, $members)))
			$form = false;
		else
			$form = true;
		
		if($form)
		{
			if(empty($vote))
			{
				$message = '<font color="red">گزینه انتخابی معتبر نیست!</font><br>';
			}
			else
			{
				$row['vote_case'] = trim($row['vote_case'], '|');
				$case = explode('|', $row['vote_case']);
				$result = explode(',', $row['vote_result']);
				$totalItemp = count($case);
				$index = array_search($vote, $case);
				for ($i=0; $i<=$totalItemp; $i++)
				{
					$result[$i] = !isset($result[$i]) || intval($result[$i])<=0? 0 : intval($result[$i]);
					if($i==$index)
					{
						$result[$i]++;
						$result_add = true;
					}
				}
				
				if(!isset($result_add))
				{
					$message = '<font color="red">گزینه ارسالی معتبر نیست!</font><br>';
				}
				else
				{
					$row['vote_result'] = implode(',', $result);

					if(!in_array(get_ip(), $ip))
					{
						array_push($ip, get_ip());
					}
					$row['vote_ip'] = implode(',', $ip);
					
					if(member && !in_array(member_name, $members))
					{
						array_push($members, member_name);
					}
					$row['vote_members'] = implode(',', $members);

					$d->update('voting', array(
						'vote_result' => $row['vote_result'],
						'vote_ip' => trim($row['vote_ip'], ','),
						'vote_members' => trim($row['vote_members'], ','),
					), "vote_id='".$id."'", 1);
					set_cookie('vote-'.$row['vote_id'], md5($row['vote_id']));
					$form = false;
					$showPercent = true;
				}
			}
		}
		
		$html = func_module_voting_show($row, $form, $showPercent, $message, $key);
	}
	else
	{
		$html = 'رای گیری یافت نشد!';
	}

	die($html);
}

?>